/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__APP_PTHREAD_H__
#define	__APP_PTHREAD_H__    1


#define thdMSG_CloseProcess	1
#define thdMSG_Create		2
#define thdMSG_Free		3
#define thdMSG_Init		4
#define thdMSG_Open		5
#define thdMSG_Close		6
#define thdMSG_Start		7
#define thdMSG_Stop		8
#define thdMSG_Err		9
#define thdMSG_Setup_Data	10
#define thdMSG_Status		11
#define thdMSG_EOF		12

#define thdMSG_XCopy		32
#define thdMSG_XCopy_RunStat	33

#define thdMSG_USER		1000

#define thdMSG_Mask		0x00ffffff
#define thdMSG_rv		0x01000000
#define thdMSG_rv_mmMSG_free	0x03000000
#define thdMSG_NoSyncEv		0x04000000

#ifdef _OS_WIN32

#define AlgTpthd_msg    int wtyp; \
  int size;		/* sizeof(TThread_MSG),.	*/ \
  int bef;		/* 1=Create, 2=Free,....	*/ \
  int wtyp_obj;		/* wtyp_Tv4l_IO,.....       */ \
  void *obj; \
  int tag; \
  int org_msg; \
  int ret; \
  struct Tpthd_msg *ret_msg;

typedef struct Tpthd_msg {
  AlgTpthd_msg
} Tpthd_msg;

#define AlgTpthd_msgData int data_lg; \
  int data_typ;

typedef struct {
  AlgTpthd_msgData
  char data[];
} Tpthd_msgData;

#else /* _OS_WIN32 */

#include <pthread.h>
#include <setjmp.h>


//*********************** PThread msg *********************************
#define AlgTpthd_msg    int wtyp; \
  int size;		/* sizeof(TThread_MSG),.	*/ \
  int bef;		/* CloseProcess,Create,....	*/ \
  int wtyp_obj;		/* wtyp_Tv4l_IO,.....       */ \
  void *obj; \
  int tag; \
  int org_msg; \
  int ret; \
  struct Tpthd_msg *ret_msg;

typedef struct Tpthd_msg {
  AlgTpthd_msg
} Tpthd_msg;

typedef struct Tpthd_msg_t {
  AlgTpthd_msg
  byte t[];
} Tpthd_msg_t;

typedef union {
	char c[16];
	byte b[16];
	short i16[8];
	int i[4];
	float f[4];
	int64 i64[2];
	double f64[2];
	} TuMSG16B;

typedef union {
	char c[32];
	byte b[32];
	short i16[16];
	int i[8];
	float f[8];
	int64 i64[4];
	double f64[4];
	} TuMSG32B;

typedef union {
	char c[64];
	byte b[64];
	short i16[32];
	int i[16];
	float f[16];
	int64 i64[8];
	double f64[8];
	} TuMSG64B;

typedef struct Tpthd_msg16B {
  AlgTpthd_msg
  TuMSG16B t;
} Tpthd_msg16B;

typedef struct Tpthd_msg32B {
  AlgTpthd_msg
  TuMSG32B t;
} Tpthd_msg32B;

typedef struct Tpthd_msg64B {
  AlgTpthd_msg
  TuMSG64B t;
} Tpthd_msg64B;

#define AlgTpthd_msgData int data_lg; \
  int data_typ;

typedef struct {
  AlgTpthd_msgData
  char data[];
} Tpthd_msgData;

typedef struct Tpthd_msgStr {
  AlgTpthd_msg
  int data_lg;
  int data_typ;   //0=String 1=Byte
  char data[];
} Tpthd_msgStr;

typedef struct Tpthd_msg16BStr {
  AlgTpthd_msg
  TuMSG16B t;
  int str_size;
  int data_typ;   //0=String
  char data[];
} Tpthd_msg16BStr;



//*********************** PThread *************************************
#define Tpthd_NoMSG		1
#define Tpthd_select_t0_single	(1<<1)
#define Tpthd_TimerSync		(1<<24)
#define Tpthd_TimerSyncRun	(1<<25)

typedef int (*Tpthd_OnMSG)(Tpthd_msg *msg);

typedef struct Tpthd {
  AlgTTC0
  struct Tpthd *next;	//DO NOT edit this !!!!
  dword fu;
  int wtyp_obj;
  void *obj;
  int (*DoExecute)(struct Tpthd *pthd);
  int w_fd;
  Tpthd_msg *w_msg;
  struct Tpthd_MSG_Obj *app2pthd;
  struct Tpthd_MSG_Obj *pthd2app;
  pthread_t pthd_id;
  jmp_buf ptAbort;
  int app_pid;
  bool run;		//is Tpthd_Execute
  bool sleep;		//user set (Tpthd_Execute)
  bool MsgToApp;
  bool stop;
  dword lastTimerSync;
  fd_set fdset_in;
//  pthread_mutex_t mutex;
  int ret;
  struct Tpthread_mmMSG *ret_mmMSG;
  char tt[32];
} Tpthd;

typedef struct Tpthd_arr {
  Tpthd *pthd;

  struct sigaction action, old_action;
  sigset_t block_mask;

} Tpthd_arr;

extern Tpthd *Tpthd_Create(int fu, int wtyp_obj, void *obj, Tpthd_OnMSG OnMSG);
//void Tpthd_Free(Tpthd *pthd);
extern bool Tpthd_Start(Tpthd *pthd);
extern void Tpthd_Stop(Tpthd *pthd);
extern void Tpthd_Sync(Tpthd *pthd);  // send SIGNAL to thread

extern int pt_send_M(Tpthd *pthd, int bef);
extern int pt_send_Mt(Tpthd *pthd, int bef, int tag);
//void pt_send_MData(Tpthd *pthd, int msg, Tpthd_msgData *msgData);
extern int pt_send_Data(Tpthd *pthd, int msg, void *data, int lg);

extern void pt_send_M16B(Tpthd *pthd, int msg, TuMSG16B *M16B);
extern void pt_send_M32B(Tpthd *pthd, int msg, TuMSG32B *M32B);
extern void pt_send_M64B(Tpthd *pthd, int msg, TuMSG64B *M64B);
extern void pt_send_M_v3(Tpthd *pthd, int msg, int tag, int org_msg);
extern void pt_send_M16B_v3(Tpthd *pthd, int msg, int tag, int org_msg, TuMSG16B *M16B);
extern void pt_send_M32B_v3(Tpthd *pthd, int msg, int tag, int org_msg, TuMSG32B *M32B);
extern void pt_send_M64B_v3(Tpthd *pthd, int msg, int tag, int org_msg, TuMSG64B *M64B);

extern void pt_send_Mstr(Tpthd *pthd, int msg, char *s);
extern void pt_send_Merr(Tpthd *pthd, int msg_typ, char *msg, ...);

#define pthdWait_TimeOut	0
#define pthdWait_msg		1
#define pthdWait_fd		2

//int Tpthd_Wait(Tpthd *pthd, dword TimeOut_us);
extern int Tpthd_Wait_fd(Tpthd *pthd, int fd, dword TimeOut_us);
#define Tpthd_Wait(a, b) Tpthd_Wait_fd(a, 0, b)

extern bool pthd_SetMSG_obj(Tpthd *pthd, int wtyp_obj, void *obj);

#endif /* ! _OS_WIN32 */

#endif /* __APP_PTHREAD_H__ */
