/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

#if appChacheSIZE > 0
typedef struct {
  Tapph *ap;
  Window win;
} TapphChache;

#if appChacheSIZE == 1
static TapphChache apphChache;
#else
static TapphChache apphChache[appChacheSIZE];
#endif
#endif

/*____________________________________________________________________________*/
/* Id = 0x00100000 - 0xfff00000 (max 4095 ID's) */
dword GetNewForm_ID() {
  int i, x, m;
  dword lw;
  dword *FormIDs = IappXDat.FormIDs;

	m = (IappXDat.lfnFormID + 1) & 0xfff;
	if (!m) m++;
	IappXDat.lfnFormID = m;
	i = m >> 5;
	lw = 1 << (m & 0x1f);
	if (!(FormIDs[i] & lw)) {
	    FormIDs[i] |= lw;
	    return m << 20;
	}

//127 * 32 + 31 = 4095 = $fff
	m = 1; lw = 0x02;
	for (i=0;i<128;i++) {
	    if (FormIDs[i] != 0xffffffff) {
		for (x=m;x<32;x++) {
		    if (!(FormIDs[i] & lw)) {
			FormIDs[i] |= lw;
			return ((i << 5) + x) << 20;
		    }
		    lw += lw;	//shl 1
		}
	    }
	    m = 0; lw = 1;
	}
	return 0;
}

/*____________________________________________________________________________*/
Tapph *AddAppWin(Tapph *ap, TWins *ws) {
  Tapph *app;
  TapphRoot *appRoot;
  TWins *ParentForm;
  int i;

	ParentForm = ws;
	i = sizeof(Tapph);
	if (!ap) i = sizeof(TapphRoot);
	app = xcalloc(i);
	app->wtyp = wtyp_Tapph;

	if (ap) {
	    appRoot = (TapphRoot*)ap;
	    while (!(appRoot->aos & aosIsAppRoot)) {
		if (appRoot->prev) appRoot = appRoot->prev;
		else appRoot = appRoot->prev_child;
	    }
	    appRoot->lfnWinNr++;
	    if (ap->next_child) {
		ap = ap->next_child;
		while (ap->next) ap = ap->next;
		ap->next = app;
		app->prev = ap;
	    } else {
		ap->next_child = app;
		app->prev_child = ap;
	    }
	    app->ahID = appRoot->ahID | appRoot->lfnWinNr;
	    ParentForm = appRoot->wins;

	} else {
	    app->ahID = GetNewForm_ID();
	    app->aos = aosIsAppRoot;
	    ((TapphRoot*)app)->lfnWinNr++;	//=1
	    ap = IappXDat.apph;
	    if (ap) {
		while (ap->next) ap = ap->next;
		ap->next = app;
		app->prev = ap;
	    } else IappXDat.apph = app;
	}

	if (ws) {
	    app->wins = ws;
	    ws->apph = app;
	    ws->ParentForm = ParentForm;
	}

	return app;
}

/*____________________________________________________________________________*/
void DelAppWin(Tapph *ap) {
  int i;
  Tobjmsg msg;
  Tapph *apnc;

	msg.msg = msgDestroy;
	if (ap->next_child) {
	    apnc = ap->next_child;
	    while (apnc->next) {
		Send_MSG(&msg, apnc->next);
// if (apnc == apnc->next) {
// printf("DelAppWin: Error 0x%x\n", (int)apnc);
// exit(EXIT_FAILURE);
// }
	    }
	    Send_MSG(&msg, apnc);
	}

// printf("%s(%d) DelAppWin: win=%x ap=%x\n", FL, (int)ap->wins->WinID, (int)ap);
// printf(" DelAppWin: prev=%x prev_c=%x next=%x next_c=%x\n", (int)ap->prev, (int)ap->prev_child, (int)ap->next, (int)ap->next_child);
	if (ap->prev) {
	    ap->prev->next = ap->next;
	} else if (ap->prev_child) {
	    ap->prev_child->next_child = ap->next;
	}
	if (ap->next) {
	    ap->next->prev = ap->prev;
	    ap->next->prev_child = ap->prev_child;
	}
#if appChacheSIZE > 0
#if appChacheSIZE == 1
	if (apphChache.ap == ap) {
	    apphChache.ap = NULL;
	    apphChache.win = 0;
	}
#else
	for (i=0;i<apphChacheSIZE;i++) {
	    if (apphChache[i].ap == ap) {
		apphChache[i].ap = NULL;
		apphChache[i].win = 0;
		break;
	    }
	}
#endif
#endif
	for (i=0; i < IappXDat.PaintOnEvEnd_Count; i++) {
	    if (IappXDat.PaintOnEvEnd_List->val[i] == ap) IappXDat.PaintOnEvEnd_List->val[i] = 0;
	}
	ap->wtyp = 0;
	xfree(ap);
}

/*____________________________________________________________________________*/
#if appChacheSIZE > 0
#if appChacheSIZE == 1
void apphChache_CLR() {
	apphChache.ap = NULL;
	apphChache.win = 0;
}
#else
void apphChache_CLR() {
  int i;
	for (i=0;i<apphChacheSIZE;i++) {
	    apphChache[i].ap = NULL;
	    apphChache[i].win = 0;
	}
}
#endif
static Tapph *st_Find_Exec_WinsX_Ev(Tapph *ap, Window win) {
#else
Tapph *Find_Exec_WinsX_Ev(Tapph *ap, Window win) {
#endif
  Tapph *res;

	while (ap) {
	    if (ap->win == win) return ap;
	    if (ap->next_child) {
#if appChacheSIZE > 0
		res = st_Find_Exec_WinsX_Ev(ap->next_child, win);
#else
		res = Find_Exec_WinsX_Ev(ap->next_child, win);
#endif
		if (res) return res;
	    }
/* if (ap == ap->next) {
  printf("Find_Exec_WinsX_Ev: Error 0x%x\n", (int)ap);
  exit(EXIT_FAILURE);
 } */
	    ap = ap->next;
	}
	return NULL;
}

// int fxce_count = 0;
// int fxce_new_count = 0;


#if appChacheSIZE > 0
#if appChacheSIZE == 1
Tapph *Find_Exec_WinsX_Ev(Tapph *ap, Window win) {
  Tapph *res;

// fxce_count++;
	if ((apphChache.win == win) && apphChache.ap) return apphChache.ap;
// fxce_new_count++;
	res = st_Find_Exec_WinsX_Ev(ap, win);
	if (res) {
	    apphChache.win = win;
	    apphChache.ap = res;
	}
	return res;
}
#else
Tapph *Find_Exec_WinsX_Ev(Tapph *ap, Window win) {
  Window win2;
  Tapph *res;
  int i;
	for (i=0;i<apphChacheSIZE;i++) {
	    res = apphChache[i].ap;
	    if ((apphChache[i].win == win) && res) {
		if (i > 0) {
		    apphChache[i].win = apphChache[0].win;
		    apphChache[i].ap  = apphChache[0].ap;
		    apphChache[0].win = win;
		    apphChache[0].ap = res;
		}
		return res;
	    }
	}
	res = st_Find_Exec_WinsX_Ev(ap, win);
	if (res) {
	    for (i=apphChacheSIZE-1;i;i--) {
		    apphChache[i].win = apphChache[i-1].win;
		    apphChache[i].ap  = apphChache[i-1].ap;
	    }
	    apphChache[0].win = win;
	    apphChache[0].ap = res;
	}
	return res;
}
#endif
#endif

Tapph *Find_ahID(Tapph *ap, dword ahID) {
  Tapph *res;

	while (ap) {
	    if (ap->ahID == ahID) return ap;
	    if (ap->next_child) {
		res = Find_ahID(ap->next_child, ahID);
		if (res) return res;
	    }
	    ap = ap->next;
	}
	return NULL;
}

bool ChkTWinsExist(Tapph *ap, TWins *ws) {
	if (!ws) return False;
	while (ap) {
	    if (ap->wins == ws) return True;
	    if (ap->next_child) {
		if (ChkTWinsExist(ap->next_child, ws)) return True;
	    }
	    ap = ap->next;
	}
	return False;
}
