/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include <winsock.h>

extern TappDat *appDat;

OSVERSIONINFO WinVERSIONINFO;
TappXDat IappXDat;
TappXDat *appXDat = &IappXDat;

static HMODULE appInstance;

static Display dpy;
static dword appTimer_50ms;

static bool Terminate = False;

void CALLBACK appTimerProc_50ms(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime) {
	W32_app_Timer_50ms(dwTime);
}


#ifdef APP_INI_DAT
static char *DefaultIniDat[] = {
  "[Global]",
  "Font=-*-Arial-medium-r-*-*-13-*-*-*-*-*-*-1",
  "FontBold=-*-Arial-bold-r-*-*-13-*-*-*-*-*-*-1",
  "",
  "[Icon]",
  "",
  "[FileExt_Plugins]",
  ";(&e=exec) (&i=icon)  (&m=mime)",
  ";(@=file (&a=art 0=path+file 1=path; +Bit1=1 ohne RootPath))",
  "",
  "[FileExt_Buildin]",
  "",
  "[Dlg_File]",
  "Az0_ItemE_Dbl=True",
  "Az0_PathE_Dbl=False",
  "Az1_ItemE_Dbl=True",
  "Az1_PathE_Dbl=False",
  NULL};
#endif

#define g_width 2
#define g_height 2
static char g_bits[] = {0x02, 0x01};

void initXapp(int fu, int argc, char **argv) {
  word *pwc;

	initapp(fu, argc, argv);
//	Fill0(&WinVERSIONINFO, sizeof(OSVERSIONINFO));
	WinVERSIONINFO.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if (!GetVersionEx(&WinVERSIONINFO)) {
	    printf("%s(%d): ERROR: GetVersionEx()\n", FL);
	}
// printf("%s(%d): %lu.%lu %lu %lu %s\n", FL, WinVERSIONINFO.dwMajorVersion, WinVERSIONINFO.dwMinorVersion, WinVERSIONINFO.dwBuildNumber, WinVERSIONINFO.dwPlatformId, WinVERSIONINFO.szCSDVersion);

	InitEvCALLBACKJumpTable();

	set_ptr_arr(&IappXDat.PaintOnEvEnd_List, 254);
#if appChacheSIZE > 0
	apphChache_CLR();
#endif

	appDat->self_pid = GetCurrentThreadId();
// printf("ThreadId=%d\n", appDat->self_pid);

	MonitorsInit();

// printf("%d %d\n", IappXDat.Root_width, IappXDat.Root_height);

	appInstance = GetModuleHandle(0);
	pwc = xcalloc(4096*2);
	GetModuleFileNameW(appInstance, pwc, 4096);
	appDat->self_exe = pwctoUTF8(pwc);
	xfree(pwc);
	appDat->sHOME = GetFilePath(appDat->self_exe);
	appDat->ALDini_dir = pcadd(appDat->sHOME, ".ALDini");

	if ((fu & app_NoIni) == 0) {
	    if (!file_chk_exist(appDat->ALDini_dir, findDIR)) {
  char buf[MAX_PATH];
  buf[0] = 0;
  HKEY hk = 0;
  DWORD BufSize = MAX_PATH;
  DWORD ret_type = 0;
		if (!RegOpenKeyExA(HKEY_USERS, 
			".DEFAULT\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\User Shell Folders", 
			0, KEY_QUERY_VALUE, &hk)) {
//	  printf("%s(%d): hk=0x%x 0x%x\n", FL, (int)hk, (int)HKEY_USERS);

		    if (!RegQueryValueExA(hk, "AppData", NULL, &ret_type, buf, &BufSize)) {
//	  printf("%s(%d): 0x%x 0x%x\n", FL, (int)ret_type, (int)REG_EXPAND_SZ);
			if (ret_type == REG_EXPAND_SZ) {
			    char *tmp = pcdup(buf);
			    buf[0] = 0;
			    ExpandEnvironmentStringsA(tmp, buf, MAX_PATH);
			    xfree(tmp);
			}
//	  printf("%s(%d): Reg    =%s\n", FL, buf);
		    }
		    RegCloseKey(hk);
		    xfree(appDat->ALDini_dir);
		    appDat->ALDini_dir = pcadd(buf, "\\ALDccp");
		}
	    }
	    file_mkdir_erl(appDat->ALDini_dir, 0750, EMSG_ERR_EXIT);
	}

	appDat->inifile_global = pcadd(appDat->ALDini_dir, "\\global.ini");
#ifdef APP_INI_DAT
  int i;
  FILE *fd;
	if ((fu & app_NoIni) == 0) {
	  if (!file_chk_exist(appDat->inifile_global, F_OK)) {
	    fd = file_stream_open(appDat->inifile_global, "w");
	    if (!fd) {
		printf("ERROR: cant create default '%s'\n", appDat->inifile_global);
		exit(EXIT_FAILURE);
	    }
	    i = 0;
	    while (DefaultIniDat[i]) {
		fputs(DefaultIniDat[i], fd);
		fputs("\n", fd);
		i++;
	    }
	  fclose(fd);
	  }
	}
#endif

	appXDat->RootW = 0;
  HDC hdc = GetDC(0);
	appXDat->RootW_depth = GetDeviceCaps(hdc, BITSPIXEL);
	appXDat->LogPixel = GetDeviceCaps(hdc, LOGPIXELSY);
// printf("%s(%d): RootW_depth=%d\n", FL, appXDat->RootW_depth);
	if (appXDat->RootW_depth > 24) appXDat->RootW_depth = 24;

// printf("%d\n", GetDeviceCaps(hdc, BITSPIXEL));
	ReleaseDC(0, hdc);


	appTimer_50ms = SetTimer(0, 0, 50, appTimerProc_50ms);

/*
      SendMessage(appHandle, WM_SETICON, 1, LoadIcon((HINSTANCE) NULL, IDI_APPLICATION));
      SetClassLong(appHandle, GCL_HICON, LoadIcon((HINSTANCE) NULL, IDI_APPLICATION));
*/

	appDat->X11DispatchEvent = X11DispatchEvent;
	appDat->Wins_PaintOnEvEnd = Wins_PaintOnEvEnd;


	dpy.appDat = appDat;
	dpy.appXDat = &IappXDat;
	dpy.appInstance = appInstance;
//	dpy.lpfnWndProc = WindowProc;

	IappXDat.dpy = &dpy;

  long gcm;
  XGCValues gcv;
	Fill0(&gcv, sizeof(XGCValues));
	IappXDat.Default_Color = 0xc0c0c0;
	IappXDat.Paint_Color = 0xc0c0c0;
#ifdef USE_X11GC_plane_mask
	gcm = GCFunction | GCPlaneMask | GCGraphicsExposures | GCLineWidth;
	gcv.plane_mask = AllPlanes;
#else
	gcm = GCFunction | GCGraphicsExposures | GCLineWidth;
#endif
//	gcv.line_width = 0;
	gcv.function = GXcopy;
	gcv.fill_style = FillSolid;
//	gcv.graphics_exposures = 0;
	IappXDat.IconGC = CreateGC(gcm, &gcv);

	IappXDat.Default_GC = CreateGC_RGB(IappXDat.Default_Color);
	IappXDat.bordH_GC = CreateGC_RGB(0xe0e0e0);
	IappXDat.bordL_GC = CreateGC_RGB(0x808080);
	IappXDat.GC_FFFFFF = CreateGC_RGB(0xffffff);
	IappXDat.GC_C0C0C0 = CreateGC_RGB(0xc0c0c0);
	IappXDat.GC_404040 = CreateGC_RGB(0x404040);
	IappXDat.GC_000000 = CreateGC_RGB(0x000000);
	IappXDat.Paint_GC = CreateGC_RGB(IappXDat.Paint_Color);
	IappXDat.Select_GC_Back = CreateGC_RGB(0x00007f);

#ifdef USE_X11GC_plane_mask
	gcm = GCFunction | GCPlaneMask | GCGraphicsExposures | GCLineWidth |
	      GCForeground | GCFillStyle;
#else
	gcm = GCFunction | GCGraphicsExposures | GCLineWidth | GCForeground | GCFillStyle;
#endif
	gcv.function  = GXnand;
//	gcv.foreground = GetColor_RGB(0xffff80);
//	gcv.function  = GXorReverse;
	gcv.foreground = GetColor_RGB(0xffff80);
	IappXDat.Select_GC = CreateGC(gcm, &gcv);

	gcv.function = GXxor;
	IappXDat.Focus_bitmap = XCreateBitmapFromData_W32noDIB(IappXDat.dpy, IappXDat.RootW, g_bits, g_width, g_height);
	gcm |= GCStipple | GCSubwindowMode | GCBackground;
	gcv.line_width = 1;
	gcv.foreground = GetColor_RGB(0x000000);
	gcv.background = GetColor_RGB(0xc0c0c0);
	gcv.fill_style = FillOpaqueStippled;
	gcv.stipple = IappXDat.Focus_bitmap;
	gcv.subwindow_mode = IncludeInferiors;
	IappXDat.FocusLine_GC = CreateGC(gcm, &gcv);

	gcv.function = GXandInverted;
	IappXDat.GC_000000_Dot = CreateGC(gcm, &gcv);

	gcv.function = GXcopy;
	gcv.foreground = GetColor_RGB(0xffffff);
	IappXDat.SB_GC = CreateGC(gcm, &gcv);


	IappXDat.XCursors[XC_top_left_arrow] = LoadCursor(0, IDC_ARROW);
	IappXDat.XCursors[XC_xterm] = LoadCursor(0, IDC_IBEAM);

	IappXDat.XCursors[XC_top_side] = LoadCursor(0, IDC_SIZENS);
	IappXDat.XCursors[XC_bottom_side] = IappXDat.XCursors[XC_top_side];
	IappXDat.XCursors[XC_sb_v_double_arrow] = IappXDat.XCursors[XC_top_side];

	IappXDat.XCursors[XC_left_side] = LoadCursor(0, IDC_SIZEWE);
	IappXDat.XCursors[XC_right_side] = IappXDat.XCursors[XC_left_side];
	IappXDat.XCursors[XC_sb_h_double_arrow] = IappXDat.XCursors[XC_left_side];

	IappXDat.XCursors[XC_top_left_corner] = LoadCursor(0, IDC_SIZENWSE);
	IappXDat.XCursors[XC_bottom_right_corner] = IappXDat.XCursors[XC_top_left_corner];

	IappXDat.XCursors[XC_top_right_corner] = LoadCursor(0, IDC_SIZENESW);
	IappXDat.XCursors[XC_bottom_left_corner] = IappXDat.XCursors[XC_top_right_corner];

#ifdef APP_INI_DAT
  TpcIni *pcIni;
  char *pc;
	if ((fu & app_NoIni) == 0) {
	    pcIni = TpcIni_Create(appDat->inifile_global);
	    pc = TpcIni_RDstr(pcIni, "Global", "Font", NULL);
// printf("Default_Font=%s\n", pc);
	    IappXDat.Default_Font = MakeFont(pc, "-*-MS Sans Serif-medium-r-*-*-11-*-*-*-*-*-*-1", NULL);
	    IappXDat.Default_bold_Font = MakeFont(TpcIni_RDstr(pcIni, "Global", "FontBold", pc), pc, NULL);

	    Tfree(pcIni);
	} else {
	    IappXDat.Default_Font = MakeFont("-*-Arial-medium-r-*-*-13-*-*-*-*-*-*-1", 
					 "-*-MS Sans Serif-medium-r-*-*-11-*-*-*-*-*-*-1", NULL);
	    IappXDat.Default_bold_Font = MakeFont("-*-Arial-bold-r-*-*-13-*-*-*-*-*-*-1", 
					      "-*-MS Sans Serif-bold-r-*-*-11-*-*-*-*-*-*-1", NULL);
	}
#else

	IappXDat.Default_Font = MakeFont("-*-Arial-medium-r-*-*-13-*-*-*-*-*-*-1", 
					 "-*-MS Sans Serif-medium-r-*-*-11-*-*-*-*-*-*-1", NULL);
	IappXDat.Default_bold_Font = MakeFont("-*-Arial-bold-r-*-*-13-*-*-*-*-*-*-1", 
					      "-*-MS Sans Serif-bold-r-*-*-11-*-*-*-*-*-*-1", NULL);
#endif
	SetFont_Default(IappXDat.Default_Font, True);
	SetFont_Default(IappXDat.Default_bold_Font, True);
}

int Send_MSG(Tobjmsg *msg, Tapph *ap) {
  int res = 0;
	if (!msg || !ap) return res;
	msg->ap = ap;
	if (appXDat->EvProc) appXDat->EvProc(msg);
	if (ap->EvProc) res = ap->EvProc(msg);
	return res;
}

int Exec_Win_Ev(Tobjmsg *msg, Window win) {
	return Send_MSG(msg, Find_Exec_WinsX_Ev(appXDat->apph, win));
}

int Exec_WinsX_Ev(XEvent *ev) {
  Tobjmsg msg;
	msg.msg = msgXEv;
	msg.f = 0;
	msg.m = 0;
	msg.p = (int *) ev;
	return Exec_Win_Ev(&msg, ev->xany.window);
}

bool DispatchEvent() {
  MSG Msg;
	if (PeekMessageW(&Msg, 0, 0, 0, PM_REMOVE)) {
	    if (Msg.message == WM_QUIT) {
		Terminate = True;
		appDat->gQUIT_Ev = True;
		return False;
	    }
//	    TranslateMessage (&Msg);
	    DispatchMessageW(&Msg);
	    return True;
	}
	return False;
}

void X11DispatchEvent() {
	while (DispatchEvent());
}

void Wins_PaintOnEvEnd() {
  int i;
  Tobjmsg msg;
  Tapph *ap;
	msg.msg = msgPaint;
	for (i=0; i < IappXDat.PaintOnEvEnd_Count; i++) {
	    ap = (Tapph*)IappXDat.PaintOnEvEnd_List->val[i];
	    if (ap) {
//		SetAkt_hGC(ap->wins->WinId);
		Send_MSG(&msg, ap);
//		ReleaseAkt_hGC();
	    }
	}
	IappXDat.PaintOnEvEnd_Count = 0;
}

/*____________________________________________________________________________*/
static void InitStartForm() {
  Tapph *ap;
  Tobjmsg msg;

	msg.msg = msgVisibleFormShow;
	msg.f = 0;
	msg.m = 0;
	msg.p = NULL;

	ap = IappXDat.apph;
	if (!ap) return;
	while (ap) {
		if (ap->aos & aosIsForm) Send_MSG(&msg, ap);
		ap = ap->next;
	}
}

void AppRun() {
	InitStartForm();
	AppProcessMessages();
	if (appXDat->OnAppStart) appXDat->OnAppStart();
NotClose:
	while (AppHandleMessage());
	if (appXDat->OnAppClose) appXDat->OnAppClose();
	if (!appDat->gQUIT_Ev) goto NotClose;

	KillTimer(0, appTimer_50ms);
}


/*____________________________________________________________________________*/

void Close() {
	appDat->gQUIT_Ev = True;
}

void MapWinID(Window WinID, int fu) {  //fu 0=UnMap 1=Map 2=MapRaised
	switch(fu) {
	case 0:
		XUnmapWindow(appXDat->dpy, WinID);
		break;
	case 1:
		XMapWindow(appXDat->dpy, WinID);
		break;
	case 2:
		XMapRaised(appXDat->dpy, WinID);
		break;
	}
}
