/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

static TForm *getappForm(Window win) {
  Tapph *ap = IappXDat.apph;
	while (ap && (ap->win != win)) ap = ap->next;
	if (ap && (ap->aos & aosIsForm)) return (TForm*)ap->wins;
	return NULL;
}

/* ______________________________________________________________________*/
static void XKey2TKey(XKeyEvent *XKeyEv, int keyst) {
  Tobjmsg msg;
  TKeyEvent KeyEv;
  int m;

	if (IappXDat.appCursorWait) return;

	IappXDat.Tmp_XKeyEv = XKeyEv;
	IappXDat.last_KeyState = XKeyEv->state;
	KeyEv.keyst = keyst;
	KeyEv.state = XKeyEv->state;
	KeyEv.keycode = XKeyEv->keycode;
	XLookupString(XKeyEv, (char*)&m, 4, &KeyEv.keysym, NULL);
	NumLook_korr(&KeyEv);
	msg.msg = msgKey;
	msg.f = msg.m = 0;
	msg.p = &KeyEv;
	if (IappXDat.KeyInForm) Exec_Win_Ev(&msg, IappXDat.KeyInForm->WinID);
	if (KeyEv.keysym && IappXDat.KeyInWin) Exec_Win_Ev(&msg, IappXDat.KeyInWin->WinID);
}

static Window REGPARM3_FUNC HandleKeyPress(TXev_msg *msg) {  //2 
	XKey2TKey((XKeyEvent*)msg->ev, keyst_Press);
	return 0;
}

static Window REGPARM3_FUNC HandleKeyRelease(TXev_msg *msg) {  //3
	XKey2TKey((XKeyEvent*)msg->ev, keyst_Release);
	return 0;
}

static Window REGPARM3_FUNC HandleButtonEvent(TXev_msg *msg) {  //4,5
  XButtonEvent *ev = (XButtonEvent*)msg->ev;
	if (IappXDat.appCursorWait) return 0;
	IappXDat.last_KeyState = ev->state;

	if (IappXDat.GrabWin && !ttc_chk_struct(IappXDat.GrabWin)) {
 printf("%s(%d): ERROR: GrabWin\n", FL);
	    Std_UngrabPointer();
	}

	if (IappXDat.GrabWin && (ev->window != IappXDat.GrabWin->WinID)) {

XID JunkChild;
	    XTranslateCoordinates (IappXDat.dpy, IappXDat.RootW, 
			IappXDat.GrabWin->WinID, ev->x_root, ev->y_root,
			&ev->x, &ev->y, &JunkChild);
	    ev->window = IappXDat.GrabWin->WinID;
	}
	return ev->window;
}

static Window REGPARM3_FUNC HandleMotionNotify(TXev_msg *msg) {  //6
  XMotionEvent *ev = (XMotionEvent*)msg->ev;
	while (XCheckTypedWindowEvent(IappXDat.dpy, ev->window, 
				    MotionNotify, (XEvent*)ev));
	IappXDat.last_KeyState = ev->state;
	return ev->window;
}

static Window REGPARM3_FUNC HandleFocusIn(TXev_msg *msg) {  //9
  XFocusInEvent *ev = (XFocusInEvent*)msg->ev;
	msg->msg = msgFocus;
	msg->m   = WinsFocusIN;
	TForm *Form = getappForm(ev->window);
	if (!Form) return 0;
	IappXDat.KeyInForm = (TWins*)Form;
	if (!Form->FocusWin) return 0;
	return Form->FocusWin->WinID;
}

static Window REGPARM3_FUNC HandleFocusOut(TXev_msg *msg) {  //10
  XFocusOutEvent *ev = (XFocusOutEvent*)msg->ev;
	msg->msg = msgFocus;
	msg->m   = 0; //WinsFocusOut;
	TForm *Form = getappForm(ev->window);
	if (!Form || !Form->FocusWin) return 0;
	return Form->FocusWin->WinID;
}

static Window REGPARM3_FUNC HandlePropertyNotify(TXev_msg *msg) {  //28
  XPropertyEvent *ev = (XPropertyEvent*)msg->ev;
	for (int i=0;i<evFilter_max;i++) {
	  if (IappXDat.PropEvFilter[i].Filter_PropEv &&
	      IappXDat.PropEvFilter[i].FilterAtom && 
	      (IappXDat.PropEvFilter[i].FilterAtom == ev->atom)) {

	    IappXDat.PropEvFilter[i].Filter_PropEv(ev);
	  }
	}
	return ev->window;
}

void appXeventDefaultInit() {
	set_XEventHandle(KeyPress,   HandleKeyPress);
	set_XEventHandle(KeyRelease, HandleKeyRelease);
	set_XEventHandle(ButtonPress,   HandleButtonEvent);
	set_XEventHandle(ButtonRelease, HandleButtonEvent);
	set_XEventHandle(MotionNotify, HandleMotionNotify);
	set_XEventHandle(FocusIn,  HandleFocusIn);
	set_XEventHandle(FocusOut, HandleFocusOut);
	set_XEventHandle(PropertyNotify, HandlePropertyNotify);
}
