/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

#if LASTEvent > 64
#error "X11 LASTEvent > 64"
#endif

static THandleXEvent HandleXEventTab[64];

void REGPARM3_FUNC set_XEventHandle(int evtype, THandleXEvent EvProc) {
	if (evtype & ~0x3f) return;
	HandleXEventTab[evtype] = EvProc;
}

THandleXEvent REGPARM3_FUNC get_XEventHandle(int evtype) {
	if (evtype & ~0x3f) return NULL;
	return HandleXEventTab[evtype];
}

Window REGPARM3_FUNC exec_XEventHandle(TXev_msg *msg) {
  int evtype = msg->ev->type;
	if (evtype & ~0x3f) return 0;
	if (!HandleXEventTab[evtype]) return msg->ev->xany.window;
	return HandleXEventTab[evtype](msg);
}
