/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

bool get_desktop_dskcmd(TDesktopCMD *dskcmd) {
  int gp_fu;
  char *cmd, *indata, *token, *pc;
  TDesktop_gpList *ngpList;
  char *res = NULL;
#ifdef Test_Root_WinId
  char line[64];
#endif
  bool mkfn, mkmul;  

	gp_fu = gptfu_PasswdTxt;
	cmd = dskcmd->Exec;

	indata = cmd;
	while (indata && *indata) {
	    indata = GetTokenFu(indata, &token, TokenFu_PlusSep);
	    if (*token == '%') {
		mkfn = mkmul = False;
		if (token[1] == 'f') {
		    mkfn = True;
		    gp_fu |= gptfu_noRootArt;
		} else if (token[1] == 'F') {
		    mkfn = True;
		    mkmul = True;
		    gp_fu |= gptfu_noRootArt;
		} else if (token[1] == 'u') {
		    mkfn = True;
		} else if (token[1] == 'U') {
		    mkfn = True;
		    mkmul = True;
		}
		if (mkfn) {
		    ngpList = dskcmd->gpList;
		    while (ngpList) {
			if (gp_test_local_drive(&ngpList->gp)) gp_fu |= gptfu_noRootArt;
			pc = gptopc(&ngpList->gp, gp_fu);
			ppcadd_n(&res, 3, " \"", pc, "\"");
			xfree(pc);
			if (!mkmul) break;
			ngpList = ngpList->next;
		    }
		}

	    } else if (pccmp(token, "-caption")) {
		xfree(token);
		indata = GetToken(indata, &token);
	    } else if (pccmp(token, "--TestRootWinID")) {
#ifdef Test_Root_WinId
		if (TestRootWinId) {
		    ppcadd2(&res, " ", token);
		    inttopc(line, IappXDat.RootW);
		    ppcadd2(&res, " ", line);
		}
#endif
	    } else {
		if (res) ppcadd2(&res, " ", token); else ppcadd(&res, token);
	    }
	    xfree(token);
	}
	dskcmd->ret_cmd = res;
	return True;
}

char *get_desktop_CMD(TpcIni *ini, int fu, TDesktop_gpList *gpList) {
  TDesktopCMD dskcmd;
	dskcmd.gpList = gpList;
	dskcmd.Exec = TpcIni_RD(ini, Desktop_Entry, "Exec");
	get_desktop_dskcmd(&dskcmd);
	return dskcmd.ret_cmd;
}
