/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

static bool ChkFocEl(Tapph *ap) {
	return (TestWinCanFocus(ap->wins) && 
		(ap->wins->wtyp != wtyp_MenuButton) &&
		!(ap->wins->KeyFu & mNoKeyFocus));
}

static Tapph *NextFocEl(Tapph *ap) {
  while (ap && !ChkFocEl(ap)) ap = ap->next;
  return ap;
}

static void Form_NextFocEl_Scan(Tapph *ap, Tapph **org_ap, Tapph **apa, Tapph **apn) {
	while (ap && !*apn) {
	    if (ap->next_child) Form_NextFocEl_Scan(ap->next_child, org_ap, apa, apn);
	    if (!*apn) {
		if (ChkFocEl(ap) && (ap != *org_ap)) {
		    if (*org_ap) {
			if (!*apa) *apa = ap; 
		    } else *apn = ap;
		}
		if (ap == *org_ap) *org_ap = NULL;
	    }
	    ap = ap->next;
	}
}

static Tapph *PrevFocEl(Tapph *ap) {
  while (ap && !ChkFocEl(ap)) ap = ap->prev;
  return ap;
}

TWins *GetNextFocEl(Tapph *ap, bool ret, bool over) {
  Tapph *nap, *napc;
  TForm *Form;

	if (!ap) return NULL;
	if (ret) {
	    nap = PrevFocEl(ap->prev);
	    if (nap) return nap->wins;
	    nap = ap;
	    while (nap->next) nap = nap->next;
	    nap = PrevFocEl(nap);
	    if (nap && (nap != ap)) return nap->wins;

	} else if (over) {
	    nap = NextFocEl(ap->next);
	    if (nap && (nap->wins->wtyp != wtyp_MenuButton)) return nap->wins;
	    Form = GetParentForm(ap->wins);
	    nap = napc = NULL;
	    Form_NextFocEl_Scan(Form->apph, &ap, &nap, &napc);
	    if (napc) return napc->wins;
	    if (nap) return nap->wins;

	} else {
	    nap = NextFocEl(ap->next);
	    if (nap) return nap->wins; 
	    nap = ap;
	    while (nap->prev) nap = nap->prev;
	    nap = NextFocEl(nap);
	    if (nap && (nap != ap)) return nap->wins;
	}
	return NULL;
}
