/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include <stdarg.h>
#include "tpixmap.h"

#define DebugAzAtom 0

static int XmaxSel;
static int AbsMaxSel;
static Tlgs SelTxt_tmp;

void SelClr() {
	Tlgs_Clr(&IappXDat.SelTxt);
	Tlgs_Clr(&IappXDat.SelTxt_URL);
	ppTfree(&IappXDat.Selpxm);
}

void SelRetClr() {
	Tlgs_Clr(&IappXDat.SelRet_lgs);
}

/*_______________________ Selection write _______________________________*/
static dword wr_incr_ms;

static int    wrCount;
static int    wrFormat;
static Atom   wrTarget, wrProperty;
static Window wrRequestor;
static char   *wrData;


static void wrChangeProperty(int lg) {
  byte *dat = (byte*)wrData;

	if (!dat || (wrCount <= 0) || (lg <= 0)) {
	    lg = 0;
	    dat = NULL;
	} else {
	    if (lg > wrCount) lg = wrCount;
	}
	wrCount -= lg;
	wrData += lg;
	lg = lg >> (wrFormat >> 4);

	XChangeProperty(IappXDat.dpy, wrRequestor, wrProperty,
			wrTarget, wrFormat, PropModeReplace, dat, lg);
}


static void INCR_PropertyNotify(XPropertyEvent *ev) {
  int lg;

	if (ev->state != PropertyDelete) return;
	lg = wrCount;
	if (lg > XmaxSel) lg = XmaxSel;
	wrChangeProperty(lg);
	if (lg <= 0) {
	    IappXDat.PropEvFilter[evFilter_sel_wr].Filter_PropEv = NULL;
	    XSelectInput(IappXDat.dpy, wrRequestor, NoEventMask);
	}
}

static void chk_max(int *pmax, int lg, char *nAtom, XSelectionRequestEvent *ev) {
  int max = *pmax;
  Atom a;
  char *msg;

	if ((lg <= max) || (max <= 0)) return;
	a = XInternAtom(IappXDat.dpy, nAtom, 1);
	if (!a || (a != ev->property)) return;
	
	if (lg > AbsMaxSel) {
	    *pmax = 0;
	    msg = "ERROR";
	} else {
	    *pmax = AbsMaxSel;
	    msg = "WARNING";
	}
	printf("%s(%d): %s: %s \"INCR\" not work\n", FL, msg, nAtom);
}

static Window REGPARM3_FUNC HandleSelectionClear(TXev_msg *msg) {  //29
#if DebugAzAtom
 printf("%s(%d): HandleSelectionClear\n", FL);
#endif
	IappXDat.PropEvFilter[evFilter_sel_wr].Filter_PropEv = NULL;
	Tfree(IappXDat.Selpxm);
	IappXDat.Selpxm = NULL;
	SelRetClr(); //Tlgs_Clr(&IappXDat.SelRet_lgs);
	IappXDat.SELECT_AtomsCount = 0;
	return 0;
}

static Window REGPARM3_FUNC HandleSelectionRequest(TXev_msg *msg) {  //30
  int i, pbLg;
  bool ok, incr_on;
  XSelectionRequestEvent *ev = (XSelectionRequestEvent*)msg->ev;
  XSelectionEvent evt;
#if DebugAzAtom
 printf("%s(%d): HandleSelectionRequest\n", FL);
 AzAtom(FL, "Sel-Atoms selection", ev->selection);
 AzAtom(FL, "Sel-Atoms target", ev->target);
 AzAtom(FL, "Sel-Atoms property", ev->property);
 fflush(stdout);
#endif
// printf("%s(%d): SelWin=0x%x owner=0x%x requestor=0x%x\n", FL, (int)IappXDat.SelHandleWin, (int)ev->owner, (int)ev->requestor);

	evt.type = SelectionNotify;
	evt.serial = 0;
	evt.send_event = 1;
	evt.display = IappXDat.dpy;
	evt.requestor = ev->requestor;
	evt.selection = ev->selection;
	evt.target = ev->target;
	evt.property = ev->property;
	evt.time = ev->time;

	wrProperty = ev->property;
	wrRequestor = ev->requestor;
	wrTarget = ev->target;

	wrFormat = 8;
	SelTxt_tmp = IappXDat.SelTxt;
	wrCount = SelTxt_tmp.lg;
	wrData = SelTxt_tmp.s;
	IappXDat.PropEvFilter[evFilter_sel_wr].Filter_PropEv = NULL;

	incr_on = False;
	ok = True;

	if (ev->target == IappXDat.XA_TARGETS) {
	    wrData = (char*)&IappXDat.SELECT_Atoms[0];
	    wrCount = IappXDat.SELECT_AtomsCount << 2; 
	    wrFormat = 32;
	    wrTarget = XA_ATOM;

	} else if (ev->target == IappXDat.XA_KDE_CUT) {
	    wrData = "0"; //(char*)&IappXDat.SelCut;
	    if (IappXDat.SelCut) wrData = "1";
	    wrCount = 2;

#ifdef DRAG_AND_DROP
	} else if (IappXDat.dnd && ev->selection == IappXDat.dnd->XA_XdndSelection) {
// printf("%s(%d): \n", FL);
	    if (IappXDat.dnd->SelectionReq)
		  ok = IappXDat.dnd->SelectionReq(ev, &wrData, &wrCount, &wrFormat);
#endif
	} else {
// AzAtom(FL, "SelReq-Atoms", ev->target);
	  for (i=1; i < IappXDat.SELECT_AtomsCount; i++) {
	    if (ev->target == IappXDat.SELECT_Atoms[i]) {

	      if (ev->target == XA_PIXMAP) {
		if (IappXDat.Selpxm && IappXDat.Selpxm->pmxID) {
		  wrCount = 4;
		  wrFormat = 32;
		  wrData = (char*)&IappXDat.Selpxm->pmxID;
		} else ok = False;

	      } else {

		if (ev->target == IappXDat.XA_URL_STRING) {
		    SelTxt_tmp = IappXDat.SelTxt_URL;
		    wrCount = SelTxt_tmp.lg;
		    wrData = SelTxt_tmp.s;
		}

		int max = XmaxSel;
		pbLg = IappXDat.SelTxt.lg;
//		chk_max(&max, pbLg, "GDK_SELECTION", ev);
		chk_max(&max, pbLg, "CLIP_TEMPORARY", ev); // Motif clients
		ok = max > 0;
		if (ok && (pbLg > max)) {
		    wr_incr_ms = GetTime_ms() + 1000;
		    wrCount = 4;
		    wrFormat = 32;
		    wrData = (char*)&pbLg;
		    wrTarget = IappXDat.XA_INCR;
		    incr_on = True;
		}
	      }
	      break;
	    }
	  }
	}

	if (!ok) {
	    wrCount = 0;
	    wrData = NULL;
	    wrTarget = IappXDat.XA_NONE;
	}

	wrChangeProperty(wrCount);

	XSendEvent(IappXDat.dpy, ev->requestor, False, NoEventMask, (XEvent*)&evt);

	if (incr_on && ok) {
	    wrCount = SelTxt_tmp.lg;
	    wrData = SelTxt_tmp.s;
	    wrFormat = 8;
	    wrTarget = ev->target;

	    IappXDat.PropEvFilter[evFilter_sel_wr].FilterAtom = ev->property;
	    IappXDat.PropEvFilter[evFilter_sel_wr].Filter_PropEv = INCR_PropertyNotify;
	    XSelectInput(IappXDat.dpy, ev->requestor, PropertyChangeMask);
	}
	return 0;
}

/*_______________________ Selection read ________________________________*/
static Atom Sel_INCR_Atom;
static int Sel_INCR_lg;
static char *Sel_INCR_data;
static bool rd_sel_ok;

static void rd_reset(int fu) {
	XSelectInput(IappXDat.dpy, IappXDat.SelHandleWin, NoEventMask);
	IappXDat.PropEvFilter[evFilter_sel_rd].Filter_PropEv = NULL;
	if (fu & 0x01) IappXDat.SelWait = False;
	if (fu & 0x02) rd_sel_ok = False;
	Sel_INCR_lg = 0;
	if (!rd_sel_ok) SelRetClr(); //Tlgs_Clr(&IappXDat.SelRet_lgs);
}

static void rd_INCR_PropertyNotify(XPropertyEvent *ev) {
  unsigned long Offset, rlg, lg, bytes_left;
  int SelRetFormat;
  Atom SelRetAtom;
  byte *rs;

	if (!IappXDat.SelWait || (Sel_INCR_lg <= 0)) goto ev_close;
	if (ev->state != PropertyNewValue) return;

	Offset = 0;
loop:
	if (XGetWindowProperty(IappXDat.dpy, IappXDat.SelHandleWin, 
		IappXDat.XA_ALD_selection, Offset, XmaxSel, 0, 
		AnyPropertyType, &SelRetAtom, &SelRetFormat,
		&rlg, &bytes_left, &rs)) return;

	if (SelRetAtom != Sel_INCR_Atom) return;
	if (rs) {
	    IappXDat.SelRetAtom = SelRetAtom;
	    IappXDat.SelRetFormat = SelRetFormat;
    // printf("XGetWindowProperty %d=\"%s\" %d off=%d rlg=%d %d\n", (int)SelRetAtom, XGetAtomName(IappXDat.dpy, SelRetAtom), IappXDat.SelRetFormat, (int)Offset, (int)rlg, (int)bytes_left);

	    lg = rlg << (IappXDat.SelRetFormat >> 4);
	    if (lg > Sel_INCR_lg) lg = Sel_INCR_lg;
	    Sel_INCR_lg -= lg;
	    ppcnmove(&Sel_INCR_data, (char*)rs, lg);
	    XFree(rs);
	    Offset += (rlg * IappXDat.SelRetFormat) >> 5;
	    if (bytes_left) goto loop;
// printf("%s(%d) Sel INCR lg=%d\n", FL, Sel_INCR_lg);
	    XDeleteProperty(IappXDat.dpy, IappXDat.SelHandleWin, IappXDat.XA_ALD_selection);
	    if (Sel_INCR_lg > 0) return;
	    rd_sel_ok = True;
	}
ev_close:
	rd_reset(1);
}

static Window REGPARM3_FUNC HandleSelectionNotify(TXev_msg *msg) {  //31
  unsigned long bytes_left, Offset, lg, rlg;
  unsigned char *rs;
  XSelectionEvent *ev = (XSelectionEvent*)msg->ev;
#if DebugAzAtom
 printf("HandleSelectionNotify %d req=%x s=%d t=%d p=%d\n", IappXDat.SelWait, (int)ev->requestor, (int)ev->selection, (int)ev->target, (int)ev->property);
 AzAtom(FL, "HandleSelectionNotify selection", ev->selection);
 AzAtom(FL, "HandleSelectionNotify target", ev->target);
 AzAtom(FL, "HandleSelectionNotify property", ev->property);
#endif

	if (ev->property == IappXDat.XA_NONE) {
	    rd_reset(3);
	    return 0;
	}
	Sel_INCR_Atom = ev->target;
	Offset = 0;
	while (IappXDat.SelWait) {
	    if (XGetWindowProperty(IappXDat.dpy, ev->requestor, IappXDat.XA_ALD_selection,
		    Offset, XmaxSel, 0, AnyPropertyType,
		    &IappXDat.SelRetAtom, &IappXDat.SelRetFormat,
		    &rlg, &bytes_left, &rs) != 0) break;
#if DebugAzAtom
 printf("XGetWindowProperty %d=\"%s\" %d off=%d rlg=%d %d\n", (int)IappXDat.SelRetAtom, XGetAtomName(IappXDat.dpy, IappXDat.SelRetAtom), IappXDat.SelRetFormat, (int)Offset, (int)rlg, (int)bytes_left);
#endif
	    if (!rs) {
		rd_reset(3);
		return 0;
	    }

	    if (IappXDat.SelRetAtom == IappXDat.XA_INCR) {
		Sel_INCR_lg =  *(int*)rs;
		XFree(rs);
#if DebugAzAtom
 printf("%s(%d) Sel INCR lg=%d\n", FL, Sel_INCR_lg);
#endif
		if (Sel_INCR_lg <= 0) {
		    rd_reset(3);
		    return 0;
		}

		Sel_INCR_data = xmalloc(Sel_INCR_lg + 1);
		IappXDat.SelRet_lgs.s = Sel_INCR_data;
		IappXDat.SelRet_lgs.lg = Sel_INCR_lg;

		IappXDat.PropEvFilter[evFilter_sel_rd].FilterAtom = IappXDat.XA_ALD_selection;
		IappXDat.PropEvFilter[evFilter_sel_rd].Filter_PropEv = rd_INCR_PropertyNotify;

		XSelectInput(IappXDat.dpy, IappXDat.SelHandleWin, PropertyChangeMask);
		XDeleteProperty(IappXDat.dpy, IappXDat.SelHandleWin, IappXDat.XA_ALD_selection);
		return 0;

	    } else {
		lg = (rlg << (IappXDat.SelRetFormat >> 4));
		Tlgs_Add_s(&IappXDat.SelRet_lgs, (char*)rs, lg);
		XFree(rs);
		Offset += (rlg * IappXDat.SelRetFormat) >> 5;
		if (!bytes_left) break;
	    }
	}
	rd_sel_ok = IappXDat.SelWait;
#if DebugAzAtom
 printf("%s(%d) %d lg=%d\n", FL, IappXDat.SelWait, IappXDat.SelRet_lgs.lg);
#endif
	return 0;
}


void SetSelection(int count, ...) {
  va_list ap;
	if (count <= 0) {
	    IappXDat.SELECT_AtomsCount = 0;
	    return;
	}
	if (!get_XEventHandle(SelectionRequest)) SelectionInit();

	IappXDat.SELECT_AtomsCount = count+1;
	IappXDat.SELECT_Atoms[0] = IappXDat.XA_TARGETS;

	va_start(ap, count);
	if (count > MaxSELECT_Atoms-1) count = MaxSELECT_Atoms-1;
	for (int i = 1; (i <= count); i++) {
	    IappXDat.SELECT_Atoms[i] = va_arg(ap, int);
	}
	va_end(ap);
	XSetSelectionOwner(IappXDat.dpy, IappXDat.CLIPBOARD_ATOM, IappXDat.SelHandleWin, CurrentTime);
}

static void Wait_GetPasteDaten(int ms) {
  dword t = GetTime_ms() + ms;
	while (IappXDat.SelWait && !rd_sel_ok && !cpTime(t, GetTime_ms())) {
	    if (fd_in_wait_sigle(IappDat.x_fd, 10000)) {
		handle_wait_X11Event();
	    }
	}
}


bool GetPasteDaten(Atom SrcAtom, Atom XA_SelAtom) {

	if (IappXDat.SelWait) return False;
	if (!get_XEventHandle(SelectionNotify)) SelectionInit();
	rd_reset(3);
	IappXDat.SelWait = True;
// AzAtom(FL, "GetPasteDaten", SrcAtom);
// AzAtom(FL, "GetPasteDaten", XA_SelAtom);

	XConvertSelection(IappXDat.dpy, SrcAtom, XA_SelAtom, IappXDat.XA_ALD_selection, IappXDat.SelHandleWin, CurrentTime);

	Wait_GetPasteDaten(60);  //0,06sec
	if (IappXDat.SelWait && !rd_sel_ok) {
	    appSetCursorWait(NULL, True);
	    Wait_GetPasteDaten(10000); //10,0sec
	    appSetCursorWait(NULL, False);
	}
	rd_reset(1);
	return (IappXDat.SelRet_lgs.lg > 0);
}

#if DebugAzAtom
void printf_XA_TARGETS() {
  int i;
  Atom *pA;

	pA = (Atom*)&IappXDat.SelRet_lgs.s[0];
	i = IappXDat.SelRet_lgs.lg >> 2;
	printf("printf_XA_TARGETS: %d\n", i);
	AzAtom(FL, "Sel-Atoms: RetType", IappXDat.SelRetAtom);
	for (; i > 0; i--) {
	    AzAtom(FL, "Sel-Atoms", *pA);
	    pA++;
	}
}
#endif
bool Get_XA_TARGETS() {
  bool res = (GetPasteDaten(IappXDat.CLIPBOARD_ATOM, IappXDat.XA_TARGETS) != 0);
	res = res && (IappXDat.SelRetFormat == 32) &&
          	     ((IappXDat.SelRetAtom == IappXDat.XA_TARGETS) || 
		      (IappXDat.SelRetAtom == XA_ATOM));
#if DebugAzAtom
  if (res) printf_XA_TARGETS();
#endif
	return res;
}

Atom get_nSelAtom(Atom a) {
  Atom *pA = (Atom*)IappXDat.SelRet_lgs.s;
  int i = IappXDat.SelRet_lgs.lg >> 2;
	for (; i > 0; i--) {
	    if (*pA == a) return a;
	    pA++;
	}
	return 0;
}

bool Chk_GetSelection(int count, ...) {
  va_list ap;
  Atom a = 0;

	if ((count <= 0) || !Get_XA_TARGETS()) return False;

	va_start(ap, count);
	while (!a && count) {
	    Atom an = va_arg(ap, int);
	    a = get_nSelAtom(an);
	    count--;
	}
	va_end(ap);
	rd_reset(3);
	return (a != 0);
}

/*____________________________ Init _____________________________________*/
void SelectionInit() {
  int a, m;

	a = m = XExtendedMaxRequestSize(IappXDat.dpy);
	if (m > 0x40000) {
	    m = 0x40000;
	} else if (m) {
	    m -= 32;
	    a = m;
	} else {
	    a = m = XMaxRequestSize(IappXDat.dpy) - 32;
	}
	AbsMaxSel = a;
	XmaxSel = m;

	set_XEventHandle(SelectionClear, HandleSelectionClear);
	set_XEventHandle(SelectionNotify, HandleSelectionNotify);
	set_XEventHandle(SelectionRequest, HandleSelectionRequest);
}
