/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "sysbase.h"
#include <dlfcn.h>

#define libpng_so_2	2
#define libpng_so_3	3
#define libpng_so_2V	"1.0.5"
#define libpng_so_3V	"1.2.2"

void *(*dl_png_create_read_struct) (char *user_png_ver,
		void *error_ptr, void *error_fn, void *warn_fn);
void *(*dl_png_destroy_read_struct) (void **png_ptr_ptr,
		void **info_ptr_ptr, void **end_info_ptr_ptr);
void *(*dl_png_create_info_struct) (void *png_ptr);

void (*dl_png_init_io) (void *png_ptr, FILE *fp);

void *pngLibHandle = NULL;
int pngVer;
char *pngVerStr;
bool pnglib_RD_load = False;
bool pnglib_WR_load = False;
bool pnglib_Err = False;


static void CHK_PNG_Ver(char *name) {
  void *png_ptr;

	pngLibHandle = dlopen(name, RTLD_LAZY);
	if (!pngLibHandle) return;

	dl_png_create_read_struct = load_lib(pngLibHandle, "png_create_read_struct");
	dl_png_destroy_read_struct = load_lib(pngLibHandle, "png_destroy_read_struct");
	dl_png_create_info_struct = load_lib(pngLibHandle, "png_create_info_struct");
	dl_png_init_io = load_lib(pngLibHandle, "png_init_io");
	
	if (dl_png_create_read_struct && dl_png_destroy_read_struct &&
	    dl_png_create_info_struct && dl_png_init_io) {
	    png_ptr = dl_png_create_read_struct(pngVerStr, NULL, NULL, NULL);
	} else png_ptr = NULL;

	if (png_ptr) {
	    dl_png_destroy_read_struct(&png_ptr, NULL, NULL);
	} else {
	    dlclose(pngLibHandle);
	    pngLibHandle = NULL;
	}
}

bool LoadLib_PNG() {
	if (pnglib_Err) return False;
	if (pngLibHandle) return True;

	pngVer = libpng_so_3;
	pngVerStr = libpng_so_3V;
	CHK_PNG_Ver("libpng12.so.0");
	if (!pngLibHandle) {
	    CHK_PNG_Ver("libpng.so.3");
	}
	if (!pngLibHandle) {
	    pngVer = libpng_so_2;
	    pngVerStr = libpng_so_2V;
	    CHK_PNG_Ver("libpng.so.2");
	}

	pnglib_Err = (pngLibHandle == NULL);
	if (pnglib_Err) appError(EMSG_ERR2, "can't open libpng12.so.0 or libpng.so.3 or libpng.so.2");
	return !pnglib_Err;
}
