/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

/* ************ Zoom 16bpp 1:XXX ******************* */

static void inline Timg_rsz16xx11_rgb_n(dword cw, dword *r, dword *g, dword *b, dword k) {
	*b += (cw & 0x1f) * k; 
	*g += (((cw >> 5) & 0x3f) * k) >> 1; 
	*r += ((cw >> 11) & 0x1f) * k;
}

static void inline Timg_rsz16xx11_rgb_n1(dword cw, dword *r, dword *g, dword *b, dword k) {
	*b += (cw & 0x1f) * k; 
	*g += ((cw >> 5) & 0x3f) * k; 
	*r += ((cw >> 11) & 0x1f) * k;
}
 
static int _rsz16_xx_11(Timg_rsz *rsz) {
  word *pws = rsz->src_dat;
  word *pwd = rsz->dest_dat;
  dword org_w = rsz->src_w;
  dword org_h = rsz->src_h;
  dword new_w = rsz->to_w;
  dword new_h = rsz->to_h;
  int s_eoff = rsz->src_line_eoff;
  int d_eoff = rsz->dest_line_eoff;

  dword k, kw, kw0, kh, kh0, kmul, kmul_g;
  dword x, y;
  dword r, g, b;
  dword xa, ye, cya, cye, ya0, cxa, cxe;
  word *pwsy, *pws0;
  int lx, l, ly, yn, loff_x;

// printf("%s(%d): %d %d\n", FL, rsz->src_line_eoff, rsz->dest_line_eoff);
/* return 1  = ERROR: img kleiner 2x2 bixel */
	if ((new_w < 2) || (new_h < 2)) return rszERR_LE2x2Pixel;

	kw = (org_w << 16) / new_w;
	kh = (org_h << 16) / new_h;

/* return 2  = ERROR: Zoom > 1:255 */
	if ((kw > 0x00ffffff) && (kh > 0x00ffffff)) return rszERR_ZoomGT255;


	if ((kw == 0x00010000) && (kh == 0x00010000)) return ImgDat_Copy(rsz);
	if ((kw < 0x00010000) || (kh < 0x00010000)) goto zoom_plus;
	if ((kw == 0x00020000) && (kh == 0x00020000)) return ImgDat_Resize_22_11(rsz);

//	k = ((kw >> 8) * (kh >> 8)) >> 8;
	if (((kw + kh) < 0x001fffff)) {
		k = ((kw >> 4) * (kh >> 4)) >> 16;
	} else {
		k = ((kw >> 8) * (kh >> 8)) >> 8;
	}
	kmul   = 0x103fffff / k;
	kmul_g = 0x101fffff / k;
// printf("w=%d/%d h=%d/%d kw=%x kh=%x k=%x kmul=%x\n", org_w, new_w, org_h, new_h, kw, kh, k, kmul);

	if (((kw*new_w)>>16) == org_w) kw--;
	if (((kh*new_h)>>16) == org_h) kh--;

	kh0 = 0;
	pws0 = pws;
	y = new_h;
	while (y) {
	    ya0 = kh0>>16;
	    ye = (kh0+kh)>>16;
	    pwsy = pws + ((org_w + s_eoff) * ya0);
	    ly = ye - ya0 - 1;

	    kw0 = 0;
	    cya = (0xffff - (kh0 & 0xffff)) >> 5;
	    cye = ((kh0+kh) & 0xffff) >> 5;

	    x = new_w;
	    while (x) {
		cxa = ((0xffff - (kw0 & 0xffff)) >> 5);
		cxe = (((kw0+kw) & 0xffff) >> 5);
		xa = kw0>>16;
		lx = ((kw0+kw)>>16) - xa - 1;
		loff_x = org_w + s_eoff - lx - 1;
		pws0 = pwsy + xa;

		k = ((cxa * cya) >> 11);
		b = (*pws0 & 0x1f) * k; 
		g = (((*pws0 >> 5) & 0x3f) * k) >> 1; 
		r = ((*pws0 >> 11) & 0x1f) * k;
		pws0++;

		l = lx;
		while (l > 0) {
			Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, cya);
			l--; pws0++;
		}
		Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, (cxe * cya) >> 11);

		yn = ly;
		while (yn > 0) {
			yn--;
			pws0 += loff_x;
			Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, cxa);
			pws0++;
			l = lx;
			while (l > 0) {
			    b += (*pws0 << 11) & 0xf800; 
			    g += (*pws0 << 5) & 0xfc00; 
			    r += *pws0 & 0xf800; 
			    l--; pws0++;
			}
			Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, cxe);
		}

		pws0 += loff_x;
		Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, (cxa * cye) >> 11);
		pws0++;
		while (lx > 0) {
			Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, cye);
			lx--; pws0++;
		}
		Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, (cxe * cye) >> 11);

		*pwd = ((((r >> 4) * kmul) >> 16) & 0xf800) | 
			((((g >> 4) * kmul_g) >> 21) & 0x7e0) | 
			((((b >> 4) * kmul) >> 27) & 0x1f);
		kw0 += kw;
		pwd++; x--;
	    }
	    kh0 += kh;
	    pwd += d_eoff;
	    y--;
	}
	return 0;

zoom_plus:
 printf("%s(%d): 0x%x 0x%x %d %d\n", FL, kw, kh, (kw*new_w)>>16, (kh*new_h)>>16);
	if (((kw*new_w)>>16) >= org_w) kw--;
	if (((kh*new_h)>>16) >= org_h) kh--;
 printf("%s(%d): 0x%x 0x%x %d %d\n", FL, kw, kh, (kw*new_w)>>16, (kh*new_h)>>16);


	kmul   = 0x0080ffff / kw;
	kmul_g   = 0x0080ffff / kh;
	loff_x = org_w + s_eoff;
	kh0 = 0;
	pws0 = pws;
	y = new_h;
	while (y) {
	    ya0 = kh0>>16;
	    pwsy = pws + ((org_w + s_eoff) * ya0);

	    kw0 = 0;

	    ly = ((kh0+kh-1) >> 16) - (kh0 >> 16);
	    cya = (kmul_g * (0x10000 - (kh0 & 0xffff))) >> 12;
	    cye = (kmul_g * ((kh0+kh) & 0xffff)) >> 12;
// printf("%s(%d): 0x%x 0x%x\n", FL, cya, cye);
	  if (ly) {
	    x = new_w;
	    while (x) {
		pws0 = pwsy + (kw0>>16);
#if 0
		*pwd = *pws0;
#else
		lx = ((kw0+kw-1) >> 16) - (kw0 >> 16);
		if (!lx) {
		    b = (*pws0 & 0x1f) * cya; 
		    g = ((*pws0 >> 5) & 0x3f) * cya; 
		    r = ((*pws0 >> 11) & 0x1f) * cya;
		    pws0 += loff_x;
		    Timg_rsz16xx11_rgb_n1(*pws0, &r, &g, &b, cye);
		    *pwd = (r & 0xf800) | ((g >> 6) & 0x7e0) | ((b >> 11) & 0x1f);
		} else {
		    cxa = (kmul * (0x10000 - (kw0 & 0xffff))) >> 12;
		    cxe = (kmul * ((kw0+kw) & 0xffff)) >> 12;
		    k = (cxa * cya) >> 11;
		    b = (*pws0 & 0x1f) * k; 
		    g = ((*pws0 >> 5) & 0x3f) * k; 
		    r = ((*pws0 >> 11) & 0x1f) * k;
		    Timg_rsz16xx11_rgb_n1(pws0[1], &r, &g, &b, (cxe * cya) >> 11);
		    pws0 += loff_x;
		    Timg_rsz16xx11_rgb_n1(*pws0, &r, &g, &b, (cxa * cye) >> 11);
		    Timg_rsz16xx11_rgb_n1(pws0[1], &r, &g, &b, (cxe * cye) >> 11);
		    *pwd = (r & 0xf800) | ((g >> 6) & 0x7e0) | ((b >> 11) & 0x1f);
		}
#endif
		kw0 += kw;
		pwd++; x--;
	    }
	  } else {
	    x = new_w;
	    while (x) {
		pws0 = pwsy + (kw0>>16);
#if 0
		*pwd = *pws0;
#else
		lx = ((kw0+kw) >> 16) - (kw0 >> 16);
		if (!lx) {
		    *pwd = *pws0;
		} else {
		    cxa = (kmul * (0x10000 - (kw0 & 0xffff))) >> 12;
		    cxe = (kmul * ((kw0+kw) & 0xffff)) >> 12;
		    b = (*pws0 & 0x1f) * cxa; 
		    g = ((*pws0 >> 5) & 0x3f) * cxa; 
		    r = ((*pws0 >> 11) & 0x1f) * cxa;
		    Timg_rsz16xx11_rgb_n1(pws0[1], &r, &g, &b, cxe);
		    *pwd = (r & 0xf800) | ((g >> 6) & 0x7e0) | ((b >> 11) & 0x1f);
		}
#endif
		kw0 += kw;
		pwd++; x--;
	    }
	  }
	    kh0 += kh;
	    pwd += d_eoff;
	    y--;
	}
// printf("\n");
	return 0;
}

/* ************ Zoom 16bpp + mask 1:XXX ************ */
 
static int _rsz16m_xx_11(Timg_rsz *rsz) {

  word *pws = rsz->src_dat;
  word *pwd = rsz->dest_dat;
  dword org_w = rsz->src_w;
  dword org_h = rsz->src_h;
  dword new_w = rsz->to_w;
  dword new_h = rsz->to_h;
  byte *pms = rsz->src_mask;
  byte *pmd = rsz->dest_mask;
  int s_eoff = rsz->src_line_eoff;
  int d_eoff = rsz->dest_line_eoff;

  dword k, kw, kw0, kh, kh0, kmul, kmul_g;
  dword x, y;
  dword r, g, b;
  dword xa, ye, cya, cye, ya0, cxa, cxe;
  word *pwsy, *pws0;
  int lx, l, ly, yn, loff_x;
  int kms, kmd, md, msz, mdz, km, kmg;
  byte *pms0, *pms0n, *pms1, *pmd0;

/* return 1  = ERROR: img kleiner 2x2 bixel */
	if ((new_w < 2) || (new_h < 2)) return rszERR_LE2x2Pixel;

	kw = (org_w << 16) / new_w;
	kh = (org_h << 16) / new_h;

/* return 2  = ERROR: Zoom > 1:255 */
	if ((kw > 0x00ffffff) && (kh > 0x00ffffff)) return rszERR_ZoomGT255;
	if ((kw == 0x00010000) && (kh == 0x00010000)) return ImgDat_Copy(rsz);
	if ((kw == 0x00020000) && (kh == 0x00020000)) return ImgDat_Resize_22_11(rsz);


//	k = ((kw >> 8) * (kh >> 8)) >> 8;
	if (((kw + kh) < 0x001fffff)) {
		k = ((kw >> 4) * (kh >> 4)) >> 16;
	} else {
		k = ((kw >> 8) * (kh >> 8)) >> 8;
	}
	kmul   = 0x103fffff / k;
	kmul_g = 0x101fffff / k;
// printf("w=%d/%d h=%d/%d kw=%x kh=%x k=%x kmul=%x\n", org_w, new_w, org_h, new_h, kw, kh, k, kmul);

	if (((kw*new_w)>>16) == org_w) kw--;
	if (((kh*new_h)>>16) == org_h) kh--;

	kms = (org_w+7) / 8;
	kmd = (new_w+7) / 8;
	kh0 = 0;
	pws0 = pws;
	y = new_h;
	while (y) {
	    mdz = md = 0;
	    pmd0 = pmd;

	    ya0 = kh0>>16;
	    ye = (kh0+kh)>>16;
	    pwsy = pws + ((org_w + s_eoff) * ya0);
	    pms0 = pms + (kms * ya0);
	    ly = ye - ya0 - 1;

	    kw0 = 0;
	    cya = (0xffff - (kh0 & 0xffff)) >> 5;
	    cye = ((kh0+kh) & 0xffff) >> 5;

	    x = new_w;
	    while (x) {
		km = b = g = r = 0;

		cxa = ((0xffff - (kw0 & 0xffff)) >> 5);
		cxe = (((kw0+kw) & 0xffff) >> 5);
		xa = kw0>>16;
		pms0n = pms0 + (xa >> 3);
		pms1 = pms0n;
		msz = xa & 0x07;

		lx = ((kw0+kw)>>16) - xa - 1;
		loff_x = org_w + s_eoff - lx - 1;
		pws0 = pwsy + xa;

		if (msz > 7) {msz = 0; pms1++;}
		k = ((cxa * cya) >> 11);
		kmg = k;
		if (*pms1 & (1 << msz)) {
		  b = (*pws0 & 0x1f) * k; 
		  g = (((*pws0 >> 5) & 0x3f) * k) >> 1; 
		  r = ((*pws0 >> 11) & 0x1f) * k;
		  km = k;
		}
		pws0++; msz++;

		l = lx;
		while (l > 0) {
		    kmg += cya;
		    if (msz > 7) {msz = 0; pms1++;}
		    if (*pms1 & (1 << msz)) {
			Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, cya);
			km += cya;
		    }
		    l--; pws0++;
		    msz++;
		}
		k = (cxe * cya) >> 11;
		kmg += k;
		if (msz > 7) {msz = 0; pms1++;}
		if (*pms1 & (1 << msz)) {
		    Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, k);
		    km += k;
		}
		pms0n += kms;
		pms1 = pms0n;
		msz = xa & 0x07;

		yn = ly;
		while (yn > 0) {
			yn--;
			pws0 += loff_x;
			kmg += cxa;
			if (msz > 7) {msz = 0; pms1++;}
			if (*pms1 & (1 << msz)) {
			    Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, cxa);
			    km += cxa;
			}
			l = lx;
			pws0++; msz++;
			while (l > 0) {
			  kmg += 0x7ff;
			  if (msz > 7) {msz = 0; pms1++;}
			  if (*pms1 & (1 << msz)) {
			    b += (*pws0 << 11) & 0xf800; 
			    g += (*pws0 << 5) & 0xfc00; 
			    r += *pws0 & 0xf800; 
			    km += 0x7ff;
			  }
			  l--; pws0++; msz++;
			}
			kmg += cxe;
			if (msz > 7) {msz = 0; pms1++;}
			if (*pms1 & (1 << msz)) {
			    Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, cxe);
			    km += cxe;
			}

		    pms0n += kms;
		    pms1 = pms0n;
		    msz = xa & 0x07;
		}

		pws0 += loff_x;
		k = (cxa * cye) >> 11;
		kmg += k;
		if (msz > 7) {msz = 0; pms1++;}
		if (*pms1 & (1 << msz)) {
		    Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, k);
		    km += k;
		}
		pws0++; msz++;
		while (lx > 0) {
		    kmg += cye;
		    if (msz > 7) {msz = 0; pms1++;}
		    if (*pms1 & (1 << msz)) {
			Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, cye);
			km += cye;
		    }
		    lx--; pws0++; msz++;
		}
		k = (cxe * cye) >> 11;
		kmg += k;
		if (msz > 7) {msz = 0; pms1++;}
		if (*pms1 & (1 << msz)) {
		    Timg_rsz16xx11_rgb_n(*pws0, &r, &g, &b, k);
		    km += k;
		}

		if (km == kmg) {
		    *pwd = ((((r >> 4) * kmul) >> 16) & 0xf800) | 
			   ((((g >> 4) * kmul_g) >> 21) & 0x7e0) | 
			   ((((b >> 4) * kmul) >> 27) & 0x1f);
		    md |= (1 << mdz);
		} else if ((km*2) > kmg) {
		    k = (kmg << 6) / km;
		    r = (r >> 6) * k;
		    g = (g >> 6) * k;
		    b = (b >> 6) * k;
		    *pwd = ((((r >> 4) * kmul) >> 16) & 0xf800) | 
			   ((((g >> 4) * kmul_g) >> 21) & 0x7e0) | 
			   ((((b >> 4) * kmul) >> 27) & 0x1f);
		    md |= (1 << mdz);
		} else {
		    *pwd = 0;
		}

		mdz++;
		if (mdz > 7) {*pmd0 = md; mdz = md = 0; pmd0++;}
		kw0 += kw;
		pwd++; x--;
	    }
	    if (mdz) {*pmd0 = md; pmd0++;}
	    kh0 += kh;
	    pwd += d_eoff;
	    pmd += kmd;
	    y--;
	}
	return 0;
}



/* ************ Zoom 24bpp 1:XXX ************ */

static void inline Timg_rsz24xx11_rgb_n(dword cw, dword *r, dword *g, dword *b, dword k) {
	*b += ((cw & 0xff) * k) >> 3;
	*g += (((cw >> 8) & 0xff) * k) >> 3;
	*r += (((cw >> 16) & 0xff) * k) >> 3;
}

int _rsz24_xx_11(Timg_rsz *rsz) {

  dword *pws = rsz->src_dat;
  dword *pwd = rsz->dest_dat;
  dword org_w = rsz->src_w;
  dword org_h = rsz->src_h;
  dword new_w = rsz->to_w;
  dword new_h = rsz->to_h;

  dword k, kw, kw0, kh, kh0, kmul;
  dword x, y;
  dword r, g, b;
  dword xa, ye, cya, cye, ya0, cxa, cxe;
  dword *pwsy, *pws0, *pws1;
  int lx, l, ly, yn;

/* return 1  = ERROR: img kleiner 2x2 bixel */
	if ((new_w < 2) || (new_h < 2)) return rszERR_LE2x2Pixel;

	kw = (org_w << 16) / new_w;
	kh = (org_h << 16) / new_h;

/* return 2  = ERROR: Zoom > 1:255 */
	if ((kw > 0x00ffffff) && (kh > 0x00ffffff)) return rszERR_ZoomGT255;

	if ((kw == 0x00010000) && (kh == 0x00010000)) return ImgDat_Copy(rsz);
	if ((kw == 0x00020000) && (kh == 0x00020000)) return ImgDat_Resize_22_11(rsz);

	if (((kw + kh) < 0x001fffff)) {
		k = ((kw >> 4) * (kh >> 4)) >> 16;
	} else {
		k = ((kw >> 8) * (kh >> 8)) >> 8;
	}
	kmul = 0x1003ffff / k;
// printf("w=%d/%d h=%d/%d kw=%x kh=%x k=%x kmul=%x\n", org_w, new_w, org_h, new_h, kw, kh, k, kmul);

	if (((kw*new_w)>>16) == org_w) kw--;
	if (((kh*new_h)>>16) == org_h) kh--;

	kh0 = 0;
	pws0 = pws;
	y = new_h;
	while (y) {
	    ya0 = kh0>>16;
	    ye = (kh0+kh)>>16;
	    pwsy = pws + (org_w * ya0);
	    ly = ye - ya0 - 1;

	    kw0 = 0;
		cya = (0xffff - (kh0 & 0xffff)) >> 5;
		cye = ((kh0+kh) & 0xffff) >> 5;

	    x = new_w;
	    while (x) {
		cxa = (0xffff - (kw0 & 0xffff)) >> 5;
		cxe = ((kw0+kw) & 0xffff) >> 5;
		xa = kw0>>16;
		lx = ((kw0+kw)>>16) - xa - 1;
		pws0 = pwsy + xa;

		pws1 = pws0;
		k = (cxa * cya) >> 11;
		b = ((*pws1 & 0xff) * k) >> 3; 
		g = (((*pws1 >> 8) & 0xff) * k) >> 3; 
		r = (((*pws1 >> 16) & 0xff) * k) >> 3;
		pws1++;
		l = lx;
		while (l > 0) {
			Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, cya);
			l--; pws1++;
		}
		Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, (cxe * cya) >> 11);

		yn = ly;
		while (yn > 0) {
			yn--;
			pws0 += org_w;

			pws1 = pws0;
			Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, cxa);
			l = lx;
			pws1++;
			while (l > 0) {
			    b += (*pws1 & 0xff) << 8;
			    g += *pws1 & 0xff00;
			    r += (*pws1  & 0xff0000) >> 8;
			    l--; pws1++;
			}
			Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, cxe);
		}

		pws0 += org_w;

		pws1 = pws0;
		Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, (cxa * cye) >> 11);
		pws1++;
		while (lx > 0) {
			Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, cye);
			lx--; pws1++;
		}
		Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, (cxe * cye) >> 11);

		*pwd = ((((r >> 4) * kmul) >> 8) & 0xff0000) | 
			((((g >> 4) * kmul) >> 16) & 0xff00) | 
			((((b >> 4) * kmul) >> 24) & 0xff);
		kw0 += kw;
		pwd++; x--;
	    }
	    kh0 += kh;
	    y--;
	}
	return 0;
}

/* ************ Zoom 24bpp + mask 1:XXX ************ */
 
static int _rsz24m_xx_11(Timg_rsz *rsz) {

  dword *pws = rsz->src_dat;
  dword *pwd = rsz->dest_dat;
  dword org_w = rsz->src_w;
  dword org_h = rsz->src_h;
  dword new_w = rsz->to_w;
  dword new_h = rsz->to_h;
  byte *pms = rsz->src_mask;
  byte *pmd = rsz->dest_mask;

  dword k, kw, kw0, kh, kh0, kmul;
  dword x, y;
  dword r, g, b;
  dword xa, ye, cya, cye, ya0, cxa, cxe;
  dword *pwsy, *pws0, *pws1;
  int lx, l, ly, yn;
  int kms, kmd, md, msz, mdz, km, kmg;
  byte *pms0, *pms0n, *pms1, *pmd0;

/* return 1  = ERROR: img kleiner 2x2 bixel */
	if ((new_w < 2) || (new_h < 2)) return rszERR_LE2x2Pixel;

	kw = (org_w << 16) / new_w;
	kh = (org_h << 16) / new_h;

/* return 2  = ERROR: Zoom > 1:255 */
	if ((kw > 0x00ffffff) && (kh > 0x00ffffff)) return rszERR_ZoomGT255;
	if ((kw == 0x00010000) && (kh == 0x00010000)) return ImgDat_Copy(rsz);
	if ((kw == 0x00020000) && (kh == 0x00020000)) return ImgDat_Resize_22_11(rsz);


	if (((kw + kh) < 0x001fffff)) {
		k = ((kw >> 4) * (kh >> 4)) >> 16;
	} else {
		k = ((kw >> 8) * (kh >> 8)) >> 8;
	}
	kmul = 0x1003ffff / k;
// printf("w=%d/%d h=%d/%d kw=%x kh=%x k=%x kmul=%x\n", org_w, new_w, org_h, new_h, kw, kh, k, kmul);

	if (((kw*new_w)>>16) == org_w) kw--;
	if (((kh*new_h)>>16) == org_h) kh--;

	kms = (org_w+7) / 8;
	kmd = (new_w+7) / 8;
	kh0 = 0;
	pws0 = pws;
	y = new_h;
	while (y) {
	    mdz = md = 0;
	    pmd0 = pmd;

	    ya0 = kh0>>16;
	    ye = (kh0+kh)>>16;
	    pwsy = pws + (org_w * ya0);
	    pms0 = pms + (kms * ya0);
	    ly = ye - ya0 - 1;

	    kw0 = 0;
	    cya = (0xffff - (kh0 & 0xffff)) >> 5;
	    cye = ((kh0+kh) & 0xffff) >> 5;

	    x = new_w;
	    while (x) {
		km = b = g = r = 0;

		cxa = ((0xffff - (kw0 & 0xffff)) >> 5);
		cxe = (((kw0+kw) & 0xffff) >> 5);
		xa = kw0>>16;
		pms0n = pms0 + (xa >> 3);
		pms1 = pms0n;
		msz = xa & 0x07;

		lx = ((kw0+kw)>>16) - xa - 1;
		pws0 = pwsy + xa;

		pws1 = pws0;
		if (msz > 7) {msz = 0; pms1++;}
		k = ((cxa * cya) >> 11);
		kmg = k;
		if (*pms1 & (1 << msz)) {
		  b = ((*pws1 & 0xff) * k) >> 3; 
		  g = (((*pws1 >> 8) & 0xff) * k) >> 3; 
		  r = (((*pws1 >> 16) & 0xff) * k) >> 3;
		  km = k;
		}
		pws1++; msz++;
	
		l = lx;
		while (l > 0) {
		    kmg += cya;
		    if (msz > 7) {msz = 0; pms1++;}
		    if (*pms1 & (1 << msz)) {
			Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, cya);
			km += cya;
		    }
		    l--; pws1++;
		    msz++;
		}
		k = (cxe * cya) >> 11;
		kmg += k;
		if (msz > 7) {msz = 0; pms1++;}
		if (*pms1 & (1 << msz)) {
		    Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, k);
		    km += k;
		}
		pms0n += kms;
		pms1 = pms0n;
		msz = xa & 0x07;

		yn = ly;
		while (yn > 0) {
			yn--;
			pws0 += org_w;

			pws1 = pws0;
			kmg += cxa;
			if (msz > 7) {msz = 0; pms1++;}
			if (*pms1 & (1 << msz)) {
			    Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, cxa);
			    km += cxa;
			}
			l = lx;
			pws1++; msz++;
			while (l > 0) {
			  kmg += 0x7ff;
			  if (msz > 7) {msz = 0; pms1++;}
			  if (*pms1 & (1 << msz)) {
			    b += (*pws1 & 0xff) << 8;
			    g += *pws1 & 0xff00;
			    r += (*pws1  & 0xff0000) >> 8;
			    km += 0x7ff;
			  }
			    l--; pws1++; msz++;
			}
			kmg += cxe;
			if (msz > 7) {msz = 0; pms1++;}
			if (*pms1 & (1 << msz)) {
			    Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, cxe);
			    km += cxe;
			}
		    pms0n += kms;
		    pms1 = pms0n;
		    msz = xa & 0x07;
		}

		pws0 += org_w;

		pws1 = pws0;
		k = (cxa * cye) >> 11;
		kmg += k;
		if (msz > 7) {msz = 0; pms1++;}
		if (*pms1 & (1 << msz)) {
		    Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, k);
		    km += k;
		}
		pws1++; msz++;
		while (lx > 0) {
		    kmg += cye;
		    if (msz > 7) {msz = 0; pms1++;}
		    if (*pms1 & (1 << msz)) {
			Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, cye);
			km += cye;
		    }
		    lx--; pws1++; msz++;
		}
		k = (cxe * cye) >> 11;
		kmg += k;
		if (msz > 7) {msz = 0; pms1++;}
		if (*pms1 & (1 << msz)) {
		    Timg_rsz24xx11_rgb_n(*pws1, &r, &g, &b, k);
		    km += k;
		}

		if (km && ((km*2) > kmg)) {
		    if (km < kmg) {
			k = (kmg << 6) / km;
			r = (r >> 6) * k;
			g = (g >> 6) * k;
			b = (b >> 6) * k;
		    }
		    *pwd = ((((r >> 4) * kmul) >> 8) & 0xff0000) | 
			   ((((g >> 4) * kmul) >> 16) & 0xff00) | 
			   ((((b >> 4) * kmul) >> 24) & 0xff);
		    md |= (1 << mdz);
		} else {
		    *pwd = 0;
		}

		mdz++;
		if (mdz > 7) {*pmd0 = md; mdz = md = 0; pmd0++;}
		kw0 += kw;
		pwd++; x--;
	    }
	    if (mdz) {*pmd0 = md; pmd0++;}
	    kh0 += kh;
	    pmd += kmd;
	    y--;
	}
	return 0;
}


int ImgDat_Resize_XX_11(Timg_rsz *rsz) {
	if (rsz->src_typ == pxm_2b_16bpp) {
	    if (rsz->src_mask && rsz->dest_mask) {
		return _rsz16m_xx_11(rsz);
	    } else {
		return _rsz16_xx_11(rsz);
	    }
	} else if (rsz->src_typ == pxm_4b_24bpp) {
	    if (rsz->src_mask && rsz->dest_mask) {
		return _rsz24m_xx_11(rsz);
	    } else {
		return _rsz24_xx_11(rsz);
	    }
	}
	return rszERR_Zoom;
}
