/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include <errno.h>
#include <fcntl.h>

TappDat IappDat;

TappDat *appDat;

#ifdef MEM_CHK
#ifdef MEM_CHKappAZ
int LastMEM_CHK_Count;
bool MEM_AZ_Disable = False;
#endif
#endif

#ifdef TEST_NOTIFY_TIME
dword test_notify_us = 0;
dword test__us = 0;
static dword az_notify_us;
#endif

#include <windows.h>

bool ChkDirMkDirElseExit(char *s) {
  bool res = (access(s, F_OK) == 0);

	if (!res) file_mkdir_erl(s, 0, EMSG_ERR_EXIT);

	return res;
}

void initapp(int fu, int argc, char **argv) {
	app_name = *argv;

	appDat = &IappDat;
	Fill0(appDat, sizeof(TappDat));

//	SetCPU_Flags(NULL);
#ifdef TEST_NOTIFY_TIME
	az_notify_us = GetTime_us();
#endif
}

bool AppProcessMessages() {
	if (appDat->X11DispatchEvent) appDat->X11DispatchEvent();
//	if (appDat->UserAppEvent) appDat->UserAppEvent();
	if (appDat->TimerDispatch) appDat->TimerDispatch();
	if (appDat->gQUIT_Ev) return False;
	if (appDat->Wins_PaintOnEvEnd) appDat->Wins_PaintOnEvEnd();
	return True;
}

bool AppHandleMessage() {
  dword wres;
  bool ret;
  TEv_Array *pev, **ppev;

	wres = MsgWaitForMultipleObjectsEx(0, NULL, 10, QS_ALLINPUT, 0);
// printf("%s(%d): t=%dms\n", FL, GetTime_ms());

	appDat->app_us = GetTime_us();
	ret = AppProcessMessages();

	if (appDat->appEv_Array) {
	    pev = appDat->appEv_Array;
	    ppev = &appDat->appEv_Array;
	    while (pev) {
		if (pev->On_appEv) {
			pev->On_appEv(pev);
			ppev = &pev->next;
			pev = pev->next;
		} else {
			*ppev = pev->next;
			xfree(pev);
			pev = *ppev;
		}
	    }
	}

#ifdef MEM_CHK
#ifdef MEM_CHKappAZ
	if (!MEM_AZ_Disable) {
  int lMCt, lMsize;
	    MEM_CHK_Count(&lMCt, &lMsize);
	    if (LastMEM_CHK_Count != lMCt) {
		    LastMEM_CHK_Count = lMCt;
    printf("Debug %s(%d): MEM_CHK_Count=%3d  size=%d\n", FL, lMCt, lMsize);
	    }
	}
#endif
#endif
#ifdef TEST_NOTIFY_TIME
	if (GetCurTimeDiv_us(az_notify_us) > 10000000) {
	    printf("Debug %s(%d): notify_us=%uus  t2=%uus\n", FL, test_notify_us, test__us);
	    az_notify_us = GetTime_us();
	    test_notify_us = 0;
	    test__us = 0;
	}
#endif
	return ret;
}



