/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appbase.h"
#include <fcntl.h>

bool ChkAppRun(char *fn, int fu, char **ppc) {
  int lg;
  int fd;
  TSearch_Rec sr;
  char pidnr[16];
  char line[1024];
  char tmpf[4096];
  char *tmpfn;
  char *appfn = GetFileName_pc(fn);

	snprintf(pidnr, sizeof(pidnr), "%d", IappDat.self_pid);
	Fill0(&sr, sizeof(TSearch_Rec));
	sr.path = "/proc/";
	sr.findAtr = findDIR;
	sr.statfu = fsNoFileName | fsNoLinkName;

	if (Find_First(&sr)) {
	  while (Find_Next(&sr)) {
	    if ((sr.ret_entry->d_name[0] >= '1') && 
		(sr.ret_entry->d_name[0] <= '9') &&
		(!pccmp(sr.ret_entry->d_name, pidnr))) {

		lg = 0;
		if (fu & carfu_cmd) {
		  snprintf(line, sizeof(line), "/proc/%s/cmdline", sr.ret_entry->d_name);
		  fd = open(line, O_RDONLY);
		  if (fd > 0) {
		    lg = read(fd, tmpf, sizeof(tmpf));
		    close(fd); 
		  }
		} else {
		  snprintf(line, sizeof(line), "/proc/%s/exe", sr.ret_entry->d_name);
		  lg = readlink(line, tmpf, sizeof(tmpf));
		}
		if (lg > 0) {
		    tmpf[lg] = 0;
		    tmpfn = GetFileName_pc(tmpf);
		    if (pccmp(appfn, tmpfn)) {
			if (ppc) {
			    snprintf(line, sizeof(line), "/proc/%s/", sr.ret_entry->d_name);
			    *ppc = pcdup(line);
			}
			Find_Close(&sr);
			return True;
		    }
	        }
	    }
	  }
	}
	return False;
}
