/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appbase.h"
#include "pthd_pv.h"

/* _______________________ MSG_ErrMSG ________________________________ */

void pthd_MSGerr_to(Tpthd_MSG_Obj *MSG_Obj, int ErrType, char *msg, ...) {
  Tpthread_mmMSG *mmMSG;
  va_list args;
  char line[2048];
  int bef = thdMSG_Err;

	va_start(args, msg);
	vsnprintf(line, 2048, msg, args);
	va_end(args);

	if (ErrType & EMSG_GetResult) bef |= thdMSG_rv;
	mmMSG = pthd_mmMSG_str(MSG_Obj, bef, line);
	if (!mmMSG) return;
	mmMSG->msg.tag = ErrType;
	mmMSG->msg.wtyp = wtyp_Tpthd_msgErr;
	Tpthread_mmMSG_to(MSG_Obj, mmMSG);
}

void pt_send_Merr(Tpthd *pthd, int msg_typ, char *msg, ...) {
  va_list args;
  Tpthd_MSG_Obj *MSG_Obj = NULL;
  char *pc;
  char line[2048];

	va_start(args, msg);
	vsnprintf(line, 2048, msg, args);
	va_end(args);
	if ((msg_typ & EMSG_SYS) && !(msg_typ & EMSG_NOSYS)) {
	    pc = pcdup(line);
	    snprintf(line, 2048, "%s [%s]", pc, SysError_pc());
	    msg_typ &= ~EMSG_SYS;
	    xfree(pc);
	}

	if (pthd && (pthd->wtyp == wtyp_Tpthd)) {
	    if (pthd->pthd_id == pthread_self()) {
		MSG_Obj = pthd->pthd2app;
	    } else if (appDat->self_pid == getpid()) {
		MSG_Obj = pthd->app2pthd;
	    }
	}

	if (MSG_Obj) {
	    pthd_MSGerr_to(MSG_Obj, msg_typ, line);
	} else {
	    appError(msg_typ, line);
	}
}

