/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "pthd_pv.h"

static Tpthd_MSG_Obj *appMSG_Obj = NULL;

/*________________ create app Tpthd_MSG_Buffer _______________________*/
void Tpthd_MSG_Buffer_App_Ev() {
  Tpthd_MSG_Obj *ev_MSG_Obj;
  Tpthd_MSG_Buffer *MSG_Buf;
  Tpthread_mmMSG *mmMSG, **ppmmMSG;
  Tpthd_msg *msg;
  int res;
  bool mmMSG_free = True;

	if (!appMSG_Obj || !appMSG_Obj->MSG_Buf) return;
	MSG_Buf = appMSG_Obj->MSG_Buf;
	if (!MSG_Buf->mmMSG) return; //goto ChkSendEv;

	pthread_mutex_lock(&MSG_Buf->mutex);
	mmMSG = MSG_Buf->mmMSG;
	if (mmMSG) {
	    MSG_Buf->mmMSG = mmMSG->next;
	    if (mmMSG->next) IappDat.appFu |= appFu_select_t0_single;
	    mmMSG->stat |= 1;   //msg is to send
	    if (mmMSG->stat & 0x02) {
		mmMSG->next = NULL;
		ppmmMSG = &MSG_Buf->ret_mmMSG;
		while (*ppmmMSG) ppmmMSG = &(*ppmmMSG)->next;
		*ppmmMSG = mmMSG;
		mmMSG_free = False;
	    }
	}
	pthread_mutex_unlock(&MSG_Buf->mutex);
	if (!mmMSG) return; // goto ChkSendEv;

	msg = &mmMSG->msg; //(Tpthd_msg*)&mmMSG->thdMSG[0];
	res = 0;

	ev_MSG_Obj = MSG_Buf->regobj;
	while (ev_MSG_Obj && (ev_MSG_Obj != mmMSG->MSG_Obj)) {
	    ev_MSG_Obj = ev_MSG_Obj->next;
// printf("%s(%d): 0x%x 0x%x\n", FL, (int)mmMSG->On_MSG_Ev, (int)ev_MSG_Obj->On_MSG_Ev);
	}
	if (ev_MSG_Obj) {
	    if (ev_MSG_Obj->OnMSG) res = ev_MSG_Obj->OnMSG(msg);
	}
	msg->ret = res;

	if (!res) {
	    if (msg->wtyp == wtyp_Tpthd_msgErr) {
		appError(msg->tag, ((Tpthd_msgStr*)msg)->data);
	    }
	}
	mmMSG->stat |= 0x04;   //msg to thread return Ok
	if (mmMSG_free) xfree(mmMSG);
}

Tpthd_MSG_Obj *Tpthd_MSG_Buffer_App_Get() {
	if (!appMSG_Obj) {
	    appMSG_Obj = Tpthd_MSG_AppToPthd_Create(0, NULL);
	    IappDat.MSG_Buf_Ev = Tpthd_MSG_Buffer_App_Ev;
	}
	return appMSG_Obj;
}
