/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "pthd_pv.h"


void Tpthd_MSG_registration(Tpthd_MSG_Obj *MSG_Obj) {
  Tpthd_MSG_Obj **rgo;

	if (!MSG_Obj->MSG_Buf) return;
	rgo = &MSG_Obj->MSG_Buf->regobj;
	while (*rgo && (*rgo != MSG_Obj)) rgo = &(*rgo)->next;
	MSG_Obj->aktiv = True;
	if (!*rgo) {
	    *rgo = MSG_Obj;
	    MSG_Obj->next = NULL;
// printf("%s(%d): 0x%x registration NEW\n", FL, (int)MSG_Obj);
	} else {
// printf("%s(%d): 0x%x registration Aktiv\n", FL, (int)MSG_Obj);
	}
	MSG_Obj->MSG_Buf->SlaveRun = True;
}

void Tpthd_MSG_deregister(Tpthd_MSG_Obj *MSG_Obj) {
  Tpthd_MSG_Obj **rgo;
  Tpthd_MSG_Buffer *MSG_Buf;
  Tpthread_mmMSG *mmMSG, **ppmmMSG;

	if (!MSG_Obj) return;
	MSG_Buf = MSG_Obj->MSG_Buf;
	if (!MSG_Buf) return;

	pthread_mutex_lock(&MSG_Buf->mutex);
	MSG_Obj->aktiv = False;

	rgo = &MSG_Buf->regobj;
	while (*rgo && (*rgo != MSG_Obj)) rgo = &(*rgo)->next;
	if (*rgo) *rgo = MSG_Obj->next;
	MSG_Obj->next = NULL;

	if (!MSG_Buf->regobj) {
	    MSG_Buf->SlaveRun = False;
	}
// printf("%s(%d): 0x%x deregister\n", FL, (int)MSG_Obj);

	ppmmMSG = &MSG_Buf->mmMSG;
	while (*ppmmMSG) {
	    mmMSG = *ppmmMSG;
	    if ((mmMSG->MSG_Obj == MSG_Obj) && !(mmMSG->stat & 1)) {
		*ppmmMSG = mmMSG->next;
		xfree(mmMSG);
	    } else ppmmMSG = &mmMSG->next;
	}

	pthread_mutex_unlock(&MSG_Obj->MSG_Buf->mutex);
}


void *Tpthread_mmMSG_Creat_size(Tpthd_MSG_Obj *MSG_Obj, 
	                        void **ppthdMSG,
				int bef, int size) {

  Tpthread_mmMSG *mmMSG;
  Tpthd_msg *thdMSG;
	mmMSG = xcalloc(sizeof(Tpthread_mmMSG) + size);
	mmMSG->MSG_Obj = MSG_Obj;
	thdMSG = &mmMSG->msg;
	thdMSG->wtyp = wtyp_Tpthd_msg;
	thdMSG->size = size;
	thdMSG->bef = bef;
	thdMSG->wtyp_obj = MSG_Obj->wtyp_obj;
	thdMSG->obj = MSG_Obj->obj;
	thdMSG->org_msg = MSG_Obj->last_msg;
	if (ppthdMSG) *ppthdMSG = thdMSG;
	if (bef & thdMSG_rv) mmMSG->stat = pthMsgStat_RetMsg;  //msg to thread return
	if (bef & thdMSG_NoSyncEv) mmMSG->stat |= pthMsgStat_NoSyncEv;
	return mmMSG;
}

int Tpthread_mmMSG_to(Tpthd_MSG_Obj *MSG_Obj, void *pthd_mmMSG) {
  Tpthread_mmMSG *mmMSG, *mmMSGn, **ppMSG;
  Tpthd_MSG_Buffer *MSG_Buf;
  Tpthd *pthd;
  bool PthdToApp;

	if (!MSG_Obj || !MSG_Obj->MSG_Buf) return 0;
	pthd = MSG_Obj->pthd;
	PthdToApp = pthd && !MSG_Obj->AppToPthd;

// printf("%s(%d): 0x%x\n", FL, MSG_Obj->pthd);
	if (PthdToApp && pthd->ret_mmMSG) {
	    xfree(pthd->ret_mmMSG->msg.ret_msg);
	    xfree(pthd->ret_mmMSG);
	    pthd->ret = 0;
	    pthd->ret_mmMSG = NULL;
	}

	MSG_Buf = MSG_Obj->MSG_Buf;
	pthread_mutex_lock(&MSG_Buf->mutex);
	if (MSG_Buf->mmMSG) {
	    mmMSG = MSG_Buf->mmMSG;
	    while (mmMSG->next) mmMSG = mmMSG->next;
	    mmMSG->next = pthd_mmMSG;
	} else {
	    MSG_Buf->mmMSG = pthd_mmMSG;
	}
	mmMSG = pthd_mmMSG;
	if (PthdToApp && !(mmMSG->stat & pthMsgStat_NoSyncEv)) {
	    pthd->MsgToApp = True;
	}

	pthread_mutex_unlock(&MSG_Buf->mutex);

	if (!PthdToApp) return 0;

// printf("%s(%d): 0x%x\n", FL, mmMSG->stat);
	if (!(mmMSG->stat & pthMsgStat_RetMsg)) return 0;

// printf("%s(%d): 0x%x\n", FL, MSG_Obj->AppToPthd);

loop:
	if (!pthd->run) longjmp(pthd->ptAbort, 0);

	pthread_mutex_lock(&MSG_Buf->mutex);
	ppMSG = &MSG_Obj->MSG_Buf->ret_mmMSG;
	while (*ppMSG && (*ppMSG != mmMSG)) ppMSG = &(*ppMSG)->next;
	if (!*ppMSG || !((*ppMSG)->stat & pthMsgStat_RetMsgOk)) {
	    pthread_mutex_unlock(&MSG_Buf->mutex);
	    usleep(4000);
	    goto loop;
	}
	mmMSGn = *ppMSG;
	*ppMSG = mmMSGn->next;
	pthread_mutex_unlock(&MSG_Buf->mutex);

	pthd->ret = mmMSG->msg.ret;
	if (mmMSG->msg.bef & thdMSG_rv_mmMSG_free) {
	    xfree(mmMSGn);
	} else {
	    pthd->ret_mmMSG = mmMSGn;
	}
	return pthd->ret;
}

static bool Chk_MSG_Obj(Tpthd_MSG_Obj *MSG_Obj) {
	return (MSG_Obj && MSG_Obj->aktiv &&  
		MSG_Obj->MSG_Buf && MSG_Obj->MSG_Buf->SlaveRun);
}

/* _______________________ MSG _______________________________________ */
int pthd_MSG_to(Tpthd_MSG_Obj *MSG_Obj, int bef) {
  Tpthread_mmMSG *mmMSG;
	if (!Chk_MSG_Obj(MSG_Obj)) return 0;
	mmMSG = Tpthread_mmMSG_Creat_size(MSG_Obj, NULL, bef, sizeof(Tpthd_msg));
	return Tpthread_mmMSG_to(MSG_Obj, mmMSG);
}

int pthd_MSG_v3_to(Tpthd_MSG_Obj *MSG_Obj,
			 int bef, int tag, int org_msg) {
  Tpthread_mmMSG *mmMSG;
  Tpthd_msg *thdMSG;
	if (!Chk_MSG_Obj(MSG_Obj)) return 0;
	mmMSG = Tpthread_mmMSG_Creat_size(MSG_Obj, (void*)&thdMSG, bef, sizeof(Tpthd_msg));
	thdMSG->tag = tag;
	thdMSG->org_msg = org_msg;
	return Tpthread_mmMSG_to(MSG_Obj, mmMSG);
}

/* _______________________ MSG Data __________________________________ */
int pthd_MSGxxxx_v3_to(Tpthd_MSG_Obj *MSG_Obj,
				int bef, int tag, int org_msg,
				int wtyp, void *Data, int lg) {
  Tpthread_mmMSG *mmMSG;
  Tpthd_msg_t *thdMSG;

	if (!Chk_MSG_Obj(MSG_Obj)) return 0;
	mmMSG = Tpthread_mmMSG_Creat_size(MSG_Obj, (void*)&thdMSG,
			 bef, sizeof(Tpthd_msg) + lg);
	thdMSG->wtyp = wtyp;
	thdMSG->tag = tag;
	thdMSG->org_msg = org_msg;
	if (Data && (lg > 0)) pnmove(thdMSG->t, Data, lg);
	return Tpthread_mmMSG_to(MSG_Obj, mmMSG);
}

/* _______________________ Send MSG _________________________________ */
int pt_send_M(Tpthd *pthd, int bef) {
	return pthd_MSG_to(getMSG_Obj(pthd), bef);
}

int pt_send_Mt(Tpthd *pthd, int bef, int tag) {
	return pthd_MSG_v3_to(getMSG_Obj(pthd), bef, tag, 0);
}

int pt_send_Data(Tpthd *pthd, int msg, void *data, int lg) {
	return pthd_MSGxxxx_v3_to(getMSG_Obj(pthd), msg, 0, 0, 
			wtyp_Tpthd_msgData, data, lg);
}

/* _______________________ Get_MSG ___________________________________ */

Tpthd_msg *pthd_Get_MSG(Tpthd_MSG_Obj *MSG_Obj) {
  Tpthread_mmMSG *mmMSG;
  Tpthd_msg *msg;
  Tpthd_msg *thdMSG;

	if (!MSG_Obj || !MSG_Obj->MSG_Buf || !MSG_Obj->MSG_Buf->mmMSG) return NULL;
	mmMSG = MSG_Obj->MSG_Buf->mmMSG;
	msg = &mmMSG->msg; // (Tpthd_msg*)&mmMSG->thdMSG[0];
	thdMSG = xmalloc(msg->size);
	pnmove(thdMSG, msg, msg->size);
	pthread_mutex_lock(&MSG_Obj->MSG_Buf->mutex);
	MSG_Obj->MSG_Buf->mmMSG = mmMSG->next;
	pthread_mutex_unlock(&MSG_Obj->MSG_Buf->mutex);
	MSG_Obj->last_msg = msg->bef;
	xfree(mmMSG);
	return thdMSG;
}

Tpthd_MSG_Obj REGPARM3_FUNC *getMSG_Obj(Tpthd *pthd) {
  Tpthd_MSG_Obj *MSG_Obj = NULL;
	if (pthd && (pthd->wtyp == wtyp_Tpthd)) {
	    if (pthd->pthd_id == pthread_self()) {
		MSG_Obj = pthd->pthd2app;
	    } else if (IappDat.self_pid == getpid()) {
		MSG_Obj = pthd->app2pthd;
	    }
	}
	return MSG_Obj;
}

/*_____________________________ Destroy _________________________________*/
static bool Tpthd_MSG_Buffer__Destroy(Tpthd_MSG_Buffer *self) {
	self->SlaveRun = False;
	pthread_mutex_lock(&self->mutex);
	while (self->mmMSG) {
	    Tpthread_mmMSG *mmMSG = self->mmMSG;
	    self->mmMSG = mmMSG->next;
	    xfree(mmMSG);
	}
	pthread_mutex_unlock(&self->mutex);
	pthread_mutex_destroy(&self->mutex);
	return False;
}

static bool Tpthd_MSG_BufObj__Destroy(Tpthd_MSG_Obj *self) {
	Tpthd_MSG_deregister(self);
	Tfree(self->MSG_Buf);
	return False;
}

static bool Tpthd_MSG_SubObj__Destroy(Tpthd_MSG_Obj *self) {
	Tpthd_MSG_deregister(self);
	return False;
}

/*_____________________________ Create __________________________________*/
Tpthd_MSG_Buffer *Tpthd_MSG_Buffer_Create() {
  Tpthd_MSG_Buffer *self;

	self = ttc_create(sizeof(Tpthd_MSG_Buffer), wtyp_Tpthd_MSG_Buf);
	self->destroy = (TDESTROY)Tpthd_MSG_Buffer__Destroy;
//	self->self_THD = pthread_self();
	self->SlaveRun = True;
	pthread_mutex_init(&self->mutex, NULL);
	return self;
}

static Tpthd_MSG_Obj *Tpthd_MSG_Obj_Create(Tpthd_MSG_Buffer *MSG_Buf, 
					int wtyp_obj, void *obj) {
  Tpthd_MSG_Obj *self;

	self = ttc_create(sizeof(Tpthd_MSG_Obj), wtyp_Tpthd_MSG_Obj);
	self->MSG_Buf = MSG_Buf;
	self->wtyp_obj = wtyp_obj;
	self->obj = obj;
	return self;
}

Tpthd_MSG_Obj *Tpthd_MSG_AppToPthd_Create(int wtyp_obj, void *obj) {
  Tpthd_MSG_Obj *self;
	self = Tpthd_MSG_Obj_Create(NULL, wtyp_obj, obj);
	self->AppToPthd = True;
	self->destroy = (TDESTROY)Tpthd_MSG_BufObj__Destroy;
	self->MSG_Buf = Tpthd_MSG_Buffer_Create();
	Tpthd_MSG_registration(self);
	return self;
}

Tpthd_MSG_Obj *Tpthd_MSG_PthdToApp_Create(Tpthd_MSG_Obj *MSG_Obj, 
					int wtyp_obj, void *obj) {
  Tpthd_MSG_Obj *self;
	self = Tpthd_MSG_Obj_Create(MSG_Obj->MSG_Buf, wtyp_obj, obj);
	self->destroy = (TDESTROY)Tpthd_MSG_SubObj__Destroy;
	Tpthd_MSG_registration(self);
	return self;
}
