/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#ifndef	__PTHREAD_H__
#define	__PTHREAD_PV__    1

#include "app_pthread.h"

#define pthMsgStat_IsSend	1
#define pthMsgStat_RetMsg	(1<<1)
#define pthMsgStat_RetMsgOk	(1<<2)
#define pthMsgStat_NoSyncEv	(1<<3)

//#define PTH_SYNC_SIG SIGUSR1
#define PTH_SYNC_SIG SIGCHLD


typedef struct Tpthread_mmMSG {
  struct Tpthread_mmMSG *next;
  int stat;		//b0=1 = msg is to send
			//b1=1 = msg to thread return 
			//b2=1 = msg to thread return Ok
			//b3=1 = msg no sync ev (kill(pthd->app_pid, PTH_SYNC_SIG);)
  struct Tpthd_MSG_Obj *MSG_Obj;
  Tpthd_msg msg;
} Tpthread_mmMSG;

typedef struct Tpthd_MSG_Obj {
  AlgTTC0
  struct Tpthd_MSG_Obj *next;	//DO NOT edit this !!!!
  struct Tpthd_MSG_Buffer *MSG_Buf;
  int (*OnMSG)(Tpthd_msg *msg);
//  pthread_t msg_THD;
  struct Tpthd *pthd;
  int wtyp_obj;
  void *obj;
  int last_msg;
  bool aktiv;
  bool AppToPthd;
  bool bnc2;
  bool bnc3;
} Tpthd_MSG_Obj;

typedef struct Tpthd_MSG_Buffer {
  AlgTTC0
  Tpthread_mmMSG *mmMSG;
  Tpthread_mmMSG *ret_mmMSG;  //move mmMSG -> ret_mmMSG
  Tpthd_MSG_Obj *regobj;
//  pthread_t self_THD;
  pthread_mutex_t mutex;
  int fu;
  int wtyp_obj;
  void *obj;
  bool SlaveRun;
} Tpthd_MSG_Buffer;


extern Tpthd_MSG_Buffer *Tpthd_MSG_Buffer_Create();

extern Tpthd_MSG_Obj *Tpthd_MSG_AppToPthd_Create(int wtyp_obj, void *obj);

extern Tpthd_MSG_Obj *Tpthd_MSG_PthdToApp_Create(Tpthd_MSG_Obj *MSG_Obj, 
					int wtyp_obj, void *obj);

extern Tpthd_MSG_Obj REGPARM3_FUNC *getMSG_Obj(Tpthd *pthd);

extern void Tpthd_MSG_registration(Tpthd_MSG_Obj *MSG_Obj);
extern void Tpthd_MSG_deregister(Tpthd_MSG_Obj *MSG_Obj);


extern void *Tpthread_mmMSG_Creat_size(Tpthd_MSG_Obj *MSG_Obj, 
	                        void **ppthd_MSG,
				int bef, int size);

extern int Tpthread_mmMSG_to(Tpthd_MSG_Obj *MSG_Obj, void *pthd_mmMSG);

/*______________________________ Get_MSG ________________________________*/
extern Tpthd_msg *pthd_Get_MSG(Tpthd_MSG_Obj *MSG_Obj);

/*______________________________ MSG ____________________________________*/
extern int pthd_MSG_to(Tpthd_MSG_Obj *MSG_Obj, int bef);
extern int pthd_MSG_v3_to(Tpthd_MSG_Obj *MSG_Obj, int bef, int tag, int org_msg);

/* _______________________ MSG Data __________________________________ */
extern int pthd_MSGxxxx_v3_to(Tpthd_MSG_Obj *MSG_Obj,
				int bef, int tag, int org_msg,
				int wtyp, void *Data, int lg);

/*______________________________ MSG16B _________________________________*/
extern void pthd_MSG16B_v3_to(Tpthd_MSG_Obj *MSG_Obj,
			    int msg, int tag, int org_msg, 
			    TuMSG16B *MSG16B);
extern void pthd_MSG16B_to(Tpthd_MSG_Obj *MSG_Obj,
			 int msg, TuMSG16B *MSG16B);

/*______________________________ MSG32B _________________________________*/
extern void pthd_MSG32B_v3_to(Tpthd_MSG_Obj *MSG_Obj,
			    int msg, int tag, int org_msg, 
			    TuMSG32B *MSG32B);
extern void pthd_MSG32B_to(Tpthd_MSG_Obj *MSG_Obj,
			 int msg, TuMSG32B *MSG32B);

/*______________________________ MSG16B _________________________________*/
extern void pthd_MSG64B_v3_to(Tpthd_MSG_Obj *MSG_Obj,
			    int msg, int tag, int org_msg, 
			    TuMSG64B *MSG64B);
extern void pthd_MSG64B_to(Tpthd_MSG_Obj *MSG_Obj,
			 int msg, TuMSG64B *MSG64B);

/*______________________________ MSG_str ________________________________*/
extern Tpthread_mmMSG *pthd_mmMSG_str(Tpthd_MSG_Obj *MSG_Obj, int msg, char *s);

extern void pthd_MSGstr_to(Tpthd_MSG_Obj *MSG_Obj, int msg, char *s);
extern void pthd_MSGerr_to(Tpthd_MSG_Obj *MSG_Obj, int ErrType, char *msg, ...);
//Tpthread_mmMSG *pthd_rvMSGerr_to(Tpthd_MSG_Obj *MSG_Obj, int ErrType, char *msg, ...);

/*_______________________ app Tpthd_MSG_Buffer _______________________*/
extern Tpthd_MSG_Obj *Tpthd_MSG_Buffer_App_Get();


#endif /* __APP_PTHREAD_H__ */
