/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"

//************************** Timer ******************************************
dword gTimerEv_ms, gTimer_ms_old;
static TgTimer *gTimersX;
dword gTimerZ;

#ifndef _OS_WIN32
bool gTimerXNewEv;

void Ev_gTimer(int nonsense) {
//	gTimerEv_ms = GetTime_ms();
	gTimerZ++;
	gTimerXNewEv = True;
}
#endif /* ! _OS_WIN32 */

void gTimer_DispatchX() {
  int m, d; 
  dword gTimer_ms;
  TgTimer *gTimer;
  TgTimer *gTFree;
  bool LoopAkt;
#ifdef _OS_WIN32
	gTFree = NULL;
	gTimer_ms = GetTime_ms();
loop:
	d = gTimer_ms - gTimer_ms_old;
	if ((d >= 0) && (d < 10)) return;
	gTimerZ++;
#else
	if (!gTimerXNewEv) return;
	gTimerXNewEv = False;
	gTFree = NULL;
	gTimer_ms = IappDat.app_ms; //GetTime_ms();
loop:
	d = gTimer_ms - gTimer_ms_old;
#endif
	if (d > 30000) {
	    gTimer = gTimersX;
	    while (gTimer) {
		gTimer->Tmp_ms = gTimer->Tmp_ms + d;
		gTimer = gTimer->next;
	    }
	}
	LoopAkt = False;
	gTimer_ms_old = gTimer_ms;
	gTimer = gTimersX;
	while (gTimer) {

	    if (gTimer->func & Timer_Enabled) {
		m = gTimer_ms - (gTimer->Tmp_ms + gTimer->Interval);
		if (m >= 0) {
		    if (gTimer->func & Timer_Single) gTimer->func &= ~Timer_Enabled;
		    if (gTimer->func & Timer_NoLostOnTimer) {
			gTimer->Tmp_ms += gTimer->Interval;
			LoopAkt = True;
		    } else {
			gTimer->Tmp_ms = gTimer_ms;
		    }
		    if (gTimer->OnTimer && ((gTimer->intern_func & 0x01) == 0)) {
			gTimer->intern_func |= 0x01;
			gTimer->OnTimer(gTimer);
			gTimer->intern_func &= ~0x01;
		    }
		    if (gTimer->func & Timer_OnTimerAndFree) gTFree = gTimer;
		}
	    }
	    gTimer = gTimer->next;
	    if (gTFree) {
		Tfree(gTFree);
		gTFree = NULL;
	    }
	}
	if (LoopAkt) {
	    gTimer_ms = GetTime_ms();
	    goto loop;
	}
}

/*____________________________ Destroy __________________________________*/
bool TgTimer__Destroy(TgTimer *self) {
  TgTimer **ppgt;

	ppgt = &gTimersX;
	while (*ppgt && (*ppgt != self)) ppgt = &(*ppgt)->next;
	if (*ppgt) {
	    *ppgt = self->next;
	    if (self->intern_func & 0x01) {
// Test timer del on AppHandleMessage()
		self->func |= Timer_OnTimerAndFree;
		return True;
	    }
	}
	return False;
}

/*____________________________ Create ___________________________________*/
TgTimer *gTimerX_Add(dword func, dword Interval_ms, void (*OnTimer)(struct TgTimer*)) {
  TgTimer *self;

	if (!IappDat.TimerDispatch) gTimer_Init();
	self = ttc_create(sizeof(TgTimer), wtyp_TgTimer);
	self->destroy = (TDESTROY)TgTimer__Destroy;

	self->func = func;
	self->Interval = Interval_ms;
	self->OnTimer = OnTimer;
	self->next = gTimersX;
	gTimersX = self;
#ifdef _OS_WIN32
	self->Tmp_ms = GetTime_ms();
#else /* _OS_WIN32 */
	self->Tmp_ms = GetTime_ms();
#endif
	return self;
}

#ifdef _OS_WIN32
void gTimer_Init() {
	IappDat.TimerDispatch = gTimer_DispatchX;
	gTimerEv_ms = GetTime_ms();
	gTimer_ms_old = gTimerEv_ms;
}
#else /* _OS_WIN32 */
void gTimer_Init() {
  struct itimerval timeout;
  struct sigaction action;

	IappDat.TimerDispatch = gTimer_DispatchX;
	gTimerEv_ms = GetTime_ms();
	gTimer_ms_old = gTimerEv_ms;

	timeout.it_interval.tv_sec = 0;
	timeout.it_interval.tv_usec = 16667;
	timeout.it_value.tv_sec = 0;
	timeout.it_value.tv_usec = 16667;

	action.sa_handler = Ev_gTimer;
	sigemptyset(&action.sa_mask);
	action.sa_flags = SA_RESTART;
	signal(SIGALRM, Ev_gTimer);
	setitimer(ITIMER_REAL, &timeout, NULL); 
}
#endif /* ! _OS_WIN32 */

