/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <errno.h>

bool file_chmod(const char *fn, TNetErrRet *ErrRet, int mode) {
  bool result;

#ifdef _OS_WIN32
	word *wcf = get_pcw_filename(fn, del_path_end_slash);
	result = SetFileAttributesW(wcf, mode) == 0;
	xfree(wcf);
#else
	result = chmod(fn, mode) >= 0;
#endif
	if (!result && ErrRet) ErrRet->sys_errno = errno;
	return result;
}

bool file_chmod_gp(TglobPath *gp, TNetErrRet *ErrRet, int mode) {
  char *fn;
  bool result;
	fn = gptopc(gp, gptfu_del_slash|gptfu_noRootArt);
	result = file_chmod(fn, ErrRet, mode);
	xfree(fn);
	return result;
}
