/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

bool FileOpen_wr_mkdir_erl(const char *FileName, FileHandle *fd, mode_t mode, int err_level) {
  char *tmp, *pc;

	if (!fd) return False;
	tmp = tmp_ChkFileName(FileName, err_level);
	if (!tmp) return False;

	if (path_sub(tmp, &pc)) {
	    bool ok = file_mkdir_erl(pc, mode, err_level);
	    xfree(pc);
	    if (!ok) {
		xfree(tmp);
		return False;
	    }
	}
	return FileOpen_wr_erl(FileName, fd, mode, err_level);
}

bool FileOpen_wr_mkdir(const char *FileName, FileHandle *fd) {
	return FileOpen_wr_mkdir_erl(FileName, fd, 0, EMSG_ERR1);
}
