/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <errno.h>

bool file_mkdir(const char *fn, TNetErrRet *ErrRet, int mode) {
  bool result;

	if (!mode) mode = 0755;
#ifdef _OS_WIN32
	word *tmpwc = UTF8topwc(fn);
	result = CreateDirectoryW(tmpwc, NULL) != 0;
	xfree(tmpwc);
#else
	result = mkdir(fn, mode) == 0;
#endif
	if (!result && ErrRet) ErrRet->sys_errno = errno;
	return result;
}

bool file_mkdir_gp(TglobPath *gp, TNetErrRet *ErrRet, int mode) {
  char *fn;
  bool result;
	fn = gptopc(gp, gptfu_del_slash|gptfu_noRootArt);
	result = file_mkdir(fn, ErrRet, mode);
	xfree(fn);
	return result;
}
