/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"


FILE *file_stream_open(const char *FileName, const char *opentype) {
  charOS *fn;
  FILE *result;

	fn = path_to_local_OS(FileName);
	if (!fn) return NULL;
#ifdef _OS_WIN32
  word *wo = UTF8topwc(opentype);
	result = _wfopen(fn, wo);
	xfree(wo);
#else
	result = fopen(fn, opentype);
#endif
	xfree(fn);
	return result;
}

FILE *file_stream_open_gp(TglobPath *gp, const char *opentype) {
  char *fn;
  FILE *result;

	fn = gptopc(gp, gptfu_noRootArt);
	result = file_stream_open(fn, opentype);
	xfree(fn);
	return result;
}
