/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <unistd.h>

#ifndef _OS_WIN32
static uid_t uid;
static gid_t gid;
static bool akt;
#endif

int file_get_access_st(Tstat64 *st) {
  int result;

	if (!st) return 0;
	result = st->mode;
#ifdef _OS_WIN32
	result >>= 6;
#else
	if (!akt) {
	    akt = True;
	    uid = getuid ();
	    gid = getgid ();
	}
	if (!uid || (st->uid == uid)) {
	    result >>= 6;
	} else if ((st->gid == gid) || group_member(st->gid)) {
	    result >>= 3;
	}
#endif
	return result & (X_OK | W_OK | R_OK);
}

bool file_chk_access_st(Tstat64 *st, int mode) {

	if (!st) return False;
	mode &= (X_OK | W_OK | R_OK);

	if (mode == F_OK) return True;	/* The file exists. */
	return (file_get_access_st(st) & mode) == mode;
}
