/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

char REGP3 *path_add_noChk(const char *basepath, const char *s) {
  int l1, l2;
  char *pc;
  char *result = NULL;

	l1 = pclen(basepath);
	l2 = pclen(s);
	if (!(l1 | l2)) return NULL;

	result = xmalloc(l1 + l2 + 3);
	pc = result;
	ppcnmove(&pc, basepath, l1);

	if (l1 && l2) {
	    if (TestNoSlash(pc[-1])) {*pc = '/'; pc++;}
	    if (TestSlash(*s)) s++;
	}
	if (l2) pcmove(pc, s);
	return result;
}

char *path_add(const char *basepath, const char *s) {
  TPathInfo pathi;
  char *result = path_add_noChk(basepath, s);

	if (get_PathInfo(result, &pathi)) {
	    char *pc = (char*)pathi.path_anf;
	    int lg = pclen(pc);
	    if ((lg > 1) && TestSlash(pc[lg-1])) pc[lg-1] = 0;
	}
	return result;
}

