/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball

regparm(3)  arguments in registers EAX, EDX, and ECX
*/
//	.align 4

#ifdef _OS_WIN32
.global _Get_CPUID
_Get_CPUID:
#else
.globl Get_CPUID
	.type	 Get_CPUID,@function
Get_CPUID:
#endif
	push	%edi
	push	%esi
	push	%ebx
	mov	%eax, %edi
	pushf
	pop	%eax
	mov	%eax, %ecx
	xor	$0x200000, %eax
	push	%eax
	popf
	pushf
	pop	%eax
	xor	%eax, %ecx
       jz      no_CPUID

	mov	$0, %eax
       call    rd_CPUID_save
	mov	$0, %eax
	mov	%eax, (%edi)
	add	$0x04, %edi

	mov	$1, %eax
       call    rd_CPUID_save

	mov	$2, %eax
       call    rd_CPUID_save
    // Test Ext
	mov	$0x80000000, %eax
       call    rd_CPUID_save
	cmp	$0x80000004, %eax
       jb      no_Processor_Name
	sub	$0x80000003, %eax
	mov	%eax, %esi
    // Ext1_FeatureFlag
	mov	$0x80000001, %eax
	CPUID
	mov	%edx, (%edi)
	add	$0x04, %edi
    // ProcessorName
	mov	$0x80000002, %eax
       call    rd_CPUID_save
	mov	$0x80000003, %eax
       call    rd_CPUID_save
	mov	$0x80000004, %eax
       call    rd_CPUID_save

	dec	%esi
       jz      ext_End
	mov	$0x80000005, %eax
       call    rd_CPUID_save
    // Ext6_L2
	dec	%esi
       jz      ext_End
	mov	$0x80000006, %eax
       call    rd_CPUID_save

	dec	%esi
       jz      ext_End
	mov	$0x80000007, %eax
       call    rd_CPUID_save

	dec	%esi
       jz      ext_End
	mov	$0x80000008, %eax
       call    rd_CPUID_save

ext_End:
	mov	$2, %eax
       jmp	no_CPUID

no_Processor_Name:
	mov	$1, %eax
no_CPUID:
	pop	%ebx
	pop	%esi
	pop	%edi
       ret

rd_CPUID_save:
	CPUID;
save_CPUID:	mov	%eax, 0x00(%edi)
	mov	%ebx, 0x04(%edi)
	mov	%ecx, 0x08(%edi)
	mov	%edx, 0x0c(%edi)
	add	$0x10, %edi
       ret;

	.align 4

#ifdef _OS_WIN32
.global _Get_TSC
_Get_TSC:
#else
.globl Get_TSC
	.type	 Get_TSC,@function
Get_TSC:
#endif
//	push	%edi;
	mov	%eax, %ecx
	rdtsc;
	mov	%eax, 0x00(%ecx)
	mov	%edx, 0x04(%ecx)
//	pop	%edi;
       ret

