/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include <string.h>

void nmove(char **dest, char *src, int len) {
	if (!dest || !*dest || !src || (len < 1)) return;
  char *pc = *dest;
	memmove(pc, src, len);
	*dest = &pc[len];
}

void pnmove(char *dest, char *src, int len) {
	if (!dest || !src || (len < 1)) return;
	memmove(dest, src, len);
}

int ppcmove(char **dest, char *src) {
	if (!dest || !*dest || !src) return 0;
  char *pc = *dest;
  int len = strlen(src);
	if (len > 0) memmove(pc, src, len);
	pc[len] = 0;
	*dest = &pc[len];
	return len;
}

int pcmove(char *dest, char *src) {
	if (!dest || !src) return 0;
  int len = strlen(src);
	if (len > 0) memmove(dest, src, len);
	dest[len] = 0;
	return len;
}

void pcnmove(char *dest, char *src, int len) {
	if (!dest || !src || (len < 0)) return;
	if (len > 0) memmove(dest, src, len);
	dest[len] = 0;
}
void ppcnmove(char **dest, char *src, int len) {
	if (!dest || !*dest || !src || (len < 0)) return;
  char *pc = *dest;
	if (len > 0) memmove(pc, src, len);
	pc[len] = 0;
	*dest = &pc[len];
}

int pcxmove(char *dest, char *src, int max_len) {
	if (!dest || !src || (max_len < 0)) return 0;
  int len = strlen(src);
	if (len > max_len) len = max_len;
	if (len > 0) memmove(dest, src, len);
	dest[len] = 0;
	return len;
}
