/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

nmove_len:
	mov	0x18(%esp),%ecx
nmove_reg:
	mov	%ecx,%eax
	test	%ecx,%ecx
       jle	nmove_ret
	cmp	%esi,%edi
       je	nmove_ret
       jg	nmove_down

nmove_up:
	shr	$2,%ecx
	rep	movsd
	mov	%eax,%ecx
	and	$0x03,%ecx
       je	nmove_ret
	rep	movsb
nmove_ret:
       ret

nmove_down:
	add	%esi,%eax
	cmp	%edi,%eax
	mov	%ecx,%eax
       jle	nmove_up
	add	%ecx,%esi
	add	%ecx,%edi
	push	%esi
	push	%edi
	sub	$4,%esi
	sub	$4,%edi

	shr	$2,%ecx
	std
	rep	movsd
	mov	%eax,%ecx
	and	$0x03,%ecx
       je	nmove_2end
	add	$3,%esi
	add	$3,%edi
	rep	movsb
nmove_2end:
	cld
	pop	%edi
	pop	%esi
       ret





chk_pp:
	xor	%eax,%eax
	mov	0x10(%esp),%edx
	test	%edx,%edx
       je	chk_end
	mov	(%edx),%edi
       jmp	chk_edi
chk_p:
	xor	%eax,%eax
	mov	0x10(%esp),%edi
chk_edi:
	mov	0x14(%esp),%esi
	test	%edi,%edi
       je	chk_end
	test	%esi,%esi
chk_end:
       ret

#ifdef _OS_WIN32
.global _ppcnmove
_ppcnmove:
#else
.globl ppcnmove
	.type	 ppcnmove,@function
ppcnmove:
#endif
	push	%esi
	push	%edi
       call	chk_pp
       je	ppcnmove_end

       call	nmove_len
	movb	$0,(%edi)
	mov	%edi,(%edx)
ppcnmove_end:
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _pcnmove
_pcnmove:
#else
.globl pcnmove
	.type	 pcnmove,@function
pcnmove:
#endif
	push	%esi
	push	%edi
       call	chk_p
       je	pcnmove_end

       call	nmove_len
	movb	$0,(%edi)
pcnmove_end:
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _pnmove
_pnmove:
#else
.globl pnmove
	.type	 pnmove,@function
pnmove:
#endif
	push	%esi
	push	%edi
       call	chk_p
       je	pnmove_end

       call	nmove_len
pnmove_end:
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _nmove
_nmove:
#else
.globl nmove
	.type	 nmove,@function
nmove:
#endif
	push	%esi
	push	%edi
       call	chk_pp
       je	nmove_end

       call	nmove_len
	mov	%edi,(%edx)
nmove_end:
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _ppcmove
_ppcmove:
#else
.globl ppcmove
	.type	 ppcmove,@function
ppcmove:
#endif
	push	%esi
	push	%edi
       call	chk_pp
       je	ppcmove_end
	
	mov	%esi,%edi
	mov	$0xffffffff,%ecx
	repne	scasb
	not	%ecx
	mov	(%edx),%edi
       call	nmove_reg

	dec	%edi
	mov	%edi,(%edx)
	dec	%eax
ppcmove_end:
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _pcmove
_pcmove:
#else
.globl pcmove
	.type	 pcmove,@function
pcmove:
#endif
	push	%esi
	push	%edi
       call	chk_p
       je	pcmove_end
	
	mov	%esi,%edi
	mov	$0xffffffff,%ecx
	repne	scasb
	not	%ecx
	mov	0x0c(%esp),%edi
       call	nmove_reg
	dec	%eax
pcmove_end:
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _pcxmove
_pcxmove:
#else
.globl pcxmove
	.type	 pcxmove,@function
pcxmove:
#endif
	push	%esi
	push	%edi
       call	chk_p
       je	pcxmove_end
	
	mov	%esi,%edi
	mov	0x14(%esp),%ecx
	repne	scasb
       jne	pcxmove_1
	inc	%ecx
pcxmove_1:
	mov	%ecx, %eax
	mov	0x14(%esp),%ecx
	sub	%eax,%ecx
	mov	0x0c(%esp),%edi
       call	nmove_reg
	movb	$0,(%edi)
pcxmove_end:
	pop	%edi
	pop	%esi
       ret
