/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

#define tiMaxLineLg	16384

void TpcIni_Save(TpcIni *ti) {
  TGruppe *Gp;
  TGruppeDat *Gpd;
  FILE *fd;
  char line[1024];

	if (!ti || !ti->Changed) return;

	ti->Changed = False;
	fd = file_stream_open(ti->FileName, "w");
	if (!fd) return;

	Gp = ti->Gruppe0;
	while (Gp) {
	    snprintf(line, sizeof(line), "[%s]\n", Gp->name);
	    fputs(line, fd);
	    Gpd = Gp->Dat;
	    while (Gpd) {
		if (Gpd->org) fputs(Gpd->org, fd);
		fputs("\n", fd);
		Gpd = Gpd->next;
	    }
	    Gp = Gp->next;
	}
	fclose(fd);
}

void TpcIni_SaveAndFree(TpcIni *ti) {
	TpcIni_Save(ti);
	Tfree(ti);
}

void TpcIni_WR(TpcIni *ti, const char *Gruppe, const char *Funkt, const char *Dat) {
  int lg;
  TGruppeDat *Gpd = NULL;
  char line[tiMaxLineLg];
  bool mk = True;

	if (Funkt && Dat) {
	    snprintf(line, tiMaxLineLg, "%s=%s", Funkt, Dat);
	} else if (Funkt) {
	    snprintf(line, tiMaxLineLg, "%s=", Funkt);
	} else if (Dat) {
	    snprintf(line, tiMaxLineLg, Dat);
	    TpcIni_FindGruppe(ti, Gruppe); // init ti->lastGp
	    mk = False;
	} else return;

	if (mk) Gpd = TpcIni_FindGruppeDat(ti, Gruppe, Funkt);
	if (Gpd) {
	    if (!pccmp(Gpd->dat, Dat)) {
		lg = pclen(line);
		TpcIni_ChangeGruppeDat(ti, lg, line, Gpd);
		ti->Changed = True;
	    }
	} else {
	    ti->Changed = True;
	    if (!ti->lastGp) {
		lg = pclen(Gruppe);
		if (lg) TpcIni_AddGruppe(ti, lg, Gruppe);
	    }
	    if (ti->lastGp) {
		ti->npGruD = &ti->lastGp->Dat;
		while (*ti->npGruD) ti->npGruD = &(*ti->npGruD)->next;
		lg = pclen(line);
		TpcIni_AddGruppeDat(ti, lg, line);
	    }
	}
}
