/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include <sys/time.h>

#ifdef _OS_WIN32
#include <windows.h>

static int64 TicksPerSecond;
static bool TPS_OK = False;

u64 GetTime_us64() {
	if (!TPS_OK) {
	    QueryPerformanceFrequency((void*)&TicksPerSecond);
	    TPS_OK = True;
	}
	u64 Ticks;
	QueryPerformanceCounter((void*)&Ticks);
	Ticks = Ticks * 1000000 / TicksPerSecond;
	return Ticks;
}

dword GetTime_ms() {
	if (!TPS_OK) {
	    QueryPerformanceFrequency((void*)&TicksPerSecond);
	    TPS_OK = True;
	}
  int64 Ticks;
	QueryPerformanceCounter((void*)&Ticks);
	Ticks = Ticks * 1000 / TicksPerSecond;
	return Ticks;
}

#else
u64 GetTime_us64() {
  struct timeval tv;
  u64 val;
	gettimeofday(&tv, NULL);
	val = tv.tv_sec * 1000000;
	val += tv.tv_usec;
	return val;
}

dword GetTime_ms() {
  struct timeval tv;
  u64 val;
	gettimeofday(&tv, NULL);
	val = tv.tv_sec * 1000;
	val += (tv.tv_usec / 1000);
	return val;
}
#endif

dword GetTime_us() {
	return GetTime_us64();
}

bool cpTime(dword ref, dword now) {
	return (((now - ref) & 0x80000000) == 0);
}

dword GetCurTimeDiv_us(dword StartTime) {
	return (GetTime_us() - StartTime);
}

u64 GetCurTimeDiv_us64(u64 StartTime) {
	return (GetTime_us64() - StartTime);
}
