/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

/*_____________________________ Free ____________________________________*/
bool TNode__Destroy(TNode *node) {

	while (node->next_child) Tfree(node->next_child);

	if (node->prev) {
	    node->prev->next = node->next;
	} else if (node->prev_child) {
	    node->prev_child->next_child = node->next;
	}
	if (node->next) {
	    node->next->prev = node->prev;
	    node->next->prev_child = node->prev_child;
	}
	if (node == *node->pproot) *node->pproot = node->next;
	return False;
}

/*_____________________________ Create __________________________________*/
void *TNodeAdd(TNode **pproot, TNode *prev_child, TNode *prev, int size, int wtyp) {
  TNode *self = TNode_Create(pproot, size, wtyp);

	if (self) {
	    if (!prev_child && !prev) {
		self->next = *pproot;
		if (self->next) self->next->prev = self;
		*pproot = self;
	    } else if (prev) {
		self->prev = prev;
		self->next = prev->next;
		prev->next = self;
		if (self->next) self->next->prev = self;
	    } else {
		self->next = prev_child->next_child;
		prev_child->next_child = self;
		self->prev_child = prev_child;
		if (self->next) {
		    self->next->prev_child = NULL;
		    self->next->prev = self;
		}
	    }
	}
	return self;
}

void *TNode_Create(TNode **pproot, int size, int wtyp) {
  TNode *self = NULL;

	if (!pproot || (size < sizeof(TNode))) return NULL;
	self = ttc_create(size, wtyp);
	self->destroy = (TDESTROY)TNode__Destroy;
	self->pproot = pproot;
	return self;
}
