/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

//*********************** TEdit ************************

void TEdit_DoPaint(TEdit *self) {
	if (self->KeyFu & mHasFocus) Caret_Draw(0);
	if (self->Passwd) {
	    char *s = self->vds.s;
	    int lg = self->vds.lg;
	    if (lg || (self->Passwd & ed_passwd_akt_NULL)) {
		self->vds.s = "********";
		self->vds.lg = 8;
		TWins_DoPaint((TWins*)self);
		self->vds.s = s;
		self->vds.lg = lg;
	    } else {
		TWins_DoPaint((TWins*)self);
	    }

	} else {
	    TWins_DoPaint((TWins*)self);
	}
	if (self->KeyFu & mHasFocus) Caret_Draw(1);
}

static void ed_SetCaret(TEdit *self, int idx) {
  int x = GetChar_XPos(idx, &self->vds);
	TWins_Caret_SetNewPos((TWins*)self, x, self->vds.Yoff);
	Caret_Draw(1);
}

static void TEdit_SetCaretIdx(TEdit *self, int idx, bool sel) {

	if (self->KeyFu & mHasFocus) Caret_Draw(0);
	if (idx < 0) idx = 0;
	if (idx > self->vds.lg) idx = self->vds.lg;
	self->CaretCharIdx = idx;
	self->vds.SelE = idx;
	if (!sel) self->vds.SelA = idx;
	if (!TestWinIsVisible((TWins*)self)) return;
	Paint((TWins*)self);
	if (self->KeyFu & mHasFocus) ed_SetCaret(self, idx);
	
}

void TEdit_SetSelAll(TEdit *ed) {
	ed->vds.SelA = 0;
	TEdit_SetCaretIdx(ed, ed->vds.lg, True);
}

static void TEdit_ClsSel(TEdit *self, int *idx) {
  int i;
	if (self->vds.SelA != self->vds.SelE) {
	    ppclg_delsel(&self->vds.s, &self->vds.lg, self->vds.SelA, self->vds.SelE);
	    if (self->vds.SelA < self->vds.SelE) {
		i = self->vds.SelA;
	    } else {
		i = self->vds.SelE;
	    }
	    if (i < 0) i = 0;
	    *idx = i;
	}
}

static bool ed_Strg_C(TEdit* self) {
	if (self->vds.SelA == self->vds.SelE) return False;
	if (!self->Passwd) {
	    ppcchange(&IappXDat.SelTxt.s, strgetsel(self->vds.s, self->vds.SelA, 
						    self->vds.SelE));
	    IappXDat.SelTxt.lg = pclen(IappXDat.SelTxt.s);
	    SetSelection(1, XA_STRING);
	}
	return True;
}


int TEdit_DoKeyDown(TEdit *self, TKeyEvent *KeyEv) {
  int idx;
  char tmp[8];
  bool sel = False;
  bool chg = False;

// printf("ks=0x%x \"%s\" keycode=%d(0x%x)  state=0x%x\n", *keysym, (char*)keysym, ev->keycode, ev->keycode, ev->state);
	idx = self->CaretCharIdx;
	TWins_DoKeyDown((TWins*)self, KeyEv);

	if (KeyEv->keysym == XK_Left) {
	    GetVdsPrev_WChar(&idx, &self->vds);
	    sel = ((KeyEv->state & 1) != 0);

	} else if (KeyEv->keysym == XK_Right) {
	    GetVdsNext_WChar(&idx, &self->vds);
	    sel = ((KeyEv->state & 1) != 0);

// ******* Strg_C *******
	} else if ((KeyEv->keycode == 54) && (KeyEv->state & 0x4)) {
	    ed_Strg_C(self);
	    return 1;

	} else if (self->ReadOnly) {
	    return 0;

	} else if (KeyEv->keysym == XK_BackSpace) {
	    if (self->vds.SelA == self->vds.SelE) self->vds.SelA--;
	    TEdit_ClsSel(self, &idx);
	    chg = True;

	} else if (KeyEv->keysym == XK_Delete) {
	    if (self->vds.SelA == self->vds.SelE) self->vds.SelE++;
	    TEdit_ClsSel(self, &idx);
	    chg = True;

// ******* Strg_X *******
	} else if ((KeyEv->keycode == 53) && (KeyEv->state & 0x4)) {
	    if (ed_Strg_C(self)) {
		TEdit_ClsSel(self, &idx);
		chg = True;
	    }
// ******* Strg_V *******
	} else if ((KeyEv->keycode == 55) && (KeyEv->state & 0x4)) { //Strg_V
	    TEdit_ClsSel(self, &idx);
	    if (GetPasteStr_lgs(self->vds.UTF8on)) {
		vds_ins_pc(&self->vds, IappXDat.SelRet_lgs.s, idx);
		idx += pclen(IappXDat.SelRet_lgs.s);
		SelRetClr(); //Tlgs_Clr(&IappXDat.SelRet_lgs);
		chg = True;
	    }

	} else if (self->Passwd && (KeyEv->keysym == XK_space)) {
	    return 1;

	} else if (keysymtostr(&KeyEv->keysym, tmp, self->vds.UTF8on)) {
	    if (!self->DoCharAllow || self->DoCharAllow(self, KeyEv, idx)) {
		TEdit_ClsSel(self, &idx);
		vds_ins_pc(&self->vds, tmp, idx);
		GetVdsNext_WChar(&idx, &self->vds);
		chg = True;
	    }
	} else return 0;

	self->vds.lg = pclen(self->vds.s);
	if (chg) {
	    self->Passwd &= ~ed_passwd_akt_NULL;
	    if (self->OnChange) self->OnChange(self);
	}
	self->CaptionFu |= mCaptionRePaint;
	TEdit_SetCaretIdx(self, idx, sel);
	return 1;
}

void TEdit_DoMouseDown(TWins *self, XButtonEvent *ev) {
  int idx;
	if ((ev->button == Button1) && TestWinIsEnabled(self)) {
	    idx = GetMouseX_CharPos(ev->x, &self->vds);
	    TEdit_SetCaretIdx((TEdit*)self, idx, False);
	}
	TWins_DoMouseDown(self, ev);
}

void TEdit_DoMouseMove(TWins *self, XMotionEvent *ev) {
  int idx;
  TEdit *_self = (TEdit*)self;
	TWins_DoMouseMove(self, ev);
	if ((ev->state & Button1Mask) && (IappXDat.MouseDown.apph == self->apph)) {
	    idx = GetMouseX_CharPos(ev->x, &self->vds);
	    if (_self->CaretCharIdx != idx) TEdit_SetCaretIdx(_self, idx, True);
	}
}

void TEdit_DoClick(TWins *self, long KeyState, bool DblClick) {
	
	if (DblClick && (self->KeyFu & mCanFocus)) {
	    self->vds.SelA = 0;
	    self->vds.SelE = self->vds.lg;
	    TWins_DoClick(self, KeyState, DblClick);
	    Paint(self);
	} else {
	    TWins_DoClick(self, KeyState, DblClick);
	}
}

void TEdit_DoFocus(TEdit *self, int Change) {

	if (Change & WinsFocusIN) {
	    if ((self->RunStatus & runst_Paint1) == 0) Paint((TWins*)self);
	    TWins_DoFocus((TWins*)self, Change);
	    if (self->AutoSel) {
		TEdit_SetSelAll(self);
	    } else {
		ed_SetCaret(self, self->CaretCharIdx);
	    }

	} else {
	    if (Change & WinsFocusChange) {
		self->vds.SelA = 0;
		self->vds.SelE = 0;
		Refresh((TWins*)self);
	    }
	    Caret_Draw(0);
	    TWins_DoFocus((TWins*)self, Change);
	}
}

void TEdit_SetCaption(TEdit *self, const char *s) {
	if (!pccmp(self->vds.s, s)) {
	    if (self->KeyFu & mHasFocus) Caret_Draw(0);
	    TWins_SetCaption((TWins*)self, s);
	    TEdit_SetCaretIdx(self, self->CaretCharIdx, False);
	    if (self->OnChange) self->OnChange(self);
	}
}

void TEdit_SetReadOnly(TEdit *self, bool ReadOnly) {
	if (self->ReadOnly != ReadOnly) {
	    self->ReadOnly = ReadOnly;
	    dword Color;
	    if (ReadOnly) {
		Color = SubColor(self->Color, self->ColorReadOnlyOffset);
	    } else {
		Color = AddColor(self->Color, self->ColorReadOnlyOffset);
	    }
	    SetColor((TWins*)self, Color);
	}
}

/*____________________________ Destroy __________________________________*/
bool TEdit__Destroy(TEdit *self) {
	TWins_Caret_Clr((TWins*)self);
	return TWins__Destroy((TWins*)self);
}

/*____________________________ Create ___________________________________*/
void TEdit_CreateParams(TWins_Create_struct *wcs) {
  TEdit *self = wcs->wins;

	Caret_Init();

	self->destroy = (TDESTROY)TEdit__Destroy;
	self->SetCaption = (TSetCaptionEv)TEdit_SetCaption;

	self->DoPaint = (TWinsEv)TEdit_DoPaint;
	self->DoMouseDown = TEdit_DoMouseDown;
//	self->DoMouseUp = TEdit_DoMouseUp;
	self->DoMouseMove = TEdit_DoMouseMove;
	self->DoClick = TEdit_DoClick;

	self->DoFocus = (TFocusEv)TEdit_DoFocus;
	self->DoKeyDown = (TKeyEv)TEdit_DoKeyDown;

	self->CaptionFu = mCaptionPaint | mCaptionSolid | mCaptionLeft;
	self->KeyFu = mCanFocus | mK_Down | mK_Up | mK_Tab;
	self->BorderFu = mBorder | mBorderL | mBorderW2;
	self->Color = 0xffffff;
	self->ColorReadOnlyOffset = 0x181818;
	self->vds.BackColor = self->Color;
	self->CaptionOffX = 1;
//	self->AutoSel = True;
	self->cursor_nr = XC_xterm;

	self->CaptionFu |= mCaptionRePaint;
}

TEdit *TEdit_Create(TWins *Parent) {
  TWins_Create_struct wcs;

	TWins_Create_struct_init(&wcs, sizeof(TEdit), wtyp_Edit);
	wcs.Parent = Parent;
	wcs.CreateParams = TEdit_CreateParams;
	TWins_DefaultConf(&wcs);
	return wcs.wins;
}

TEdit *TEdit_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s) {
  TEdit *self;

	self = TEdit_Create(Parent);
	SelfCreateS((TWins*)self, Left, Top, Width, Height, s);
	return self;
}

