/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

//*********************** MenuButton ************************

void TMenuButton_mio(TWins *self, int fu);

void TMenuButton_DoPaint(TWins *self) {
  TMenuButton *sw = (TMenuButton*)self;
  TPic *pic;
	pic = sw->pic;
	if (pic) {
	    if (!TestWinIsEnabled(self) && sw->dis_pic) pic = sw->dis_pic;
	    DrawPic(sw->WinID, pic, 1, 1);
	}
	TWins_DoPaint(self);
}

void TMenuButton_SetPosition(TMenuButton *mb) {
  TMenuButton *mbu = mb->mbuRoot;
  int x = 0;
  int sw;
	if (mbu) x = mbu->left;
	while (mbu) {
	    if (mbu->Visible) {
		if (mbu->AutoSize) {
		    sw = TextWidthColorString(&mbu->vds) + 4;
		    if (mbu->pic) {
			sw += mbu->pic->width + 2;
			mbu->CaptionOffX = (mbu->pic->width >> 1);
		    } else sw += 4;
		    if (sw < 18) sw = 18;
		    SetRC((TWins*)mbu, x, mbu->top, sw, mbu->height);
		}
		x += mbu->width;
	    }
	    mbu = mbu->next;
	}
}

void TMenuButton_SetVisible(TWins *self, bool Value) {
	TWins_SetVisible(self, Value);
	TMenuButton_SetPosition((TMenuButton*)self);
}

static void TMenuButton_Border(TMenuButton *self, int fu) {
  TMenuButton *mbu = self->mbuRoot;

	while (mbu) {
	    if (mbu->BorderFu) DrawRect(mbu->WinID, IappXDat.Default_GC, 0, 0, mbu->width, mbu->height);
	    mbu->BorderFu = 0;
	    mbu = mbu->next;
	}

	if (fu == -1) fu = self->mbuRoot->mbuStat;
	if (fu) {
	    if (fu == 1) self->BorderFu = mBorder;
	    if (fu == 2) self->BorderFu = mBorder | mBorderL;
	    Refresh((TWins*)self);
	}
}


static void TMenuButton_MenuOpen(TMenuButton *self) {
  TWRect rc;
	self->mbuRoot->mbuStat = 2;
	if (self->menu) {
	    GetXWinAbs_rc(self->WinID, &rc);
	    rc.top += self->height;
	    TMenu_Show(self->menu, (TWins*)self, rc.left, rc.top);
	    self->menu->DoOwner = TMenuButton_mio;
//	    self->menu->owner = (TWins*)self;
	}
	TMenuButton_Border(self, -1);
}

static void TMenuButton_ReOpen(TMenuButton *old, TMenuButton *new) {
  TMenuButton *root;
	if (old) root = old->mbuRoot; else
	if (new) root = new->mbuRoot; else return;

	TMenu_Close(NULL, me_stClose);
	if (new) {
	    Set_Focus((TWins*)new);
	    if (new->menu) {
		if (root->mbuStat == 2) {
		    TMenuButton_MenuOpen(new);
		} else {
		    TMenuButton_Border(new, -1);
		}
	    } else {
		TMenuButton_Border(new, 1);
	    }
	}
}

static void TMenuButton_next(TMenuButton *mbu) {
  TMenuButton *tmb;
	tmb = mbu->next;
	while (tmb && !TestWinCanFocus((TWins*)tmb)) tmb = tmb->next;
	if (!tmb) {
	    tmb = mbu->mbuRoot;
	    while (tmb && !TestWinCanFocus((TWins*)tmb)) tmb = tmb->next;
	}
	TMenuButton_ReOpen(mbu, tmb);
}

static void TMenuButton_prev(TMenuButton *mbu) {
  TMenuButton *tmb, *ttmb;
	ttmb = mbu->mbuRoot;
	tmb = NULL;
	while (ttmb) {
	    if (TestWinCanFocus((TWins*)ttmb) && (ttmb != mbu)) tmb = ttmb;
	    if ((ttmb == mbu) && tmb) break;
	    ttmb = ttmb->next;
	}
	TMenuButton_ReOpen(mbu, tmb);
}

void TMenuButton_mio(TWins *self, int fu) {
  TMenuButton *sw = (TMenuButton*)self;
	if (fu == mioClose) {
	    TMenuButton_Border(sw, 0);
	    sw->mbuRoot->mbuStat = 0;
	} else if (fu == mioXK_XK_Left) {
	    TMenuButton_prev(sw);
	} else if (fu == mioXK_Right) {
	    TMenuButton_next(sw);
	}
}


static void TMenuButton_Close(TMenuButton *self) {
  TForm *Form = GetParentForm((TWins*)self);

	TMenu_Close(NULL, me_stClose);
	self->mbuRoot->mbuStat = 0;
	TMenuButton_Border(self, 0);
	if (Form && ChkTWinsExist(IappXDat.apph, Form->LastNoMenuFocusWin)) {
	    Set_Focus(Form->LastNoMenuFocusWin);
	}
} 

void TMenuButton_DoMouseDown(TWins *self, XButtonEvent *ev) {
  TMenuButton *mbu = (TMenuButton*)self;
	if ((ev->x < 0) || (ev->x > self->width) || (ev->y < 0) || (ev->y > self->height)) {
	    TMenu_Close(NULL, me_stClose);
	    return;
	}
	TWins_DoMouseDown(self, ev);

	if ((ev->button == 1) && TestWinIsEnabled(self)) {
	    if (mbu->menu) {
		if (((TMenuButton*)self)->mbuRoot->mbuStat == 0) {
		    TMenuButton_MenuOpen(mbu);
		} else {
		    TMenuButton_Close(mbu);
		}
	    } else {
		TMenuButton_Border(mbu, 2);
	    }
	}
}

void TMenuButton_DoMouseUp(TWins *self, XButtonEvent *ev) {
  TMenuButton *mbu = (TMenuButton*)self;

	TWins_DoMouseUp(self, ev);
	if ((ev->button == 1) && !mbu->menu) {
	    TMenuButton_Close(mbu);
	}
}

void TMenuButton_DoClick(TWins *self, long KeyState, bool DblClick) {
  TMenuButton *mbu = (TMenuButton*)self;
	if (!mbu->menu) TWins_DoClick(self, KeyState, DblClick);
}

static TMenuButton *EnterMenuButton;

void TMenuButton_DoMouseOver(TWins *self, XCrossingEvent *ev, bool Leave) {
  int fu = ((TMenuButton*)self)->mbuRoot->mbuStat;
	if (Leave) {
	    if (fu == 0) TMenuButton_Border((TMenuButton*)self, 0);
	} else {
	    switch (fu) {
	    case 0:
		TMenuButton_Border((TMenuButton*)self, 1);
		break;
	    case 1:
		TMenuButton_ReOpen(NULL, (TMenuButton*)self);
		break;
	    case 2:
		if (EnterMenuButton != (TMenuButton*)self)
			TMenuButton_ReOpen(NULL, (TMenuButton*)self);
		break;
	    }
	    EnterMenuButton = (TMenuButton*)self;
	}
	TWins_DoMouseOver(self, ev, Leave);
}

int TMenuButton_DoKeyDown(TWins *self, TKeyEvent *KeyEv) {
  TMenuButton *mbu = (TMenuButton*)self;

	if (KeyEv->keysym == XK_Left) {
		TMenuButton_prev(mbu);
	} else if (KeyEv->keysym == XK_Right) {
		TMenuButton_next(mbu);
	} else if (KeyEv->keysym == XK_Down) {
		TMenuButton_MenuOpen(mbu);
	} else if (((KeyEv->keysym == XK_space) || 
		    (KeyEv->keysym == XK_Return)) && !mbu->menu) {
		TMenuButton_Border(mbu, 2);
	} else return 0;
	return 1;
}

int TMenuButton_DoKeyUp(TWins *self, TKeyEvent *KeyEv) {
  TMenuButton *mbu = (TMenuButton*)self;
	if (((KeyEv->keysym == XK_space) || 
	     (KeyEv->keysym == XK_Return)) && !mbu->menu) {
	    TMenuButton_Close(mbu);
	    TMenuButton_DoClick(self, KeyEv->state, False);
	}
	return 1;
}

void TMenuButton_SetCaption(TWins *self, const char *s) {
	TWins_SetCaption(self, s);
	TMenuButton_SetPosition((TMenuButton*)self);
//	Refresh(self);
}

void TMenuButton_Exec(TForm *Form) {
  TMenuButton *mb = Form->Root_MenuButton;
	if (!mb) return;
	if (mb->mbuStat) {
	    if (ChkTWinsExist(IappXDat.apph, Form->LastNoMenuFocusWin)) 
			Set_Focus(Form->LastNoMenuFocusWin);
	    mb->mbuStat = 0;
	    TMenu_Close(NULL, me_stClose);
	} else {
	    mb->mbuStat = 1;
	    Set_Focus((TWins*)mb);
	}
	TMenuButton_Border(mb, -1);
}

void TMenuButton_SetAsRoot(TForm *Form, TMenuButton *mbu) {
	Form->Root_MenuButton = mbu;
	Form->DoMenuButtonExec = TMenuButton_Exec;
}


/*_____________________________ Create __________________________________*/
void TMenuButton_CreateParams(TWins_Create_struct *wcs) {
  TMenuButton *self = wcs->wins;
  TMenuButton *mbuRoot = wcs->SubP;
  TMenuButton *mbu;

	self->SetCaption = TMenuButton_SetCaption;
	self->SetVisible = TMenuButton_SetVisible;

	self->DoPaint = TMenuButton_DoPaint;
	self->DoMouseDown = TMenuButton_DoMouseDown;
	self->DoMouseUp = TMenuButton_DoMouseUp;
//	self->DoMouseMove = TMenuButton_DoMouseMove;
	self->DoClick = TMenuButton_DoClick;
	self->DoMouseOver = TMenuButton_DoMouseOver;
//	self->DoFocusIn = TMenuButton_DoFocusIn;
//	self->DoFocusOut = TMenuButton_DoFocusOut;
	self->DoKeyDown = TMenuButton_DoKeyDown;
	self->DoKeyUp = TMenuButton_DoKeyUp;

	self->CaptionFu = mCaptionPaint;
	self->KeyFu = mCanFocus;
	self->AutoSize = True;

	if (mbuRoot) {
	    if (mbuRoot->wtyp == wtyp_Form) {
		self->height = 18;
		self->top = 2;
		self->left = 1;
		TMenuButton_SetAsRoot((TForm*)mbuRoot, self);
		self->mbuRoot = self;
	    } else if (mbuRoot->wtyp == wtyp_MenuButton) {

		self->mbuRoot = (TMenuButton*)mbuRoot;
		mbu = self->mbuRoot;
		int x = mbu->left + mbu->width;
		while (mbu->next) {
		    x += mbu->width;
		    mbu = mbu->next;
		}
		mbu->next = self;
		self->left = x;
		self->top = mbuRoot->top;
		self->height = mbuRoot->height;
	    } else {
 printf("%s(%d): TODO mbuRoot=0x%x wtyp=0x%x\n", FL, (int)mbuRoot, mbuRoot->wtyp);
	    }
	} else {
	    self->mbuRoot = self;
	    self->top = 2;
	    self->left = 1;
	}
}

TMenuButton *TMenuButton_Create(TWins *Parent, TMenuButton *mbuRoot) {
  TWins_Create_struct wcs;

	TWins_Create_struct_init(&wcs, sizeof(TMenuButton), wtyp_MenuButton);
	wcs.Parent = Parent;
	wcs.CreateParams = TMenuButton_CreateParams;
	wcs.SubP = mbuRoot;
	TWins_DefaultConf(&wcs);
	return wcs.wins;
}

TMenuButton *TMenuButton_CreateS(TWins *Parent, TMenuButton *mbuRoot, const char *s) {
  TMenuButton *self = TMenuButton_Create(Parent, mbuRoot);
	if (s) SetCaption((TWins*)self, s);
	Set_Parent((TWins*)self, Parent);
	return self;
}
