/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "tfilewin.h"

#ifdef DRAG_AND_DROP
void TFileWin_DoMouseMove(TWins *self, XMotionEvent *ev) {
  Tdnd *dnd = IappXDat.dnd;
  TFileWin *fw = (TFileWin*)self;
  TDirFileList *dfl;
  int xt, yt;
  Atom nAtom[2];
  char *path;
  char *pc = NULL;

	TWins_DoMouseMove(self, ev);
	if (!dnd || !(ev->state & Button1Mask) || !TestWinIsEnabled(self)) return;
	if (!fw->MouseCell.InCell) return;
	xt = abs(IappXDat.MouseDown.x - ev->x);
	yt = abs(IappXDat.MouseDown.y - ev->y);
	if (xt > 6 || yt > 6) {

/*
  Window target = 0;
  int lx = 0, ly = 0;
		if (!XTranslateCoordinates(IappXDat.dpy, IappXDat.RootW, IappXDat.RootW,
				 ev->x_root, ev->y_root,
				 &lx, &ly, &target)) return;

 printf("%s(%d): TFileWin_DoMouseMove A=0x%x\n", FL, (int)target);
*/


	    if (dnd->dndM_SrcWin == 0) {
		Tlgs_Clr(&dnd->SelTxt);
		path = gptopc(TFileWin_Get_gp(fw), gptfu_noPasswd | gptfu_noName | gptfu_add_slash);
		dfl = TFileWin_Get_dfl0(fw);
		while (dfl) {
		    if (dfl->fu & fls_Select) {
			if (!pccmp(dfl->fn, ".") && !pccmp(dfl->fn, ".."))
				ppcadd_n(&pc, 3, path, dfl->fn, "\n");
// printf("%s%s\n", path, dfl->fn);
		    }
		    dfl = dfl->next;
		}

		if (!pc) return;
		dnd->SelTxt.s = pc;
		dnd->SelTxt.lg = pclen(pc);
// printf("%s", pc);

		dnd->dndM_Action = dnd->XA_XdndActionCopy;
#ifdef _OS_WIN32
		nAtom[0] = CF_TEXT;
		dnd->SetSelection(self, nAtom, 2);
#else
		nAtom[0] = IappXDat.XA_URL_STRING;
		nAtom[1] = IappXDat.XA_TEXT_PLAIN;
		dnd->SetSelection(self, nAtom, 2);
#endif
// printf("%s(%d): TFileWin_DoMouseMove=0x%x\n", FL, (int)dnd->dndM_SrcWin);
	    }
	    if (dnd->dndM_SrcWin != 0) {
		dnd->MoveSet(dndM_Move_Auto, dnd->GetMoveWin(), ev->x_root, ev->y_root);
	    } 
	} else {
	    if (dnd->dndM_SrcWin != 0) {
		dnd->MoveSet(dndM_Move_Leave, 0, 0, 0);
	    } 
	}
}


void TFileWin_dnd_master_init(TFileWin *fw) {
//  Tdnd *dnd = IappXDat.dnd;

//	if (!IappXDat.dnd) dnd = Tdnd_Atoms_Create();
	Tdnd_master_Create();
	fw->DoMouseMove = TFileWin_DoMouseMove;

}
#endif  /* DRAG_AND_DROP */

