/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldconsole.h"

void leAddChar(TFormAHconsole *fmain, char *pcn) {
  Tleterm *term = fmain->leterm;
  int items, m, UCfu, scdfu;
  TUCharStat ucti;
  char *pc;
  TUCharStat *uct;
  TStrColorDat *scd;
  bool mk;

	if (term->UTF8on) {
	    while (*pcn) {
		if (term->disp_ctrl || term->charset) {
		    Tleterm_scan(term, (byte)*pcn);
		    pcn++;
		} else {
		    dword c = Utf8CharToWChar_rlg(pcn, &m) & ~Char_ErrorUTF8;
		    Tleterm_scan(term, c);
		    pcn += m;
		}
	    }
	} else {
	    while (*pcn) {
		Tleterm_scan(term, (byte)*pcn);
		pcn++;
	    }
	}

	if (term->cs->s != term->pcline) xfree(term->cs->s);
	if (term->cs->c != (char*)term->scda) xfree(term->cs->c);

	UCfu = 0;
	if (!term->UTF8on) UCfu = UC_force_ASCII;

	term->cs->s = term->pcline;
	term->cs->lg = WCharsToUtf8(term->pcline, term->linesize*4, 
					term->line, term->lg, UCfu);
	term->cs->s[term->cs->lg] = ' ';
	term->cs->c = (char*)term->scda;

	scdfu = scdfu_override_utf8;
	if (term->UTF8on) scdfu = scdfu_override_utf8 | scdfu_UTF8on;

	scd = term->scda->scd;
	items = ucti.i = 0;
	uct = term->uct;
	pc = term->pcline;
	mk = False;
	for (int i=0;i<term->lg;i++) {
	    if (!term->hide_cursor && (i == term->idx)) {
		ucti.t.bc = 15-uct->t.fc;
		ucti.t.fc = 15-uct->t.bc;
		if (mk) {
		    scd->lg = pc - scd->pc;
		    scd->fu = scdfu;
		    scd++;
		}
		mk = True;
		scd->pc = pc;
		Tleterm_set_CS_data(term, scd, ucti);
		items++;
	    } else if (!mk || (ucti.i != uct->i)) {
		ucti.i = uct->i;
		if (mk) {
		    scd->lg = pc - scd->pc;
		    scd->fu = scdfu;
		    scd++;
		}
		mk = True;
		scd->pc = pc;
		Tleterm_set_CS_data(term, scd, ucti);
		items++;
	    }
	    if (term->UTF8on) pc += get_Utf8Chars(pc); else pc++;
	    uct++; 
	}
	if (mk) {
	    scd->lg = pc - scd->pc;
	    scd->fu = scdfu;
	    scd++;
	}

	if (!term->hide_cursor && (term->idx == term->lg)) {
	    m = 15-ucti.t.fc;
	    ucti.t.fc = 15-ucti.t.bc;
	    ucti.t.bc = m;
	    scd->lg = 1;
	    scd->fu = scdfu;
	    scd->pc = &term->pcline[term->cs->lg];
	    term->cs->lg++;
	    Tleterm_set_CS_data(term, scd, ucti);
	    items++;
	}

	term->scda->items = items;

	Refresh((TWins*)fmain->le);


	if (term->ex_bef) {
	    switch (term->ex_bef) {
	    case exbef_cd:
		gTimer_set_next_ev(fmain->t1000ms, 50);
	    }
	}
}
