/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldconsole.h"

void menuEdit_OnMenuOpen(TMenu *self) {
  TFormAHconsole *fmain = (TFormAHconsole*)self->ParentForm;
  TMenuItem *mi;
  bool sh_slave, sel;

	sel = TLineEdit_ChkIsSel(fmain->le);
	sh_slave = chk_sh_slave(fmain, NULL);
	mi = self->MenuItem;
	while (mi) {
	    if (mi->tag == 1) {
		mi->fu |= miNotEnabled;
		if (sel) mi->fu &= ~miNotEnabled;

		if (sh_slave) {
		    ppcfree(&mi->s2);
		} else {
		    if (!mi->s2) mi->s2 = pcdup("Strg c");
		}

	    } else if (mi->tag == 2) {
		if (sh_slave) {
		    ppcfree(&mi->s2);
		} else {
		    if (!mi->s2) mi->s2 = pcdup("Strg v");
		}
	    }
	    mi = mi->next;
	}
}

void mEdit_Copy(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormAHconsole *fmain = (TFormAHconsole*)self->ParentForm;
	TLineEdit_Strg_C(fmain->le);
}

void mEdit_Paste(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormAHconsole *fmain = (TFormAHconsole*)self->ParentForm;
	if (!GetPasteStr_lgs(fmain->le->vds.UTF8on)) return;
	write(fmain->pty->ptyfd, IappXDat.SelRet_lgs.s, IappXDat.SelRet_lgs.lg);
	SelRetClr();
}

void mEdit_SelectAll(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormAHconsole *fmain = (TFormAHconsole*)self->ParentForm;
	TLineEdit_SetSel(fmain->le, 0, 0, 0, fmain->le->tls->Count);
}

/* ______________________ Create _____________________________________ */
void MenuEdit_Create(TFormAHconsole *fmain) {
  TMenuItem *mi;
	fmain->mbEdit = TMenuButton_Create(fmain->PanelTop, fmain->mbFile);
	SetCaption((TWins*)fmain->mbEdit, "Edit");
	Set_Parent((TWins*)fmain->mbEdit, fmain->PanelTop);

	fmain->menuEdit = TMenu_Create((TWins*)fmain);
	fmain->menuEdit->OnMenuOpen = menuEdit_OnMenuOpen;
	fmain->mbEdit->menu = fmain->menuEdit;

	mi = TMenu_AddItem(fmain->menuEdit, "Copy", miNotEnabled, mEdit_Copy);
	mi->tag = 1;
	mi = TMenu_AddItem(fmain->menuEdit, "Paste", 0, mEdit_Paste);
	mi->tag = 2;
	TMenu_AddItem(fmain->menuEdit, "Select All", 0, mEdit_SelectAll);

}
