/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"
#include <X11/extensions/shape.h>

void buWinOptMenu_OnPaint(TWins *self) {
  TwmTitle *wmt = (TwmTitle*)self->Parent;
	DrawPic(self->WinID, wmt->pic, 0, 0);
}

void buWinOptMenu_OnMouseDown(TWins *self, XButtonEvent *ev) {
  TwmFrame *wmf = (TwmFrame*)self->Parent->Parent;

	exec_Buildin(wmf->wmWin->apph, "menu_form_opt", NULL, cond_0);
}

void buMinimize_OnPaint(TWins *self) {
	DrawLine(self->WinID, IappXDat.GC_000000, 3, 9, 11, 9);
	DrawLine(self->WinID, IappXDat.GC_000000, 3, 10, 11, 10);
}

void buMinimize_OnClick(TWins *self, long KeyState, bool DblClick) {
	SetVisible(self->Parent->Parent, False);
}

void buMaximize_OnPaint(TWins *self) {
	DrawRect(self->WinID, IappXDat.GC_000000, 2, 2, 12, 10);
	DrawLine(self->WinID, IappXDat.GC_000000, 3, 3, 12, 3);
}

void buMaximize_OnClick(TWins *self, long KeyState, bool DblClick) {
  TwmFrame *wmf = (TwmFrame*)self->Parent->Parent;
	exec_Buildin(wmf->wmWin->apph, "minmax_win", NULL, cond_0);
}

void buClose_OnPaint(TWins *self) {
	DrawLine(self->WinID, IappXDat.GC_000000, 3, 3, 10, 10);
	DrawLine(self->WinID, IappXDat.GC_000000, 4, 3, 11, 10);
	DrawLine(self->WinID, IappXDat.GC_000000, 10, 3, 3, 10);
	DrawLine(self->WinID, IappXDat.GC_000000, 11, 3, 4, 10);
}

void buClose_OnClick(TWins *self, long KeyState, bool DblClick) {
  TwmFrame *wmf = (TwmFrame*)self->Parent->Parent;

	TwmWin_Close(wmf->wmWin);
}

static void TwmTitle_LoadIcoName(TwmTitle *self, char *name, bool LCase) {
  char *pc;
  int fu;
	if (!name || !*name) return;
	pc = name;
	while (*pc) {
	    if ((byte)*pc <= 0x2f) return;
	    pc++;
	}

	fu = gdifu_noUnknown;
	if (self->mpic.pic) fu = gdifu_noError|gdifu_noUnknown;

	self->pic = GetDeskIcon(ddkt_Application, 16, name, fu, NULL);
	if (self->pic || !LCase) return;

  char *pc0 = pcdup(name);
  bool mk = False;
	pc = pc0;
	while (*pc) {
	    if ((*pc >= 'A') && (*pc <= 'Z')) {
		*pc += 0x20;
		mk = True;
	    }
	    pc++;
	}
	if (mk) self->pic = GetDeskIcon(ddkt_Application, 16, pc0, fu, NULL);
	xfree(pc0);
}

static void TwmTitle_Ico_32To16(TwmTitle *self, Pixmap pmxID, Pixmap maskID) {
  TPixMap *pxm, *pmx16;

	pxm = TPixMap_Create_XID(pmxID, maskID);

	if (!pxm) return;
	if (pxm->maskID) {
	    TPixMap_XGetImage(pxm);
	    bitmask2alpha((TImage*)pxm);
	}
	pmx16 = TPixMap_dup_new_size(pxm, 16, 16);
	pxm->pmxID = pxm->maskID = 0;
	Tfree(pxm);

	TPixMap_XPutImage(pmx16);

	self->mpic.pic = pmx16->pmxID;
	self->mpic.mask = pmx16->maskID;
	self->mpic.width = 16;
	self->mpic.height = 16;
	self->pic = &self->mpic;
	pmx16->pmxID = pmx16->maskID = 0;
	Tfree(pmx16);
}


void TwmTitle_OnResize(TWins *self) {
  TwmTitle *wmt = (TwmTitle*)self;
  int left;
	left = self->width - wmt->buClose->width - 2;
	wmt->buClose->left = left;
	if (wmt->buMaximize) {
	    left -= wmt->buMaximize->width + 2;
	    wmt->buMaximize->left = left;
	}
	if (wmt->buMinimize) {
	    left -= wmt->buMinimize->width + 1;
	    wmt->buMinimize->left = left;
	}
}

void TwmTitle_DoPaint(TWins *self) {
  TwmTitle *wmt = (TwmTitle*)self;

	self->vds.Font = wmRoot->wmTitleFont;
	if ((self->vds.UTF8on) && (wmRoot->wmTitleFontUTF8)) {
	    self->vds.Font = wmRoot->wmTitleFontUTF8;
	}

	self->vds.Xoff = self->CaptionOffX;
	self->vds.Yoff = (self->height - self->vds.Font->height) >> 1;
	self->vds.Yoff += self->CaptionOffY;
	self->vds.BackColor = self->Color;
	if (wmt->flags & wmtfl_hilite) {
	    self->vds.ForeColor = 0x000000; //SubColor(self->Color, 0x808080);
	    DrawColorString(1, 1, &self->vds);
	    self->vds.ForeColor = 0xffffff; //AddColor(self->Color, 0xffffff);
	} else {
	    self->vds.ForeColor = 0x808080; //AddColor(self->Color, 0x606060);
	    DrawColorString(1, 1, &self->vds);
	    self->vds.ForeColor = 0x404040; //SubColor(self->Color, 0x303030);
	}
	DrawColorString(0, 0, &self->vds);
}

void TwmTitle_DoMouseMove(TWins *self, XMotionEvent *ev) {
  TwmFrame *wmf = (TwmFrame*)self->Parent;
  int x, y, m, Bsnap;

	Bsnap = wmRoot->BorderSnap;
	if ((ev->state & Button1Mask) && 
	    (IappXDat.MouseDown.apph == self->apph)) {
	    x = IappXDat.MouseDown.obj_left + (ev->x_root - IappXDat.MouseDown.x_root);
	    y = IappXDat.MouseDown.obj_top + (ev->y_root - IappXDat.MouseDown.y_root);

	    m = IappXDat.Root_width - wmf->width;
	    if ((x >= -Bsnap) && (x <= Bsnap)) {
		x = 0;
	    } else if ((x > m-Bsnap) && (x < m+Bsnap)) {
		x = m;
	    }

	    m = IappXDat.Root_height - wmf->height;
	    if (wmRoot->Taskbar) m -= wmRoot->Taskbar->height;
	    if ((y >= -Bsnap) && (y <= Bsnap)) {
		y = 0;
	    } else if ((y > m-Bsnap) && (y < m+Bsnap)) {
		y = m;
	    }

	    TwmWin_SetupSize(wmf->wmWin, x, y, wmf->width, wmf->height, 0); 
	}
}

void TwmTitle_DoMouseDown(TWins *self, XButtonEvent *ev) {
	TWins_DoMouseDown(self, ev);
	if (ev->button != Button1) return;
	IappXDat.MouseDown.obj_left = self->Parent->left;
	IappXDat.MouseDown.obj_top = self->Parent->top;
	IappXDat.MouseDown.obj_width = self->Parent->width;
	IappXDat.MouseDown.obj_height = self->Parent->height;
	Set_Cursor(self, XC_fleur);
}

void TwmTitle_DoMouseUp(TWins *self, XButtonEvent *ev) {
  TwmFrame *wmf = (TwmFrame*)self->Parent;
	TWins_DoMouseUp(self, ev);
	if (ev->button != Button1) return;
	Set_Cursor(self, XC_top_left_arrow);
	TwmWin_SetupSize(wmf->wmWin, wmf->left, wmf->top, wmf->width, wmf->height, wmwPos_SendPosAlways);
}

void TwmTitle_SetHilite(TwmTitle *wmt, bool Hilite) {
  Pixmap pic;

	wmt->Enabled = Hilite;
	if (wmt->Enabled) {
	    wmt->flags |= wmtfl_hilite;
	    pic = wmRoot->TitleH->pic;
	} else {
	    wmt->flags &= ~wmtfl_hilite;
	    pic = wmRoot->TitleL->pic;
	}
	XSetWindowBackgroundPixmap(IappXDat.dpy, wmt->WinID, pic);
	TWins_RePaint((TWins*)wmt);
}

void TwmTitle_OnSetCaption(TWins *self, const char *s) {
  int fuEOL = 0;
	
	Chk_fio_UTF8(s, pclen(s), &fuEOL);
	if ((fuEOL & (fio_has_UTF8_char | fio_err_UTF8_char)) == fio_has_UTF8_char) {
	    self->vds.UTF8on = True;
	} else {
	    self->vds.UTF8on = False;
	}
	XClearWindow(IappXDat.dpy, self->WinID);
}

/*____________________________ Destroy __________________________________*/
bool TwmTitle__Destroy(TwmTitle *self) {
	self->vds.Font = NULL;
	ClrPic(&self->mpic);
	return TWins__Destroy((TWins*)self);
}

/*____________________________ Create __________________________________*/
static TButton *Create_title_Button(TwmTitle *self) {
  TButton *ws;
	ws = TButton_CreateS((TWins*)self, 24, 2, 16, 14, NULL);
	ws->BorderFu = mBorder;
	ws->KeyFu = 0;
	return ws;
}

TwmTitle *TwmTitle_Create(TwmFrame *wmf) {
  TwmTitle *self;
  TWins_Create_struct wcs;
  TwmWin *wmw;
  TwmWin_tcreate *tcreate;
  TGeometry gm;

	TWins_Create_struct_init(&wcs, sizeof(TwmTitle), wtyp_TwmTitle);
	wcs.Parent = (TWins*)wmf;
	wcs.CreateXWin = NULL;
	TWins_DefaultConf(&wcs);
	self = wcs.wins;

	self->Align = alTop;
	self->height = glob_Caption_height;
	self->CaptionFu = mCaptionPaint | mCaptionLeft;
	self->CaptionOffX = 19;

	self->destroy = (TDESTROY)TwmTitle__Destroy;
	self->OnResize = TwmTitle_OnResize;
	self->DoPaint = TwmTitle_DoPaint;
	self->DoMouseMove = TwmTitle_DoMouseMove;
	self->DoMouseDown = TwmTitle_DoMouseDown;
	self->DoMouseUp = TwmTitle_DoMouseUp;
	self->OnSetCaption = TwmTitle_OnSetCaption;

	TWins_CreateXWin(&wcs);
	Set_Parent((TWins*)self, (TWins*)wmf);

	self->buWinOptMenu = TWins_CreateB((TWins*)self, 1, 1, 16, 16, 0);
//	self->buWinOptMenu->KeyFu = 0;
	self->buWinOptMenu->OnMouseDown = buWinOptMenu_OnMouseDown;
	self->buWinOptMenu->OnPaint = buWinOptMenu_OnPaint;

	wmw = wmf->wmWin;
	if (wmw->tflags & tfl_MINIMIZE) {
	    self->buMinimize = Create_title_Button(self);
	    self->buMinimize->OnClick = buMinimize_OnClick;
	    self->buMinimize->OnPaint = buMinimize_OnPaint;
	}
	if (wmw->tflags & tfl_MINMAXIMIZE) {
	    self->buMaximize = Create_title_Button(self);
	    self->buMaximize->OnClick = buMaximize_OnClick;
	    self->buMaximize->OnPaint = buMaximize_OnPaint;
	}
	self->buClose = Create_title_Button(self);
	self->buClose->OnClick = buClose_OnClick;
	self->buClose->OnPaint = buClose_OnPaint;

	tcreate = wmw->tcreate;
	if (tcreate) {
	    XWMHints *WMHints = tcreate->WMHints;
	    if (WMHints) {
	      if (WMHints->flags & IconPixmapHint) {
		  if (get_geometry(WMHints->icon_pixmap, &gm)) {
		    if ((gm.depth == 1) || ((gm.depth >= 16) && (gm.depth == IappXDat.RootW_depth))) {
		      if ((gm.width > 7) && (gm.height > 7) && (gm.width < 65) && (gm.height < 65)) {
			  if (!(WMHints->flags & IconMaskHint)) WMHints->icon_mask = 0;
			  TwmTitle_Ico_32To16(self, WMHints->icon_pixmap, WMHints->icon_mask);
		      }
		    }
		  }
  Debug_msg(0, "WMHints IconPixmap=0x%x w=%d h=%d Depth=%d\n", WMHints->icon_pixmap, gm.width, gm.height, gm.depth);
	      }
	    }
	    TPic *pic = self->pic;
	    self->pic = NULL;
	    TwmTitle_LoadIcoName(self, tcreate->icon_name, True);
	    if (!self->pic) TwmTitle_LoadIcoName(self, tcreate->WMIconName, True);
	    if (self->pic) {
		ClrPic(&self->mpic);
	    } else {
		self->pic = pic;
	    }
	}

	if (!self->pic && wmf->transientfor) {
  Tapph *ap = TwmWin_Find_WinsX_Ev(IappXDat.apph, wmf->transientfor);
	  if (ap) {
	    TwmFrame *nwmf = ((TwmWin*)ap->wins)->Frame;
	    if (nwmf && nwmf->wmTitle && nwmf->wmTitle->pic) {
		TwmTitle_Ico_32To16(self, nwmf->wmTitle->pic->pic, nwmf->wmTitle->pic->mask);
	    }
	  }
	}

	if (!self->pic && wmw->window_group) {
	  Tapph *ap = IappXDat.apph;
	  while (ap) {
	    if (ap->next_child && ap->wins && (ap->wins->wtyp == wtyp_TwmFrame)) {
	      TwmFrame *nwmf = (TwmFrame*)ap->wins;
	      if (nwmf->wmWin && nwmf->wmWin->window_group &&
		  (nwmf->wmWin->window_group == wmw->window_group) && 
		  nwmf->wmTitle && nwmf->wmTitle->pic) {
		TwmTitle_Ico_32To16(self, nwmf->wmTitle->pic->pic, nwmf->wmTitle->pic->mask);
		break;
	      }
	    }
	    ap = ap->next;
	  }
	}

	if (self->pic && self->pic->mask) {
	    CombineMask(self->buWinOptMenu->WinID, self->pic->mask);
	}

	SetColor((TWins*)self, 0xa0a0a0);
	return self;
}

