/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"

typedef struct Tnx_wmDesk_exec {
  struct Tnx_wmDesk_exec *next;
  char *cmd;
  int fu;
  int exfu;
  void *owner;
} Tnx_wmDesk_exec;

static Tnx_wmDesk_exec *nx_wmDesk_exec = NULL;



void TwmDeskIcon_PID_OnTimer(TgTimer *gti) {
  Texec_pipe *expipe = gti->obj;

	if (expipe && (expipe->wtyp == wtyp_Texec_pipe)) {
	    expipe->p1 = NULL;
	}
	Std_UngrabPointer();
}

void TwmDeskIcon_App_ExecEv(Texec_pipe* expip, int evtyp) {
  TgTimer *gTimer;
  Tnx_wmDesk_exec *proc;

	if (evtyp == evtyp_ProcStart) {
	    if (expip->tag & exGrabPointer) {
		gTimer = gTimerX_Add(Timer_Enabled | Timer_OnTimerAndFree, 30000, TwmDeskIcon_PID_OnTimer);
		gTimer->obj = expip;
		expip->p1 = gTimer;
		Std_GrabPointer((TWins*)wmRoot, IappXDat.XCursors[XC_watch]);
	    }
	    if (!(expip->tag & exNoStartPid)) wmRoot->DeskStartPid = expip->pida->pid;

	} else if (evtyp == evtyp_ProcClose) {
	    if (expip->p1) {   //Test Timer Run
		Tfree(expip->p1);
		expip->p1 = NULL;
		Std_UngrabPointer();
	    }
	    proc = nx_wmDesk_exec;
	    if (proc) {
		nx_wmDesk_exec = proc->next;
		xfree(proc->cmd);
		xfree(proc);
	    }
	    if ((expip->tag & exShowErrMsgBox) && 
		expip->pp[evtyp_errfd].lb &&
		expip->pp[evtyp_errfd].lb->lg) {

		proc = nx_wmDesk_exec;
		while (proc && (proc->exfu & exSkipPrevErr)) {
		    nx_wmDesk_exec = proc->next;
		    xfree(proc->cmd);
		    xfree(proc);
		    proc = nx_wmDesk_exec;
		}
		ShowExtMsgBox(expip->pp[evtyp_errfd].lb->pc);
	    }

	    proc = nx_wmDesk_exec;
	    if (proc) {
		ExecuteProcAppTag(proc->cmd, proc->fu, TwmDeskIcon_App_ExecEv, proc->owner, NULL, proc->exfu);
	    }
	}
}

void wmDesk_exec(char *cmd, int exfu, void *owner) {
  int fu = 0;
  Tnx_wmDesk_exec *proc, **ppproc;

	if (!cmd) return;
	if (exfu & exShowErrMsgBox) fu = errfd_Open;

	proc = xcalloc(sizeof(Tnx_wmDesk_exec));
	if (!nx_wmDesk_exec) {
	    nx_wmDesk_exec = proc;
	    ExecuteProcAppTag(cmd, fu, TwmDeskIcon_App_ExecEv, owner, NULL, exfu);
	    return;
	}
	proc->cmd = pcdup(cmd);
	proc->fu = fu;
	proc->exfu = exfu;
	proc->owner = owner;
	ppproc = &nx_wmDesk_exec;
	while (*ppproc) ppproc = &(*ppproc)->next;
	*ppproc = proc;
}

void ExecDesktopFile(char *fname, Tapph *ap) {
  int ddkt;
  TpcIni *ini;
  char *cmd, *token;
  Texec_pipe *ret_expip;

	ddkt = ddkt_desktop(fname);
	if (ddkt < 1) return;

	ini = TpcIni_Create(fname);
	switch (ddkt) {

	case ddkt_Application:
	    cmd = get_desktop_CMD(ini, 0, NULL);
	    ExecuteProcAppTag(cmd, 0, TwmDeskIcon_App_ExecEv, wmRoot, 
				&ret_expip, exGrabPointer);
	    xfree(cmd);
	    if (ret_expip) ret_expip->fname = pcdup(fname); //is NET_WM_PID free in TwmWin
	    break;

	case ddkt_ALDeskBuildin:
	    cmd = TpcIni_RD(ini, Desktop_Entry, "ALDeskBuildin");
	    if (cmd) {
		cmd = GetToken(cmd, &token);
		exec_Buildin(ap, token, cmd, 0);
		xfree(token);
	    }
	    break;
	} //case
	Tfree(ini);
}

void menu_ExecDesktopFile(TMenuFile *mf, long KeyState, Tapph *ap) {
  TMenuFileItem *mfi = (TMenuFileItem*)mf->SelItem;
  char *pc;
	if (mfi && mfi->filename) {
	    pc = pcadd(mf->path, mfi->filename);
	    ExecDesktopFile(pc, ap);
	    xfree(pc);
	}
}
