/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"

/* _____________________________ Mount _______________________________ */
typedef struct {
  char *fn, *cmd;
} TMsgBox_mount_path;

static void MsgBox_mount_path_ev(Texec_pipe *expip, int evtyp) {
  TMsgBox_mount_path *mp;

	if (evtyp == evtyp_ProcClose) {
	    mp = expip->owner;
// MsgBox return: test create mount path (zB.: /media/sda1)
	    if (pcncmp(expip->pp[evtyp_infd].lb->pc, "YES", 3)) {
		if (file_mkdir_e(mp->fn, 0)) {
		    wmDesk_exec(mp->cmd, exShowErrMsgBox | exNoStartPid, NULL);
		}
	    }
	    xfree(mp->fn);
	    xfree(mp->cmd);
	    xfree(mp);
	}
}

void meDeskIcon_mount_Click(TpcIni *ini) {
  char *pc, *pcn, *fn;
  bool opton;
  char buf[256];

	fn = TpcIni_RD(ini, Desktop_Entry, "MountPoint");
	if (!fn) return;
	pc = buf;
	pcn = TpcIni_RD(ini, Desktop_Entry, "Exec");
	if (!pcn) pcn = "mount";
	ppcmove_k(&pc, pcn, kSPACE_ADD);
	pcn = TpcIni_RD(ini, Desktop_Entry, "FSType");
	if (pcn) {
	    ppcmove(&pc, "-t ");
	    ppcmove_k(&pc, pcn, kSPACE_ADD);
	}
	ppcmove_k(&pc, TpcIni_RD(ini, Desktop_Entry, "Dev"), kSPACE_ADD);
	ppcmove(&pc, fn);

	opton = False;
	pcn = TpcIni_RD(ini, Desktop_Entry, "Options");
	if (pcn) {
	    ppcmove(&pc, " -o ");
	    ppcmove(&pc, pcn);
	    opton = True;
	}

	if (TpcIni_RD_boolean(ini, Desktop_Entry, "ReadOnly", False)) {
	    if (opton) {
		*pc = ','; pc++;
	    } else {
		ppcmove(&pc, " -o ");
	    }
	    ppcmove(&pc, "ro");
	}

	if (!file_chk_exist(fn, findDIR)) {
	    TMsgBox_mount_path *mp = xmalloc(sizeof(TMsgBox_mount_path));
	    mp->fn = pcdup(fn);
	    mp->cmd = pcdup(buf);

	    pc = buf;
	    wmExcCMD_headX(&pc, "aldmessagebox");
	    ppcmove(&pc, " -fYES,NO -dYES -w0 \"mount path ");
	    ppcmove(&pc, fn);
	    ppcmove(&pc, " not exist\n do create ???\"");

	    ExecuteProcApp(buf, infd_Open, MsgBox_mount_path_ev, mp, NULL);
	} else {
	    wmDesk_exec(buf, exShowErrMsgBox | exNoStartPid | exGrabPointer, NULL);
	}
}

void meDeskIcon_umount_Click(TpcIni *ini) {
  char *pc, *pcn, *fn;
  char buf[256];

	fn = TpcIni_RD(ini, Desktop_Entry, "Dev");
	if (!pcncmp(fn, "/dev/", 5)) fn = TpcIni_RD(ini, Desktop_Entry, "MountPoint");
	if (!fn) return;
	pc = buf;
	*pc = 'u'; pc++;
	pcn = TpcIni_RD(ini, Desktop_Entry, "Exec");
	if (!pcn) pcn = "mount";
	ppcmove_k(&pc, pcn, kSPACE_ADD);
	ppcmove(&pc, fn);
	if (pc[-1] != '/') {*pc = '/'; pc++; *pc = 0;}
	wmDesk_exec(buf, exShowErrMsgBox | exNoStartPid | exGrabPointer, NULL);
}

/* _____________________________ Ev __________________________________ */

void miMount_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TDesktopIcon *di;
  TpcIni *ini;
	di = get_owner_DesktopIcon((TWins*)self);
	if (!di || !di->fname) return;
	ini = TpcIni_Create(di->fname);
	meDeskIcon_mount_Click(ini);
	Tfree(ini);
}

void miUmount_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TDesktopIcon *di;
  TpcIni *ini;
	di = get_owner_DesktopIcon((TWins*)self);
	if (!di || !di->fname) return;
	ini = TpcIni_Create(di->fname);
	meDeskIcon_umount_Click(ini);
	Tfree(ini);
}

void miEject_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TDesktopIcon *di;

	di = get_owner_DesktopIcon((TWins*)self);
	if (di && (di->pic == di->pic2)) {
	    miUmount_OnClick(self, KeyState, mi);
	}
	wmDesk_exec((char*)mi->obj, exShowErrMsgBox | exNoStartPid | exGrabPointer, NULL);
}

void miDeleteDeskIcon_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TDesktopIcon *di;

	di = get_owner_DesktopIcon((TWins*)self);
	if (!di) return;
	remove(di->fname);
}

void menu_Default_DeskIcon_OnMenuOpen(TMenu *self) {
  TDesktopIcon *di;
  TMenuItem *mi, *mitop;
  TpcIni *ini = NULL;
  char *pc, *sdev;
  int gdifu;
  TDesktopHead ddkh;
  char buf[200];

	di = get_owner_DesktopIcon((TWins*)self);
	if (!di) return;

	mitop = TMenu_AddItem(self, GetCaption_pc(di->WinCaption), miCanNotSelect, NULL);
	ini = TpcIni_Create(di->fname);

	if (dotdesktop_get_head(ini, &ddkh)) {
	    gdifu = gdifu_getico0;
	    if (di->ddkt == ddkt_FSDevice) {

		mi = NULL;
		TMenu_AddItem(self, "-", 0, NULL);
		if (di->pic == di->pic2) {
		    gdifu = gdifu_getico1;
		    mi = TMenu_AddItem(self, "umount", 0, miUmount_OnClick);
		} else if (di->pic == di->pic3) {
		    mi = TMenu_AddItem(self, "mount", 0, miMount_OnClick);
		} else if (di->pic == di->pic4) {
		    gdifu = gdifu_getico2;
		}

		if (mi) {
      TFSDevice_info *fs_info = get_fs_info(di->s2);
		    if (fs_info) {
			if (fs_info->stat & FSINFO_OK) {
			    pc = buf;
			    ppcmove_k(&pc, fs_info->type, kSPACE_ADD);
			    ppcmove(&pc, fs_info->size);
			    mi = TMenu_InsItem(self, buf, 1);
			    mi->fu = miCanNotSelect;
			}
			sdev = pcadd("/dev/",  fs_info->dev0);
			if (chk_dev_removable(sdev)) {
			    pc = "eject ";
			    if (pcncmp(fs_info->dev0, "sd", 2)) pc = "eject -s ";
			    mi = TMenu_AddItem(self, "Eject", 0, miEject_OnClick);
			    mi->obj = pcadd(pc, sdev);
			}
			xfree(sdev);
		    }
		}
	    }
	    gdifu |= gdifu_noUnknown;
	    mitop->pic = GetDeskIcon(ddkh.ddkt, 16, ddkh.icon, gdifu, NULL);
	}
	if (!mitop->pic) {
	    mitop->pic = GetDeskIcon(ddkt_Actions, 16, "desktop", 0, NULL);
	}

	Tfree(ini);

	TMenu_AddItem(self, "-", 0, NULL);
	TMenu_AddItem(self, "Delete", 0, miDeleteDeskIcon_OnClick);
	Menu_OnMenuOpen(self);
}

void menu_Default_DeskIcon_OnMenuClose(TMenu *self, int stat) {
  TMenuItem *mi;

	Menu_OnMenuClose(self, stat);
	if (stat != me_stClose) return;
	mi = self->MenuItem;
	while (mi) {
	    ppfree(&mi->obj);
	    mi = mi->next;
	}
	TMenu_Cls(self);
}

/*_____________________________ Create __________________________________*/
void menu_DeskIcon(TwmRoot *wmr) {
  TMenu *me;
/* ****** Menu Default Desktop Icon ****** */
	me = TMenu_Create((TWins*)wmr);
	me->OnMenuOpen = menu_Default_DeskIcon_OnMenuOpen;
	me->OnMenuClose = menu_Default_DeskIcon_OnMenuClose;
	wmr->menu_Default_DeskIcon = me;
}
