/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#ifndef __ALDFILE_H__
#define __ALDFILE_H__    1

#include "appXbase.h"
#include "xcopy.h"

#include "tfilewin.h"
#include "FormProperty.h"

#ifdef USE_BULDIN_APP
#include "buildin_app/buildin_app.h"
#endif

#define APPNAME "aldfile"

extern const int build_v;
extern const char *build_date;
extern const char *Help_Msg;

typedef struct {
  AlgTWins
  AlgTForm

  TWins *pnlTop;
  TWins *pnlMiddle;
  TWins *pnlBottom;

// ******* PanelTop *******
  TMenuButton *mbFile;
    TMenu *menuFile;

  TMenuButton *mbEdit;
    TMenu *menuEdit;
        TMenu *menuNew;
        TMenuFile *menuOpenWith;
	TMenuItem *miOpenWith;
	TMenuItem *miTools;

  TMenuButton *mbTools;
        TMenuFile *menuTools;

  TMenuButton *mbSetting;
    TMenu *menuSetting;
      TMenuItem *miDblItem;
      TMenuItem *miDblPath;
      TMenuItem *miCaseSort;

  TMenuButton *mbHelp;
    TMenu *menuHelp;

  TMenuButton *mbTerm;

  TComboBox *edPath;

  TMenuButton *mbPathRet;

  TMenuButton *mbAzArt;

  TTreeVFile *tv;
  TTreeVNode *tvnet;
  TTreeVNode *tvftp;
  TTreeVNode *tvrfn;

  TSplitterV *splitt;

  TFileWin *fw;
    int fw_cTi;
    char *fw_sTi;

  TWins *lblStat;
  TWins *lblURLStat;

  TFormProperty *mfp;

} TMainForm;

extern void aldfile_LoadSetting(TMainForm *self);



extern void MenuFile_Create(TMainForm *self);
/* ------------------- mEdit.c ------------------------------------------ */
extern void MenuEdit_Create(TMainForm *self);

#define cmd_onlyPath	0x01
extern void OpenWith_Click(TMenuFile *self, int fu);

typedef struct {
  TDirFileList *dfl;
  TglobPath *gp;
  TDesktop_gpList *gpList;
  union {
    TTreeVFile *tv;
    TFileWin *fw;
  } o;
  bool istv;
  bool isLocalF;
} Txdfl;

extern bool get_MenuFileItem_xdfl(TMenuFile *self, Txdfl *xdfl);
extern TglobPath *pcsel_to_tls(char *pcsel, TLines *tls);

/* ---------------------------------------------------------------------- */
extern void MenuTools_Create(TMainForm *self);
extern void MenuSetting_Create(TMainForm *self);
extern void SetFileSystemUTF8(TMainForm *self, bool UTF8);
extern void MenuHelp_Create(TMainForm *self);

extern void tv_net_create();

extern void TFormCopy_Show(TWins *Parent, char *pcsel, TglobPath *gp_dest);

extern void TFormCopyRun_Show(TWins *Parent, TLines *tls_src, TglobPath *gp_src, 
			TglobPath *gp_dest, int skip);
extern int Copy_ErrorMsgShow(TWins *parent, Txpy_wd wd, int xcyMsg);

extern int TFormOverWrite_Show(TWins *Parent, Txpy_wd wd, int xcyMsg, int fu);


extern void TFormDel_Show(TWins *Parent, char *pcsel);
extern void TFormDelRun_Show(TWins *Parent, TLines *tls_src, TglobPath *gp_src, int skip);

extern bool TFormExecWith_Show(TWins *parent, char *fname, Tstat64 *st, TMimeDat *md);
extern char *inFormExecWith_chk_app_mime(char *fname, TMimeDat *md);

extern void init_tvImgRun();
extern void TRunImg_Add(TTreeVNode *tvn, TDirListObjNy *ObjNy);
extern void TRunImg_Del(TTreeVNode *tvn);
extern void TRunImg_Del_ObjNy(TDirListObjNy *ObjNy);

extern int xcy_ErrorMsgShow(TWins *parent, Txpy_wd wd, int xcyMsg);

extern void TFormPropNet_Show(TMainForm *Parent, Txdfl *xdfl);

#endif /* __ALDFILE_H__ */
