/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldfile.h"
#include "dlg.h"
#include "tdirlist.h"

static void ie_exec(TFileWin *self, TItemEnter *ie, TMimeDat *md) {
// printf("%s(%d): exec --> %s\n", FL, md->exec);
// printf("%s(%d): exec --> %s%s\n", FL, md->path, md->fn);
  TDirFileList *dfl;
  TDesktop_gpList *gpList;
  TDesktopCMD dskcmd;

	dfl = TFileWin_Get_Select_dfl(self, NULL);
	if (dfl) {
	    gpList = xcalloc(sizeof(TDesktop_gpList));
	    gp_dup_gpdata_path(&gpList->gp, ie->gp);
	    gpList->gp.name = pcdup(dfl->fn);

	    dskcmd.gpList = gpList;
	    dskcmd.Exec = md->exec;
	    get_desktop_dskcmd(&dskcmd);
	    if (dskcmd.ret_cmd) {
// printf("%s(%d): exec --> %s\n", FL, dskcmd.ret_cmd);
#ifndef _OS_WIN32
		exec_pc(dskcmd.ret_cmd);
#endif
		xfree(dskcmd.ret_cmd);
	    }
	    gp_pc_free(&gpList->gp);
	    xfree(gpList);
	}
}

void fw_ItemEnter(TFileWin *self, TItemEnter *ie) {
  char *pc, *pc_mime;
  TMimeDat md;
  char buf[200];

	if (ie->dfl->st->FileType == stft_Exec) {
	    if (gp_test_local_drive(ie->gp)) {
		pc = pcadd(ie->gp->path, ie->dfl->fn);
#ifndef _OS_WIN32
		exec_pc(pc);
#endif
		xfree(pc);
	    } else {
		appError(EMSG_ERR1, "%s(%d): can only exec local file\n  \"%s\"", FL, ie->fn);
	    }
	    return;
	}

	pc_mime = stat_get_mimetype(ie->dfl->st, ie->fn_passwd);
// printf("%s(%d): %d/%d --> %s\n", FL, ie->dfl->st->FileType, ie->dfl->st->sub_mime, pc_mime);

	if (!pc_mime) {

	    pc_mime = inFormExecWith_chk_app_mime(ie->fn, &md);
	    if (pc_mime) {
		snprintf(buf, sizeof(buf), "'Found: %s\n\nAdd mime: %s\n", 
				    md.exec, pc_mime);
		int ret = MsgBox_Show((TWins*)self, "Found App", buf,
				    msgOK | msgCANCEL|msgIcoINFO, msgCANCEL);
		if (ret == msgOK) {
		    pc = buf;
		    *pc = '*'; pc++;
		    *pc = '.'; pc++;
		    pcxmove(pc, GetFileExt_pc(ie->fn), 31);
		    pctoLcaseASCII(buf);
		    pc = pcadd_n(4, IappDat.ALDini_dir, 
			    "/share/mimelnk/", pc_mime, ".desktop");
		    dotdesktop_new(pc, NULL, "", pc_mime, buf, NULL, ddkt_Mime);
		    xfree(pc);
		} else {
		    ppcfree(&pc_mime);
		}
	    }
	}

	if (mimetype2app_getdat(pc_mime, &md)) {
	    ie_exec(self, ie, &md);
	} else if (pcncmp(pc_mime, "text/", 5) && mimetype2app_getdat("text/plain", &md)) {
	    ie_exec(self, ie, &md);
	} else if (TFormExecWith_Show((TWins*)self, ie->fn_passwd, ie->dfl->st, &md)) {
	    ie_exec(self, ie, &md);
	    xfree(md.exec);
	}
	xfree(pc_mime);
#if 0
  char *pfn;
  TglobPath *gp;
	gp = TFileWin_Get_gp(self);
	if (gp_test_local_drive(gp)) {
	    pfn = gptopc(gp, gptfu_noName|gptfu_noRootArt);
	    ppcadd(&pfn, ie->dfl->fn);
	    pc_mime = libmagic_get_mime(pfn);
 printf("%s(%d): libmagic --> *%s*\n", FL, pc_mime);
	    xfree(pfn);
	}
#endif
}

