/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldfile.h"

static void aldfile_SaveSetting() {
  TpcIni *ini = IappDat.appIni;
  TMainForm *mf = IappDat.obj;

	if (!ini) ini = TpcIni_Create(IappDat.inifile_app);
	TpcIni_WR_boolean(ini, "Dlg_File", "Az0_ItemE_Dbl", mf->fw->FDL_Def.Az0_ItemE_Dbl);
	TpcIni_WR_boolean(ini, "Dlg_File", "Az0_PathE_Dbl", mf->fw->FDL_Def.Az0_PathE_Dbl);
	TpcIni_WR_boolean(ini, "Dlg_File", "Az1_ItemE_Dbl", mf->fw->FDL_Def.Az1_ItemE_Dbl);
	TpcIni_WR_boolean(ini, "Dlg_File", "Az1_PathE_Dbl", mf->fw->FDL_Def.Az1_PathE_Dbl);

	TpcIni_WR_boolean(ini, "Dlg_File", "CaseSort", ((mf->miCaseSort->fu & miChecked) != 0));

	TpcIni_Save(ini);
	if (!IappDat.appIni) Tfree(ini);
}

void aldfile_LoadSetting(TMainForm *self) {
  TpcIni *ini = IappDat.appIni;
  bool mk;

	if (!ini) ini = TpcIni_Create(IappDat.inifile_app);
	self->fw->FDL_Def.Az0_ItemE_Dbl = TpcIni_RD_boolean(ini, "Dlg_File", "Az0_ItemE_Dbl", False);
	self->fw->FDL_Def.Az0_PathE_Dbl = TpcIni_RD_boolean(ini, "Dlg_File", "Az0_PathE_Dbl", False);
	self->fw->FDL_Def.Az1_ItemE_Dbl = TpcIni_RD_boolean(ini, "Dlg_File", "Az1_ItemE_Dbl", True);
	self->fw->FDL_Def.Az1_PathE_Dbl = TpcIni_RD_boolean(ini, "Dlg_File", "Az1_PathE_Dbl", False);
	if ((self->fw->AzArt & 0xff) == 0) {
	    self->fw->DblClick_ItemEnter = self->fw->FDL_Def.Az0_ItemE_Dbl;
	    self->fw->DblClick_PathEnter = self->fw->FDL_Def.Az0_PathE_Dbl;
	} else {
	    self->fw->DblClick_ItemEnter = self->fw->FDL_Def.Az1_ItemE_Dbl;
	    self->fw->DblClick_PathEnter = self->fw->FDL_Def.Az1_PathE_Dbl;
	}
	self->miDblItem->fu &= ~miChecked;
	self->miDblPath->fu &= ~miChecked;
	if (self->fw->DblClick_ItemEnter) self->miDblItem->fu |= miChecked;
	if (self->fw->DblClick_PathEnter) self->miDblPath->fu |= miChecked;

	mk = TpcIni_RD_boolean(ini, "Dlg_File", "CaseSort", False);
	self->miCaseSort->fu &= ~miChecked;
	if (mk) self->miCaseSort->fu |= miChecked;
	self->fw->sortFu &= ~dlsortFu_Case;
	if (mk) self->fw->sortFu |= dlsortFu_Case;

	if (!IappDat.appIni) Tfree(ini);
}

/* ______________________ File Ev ____________________________________ */
static void miDblItem_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TMainForm *mf = (TMainForm*)self->ParentForm;
	mf->fw->DblClick_ItemEnter = (mi->fu & miChecked) != 0;
	if ((mf->fw->AzArt & 0xff) == 0) {
	    mf->fw->FDL_Def.Az0_ItemE_Dbl = (mi->fu & miChecked) != 0;
	} else {
	    mf->fw->FDL_Def.Az1_ItemE_Dbl = (mi->fu & miChecked) != 0;
	}
	aldfile_SaveSetting();
}

static void miDblPath_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TMainForm *mf = (TMainForm*)self->ParentForm;
	mf->fw->DblClick_PathEnter = (mi->fu & miChecked) != 0;
	if ((mf->fw->AzArt & 0xff) == 0) {
	    mf->fw->FDL_Def.Az0_PathE_Dbl = (mi->fu & miChecked) != 0;
	} else {
	    mf->fw->FDL_Def.Az1_PathE_Dbl = (mi->fu & miChecked) != 0;
	}
	aldfile_SaveSetting();
}

static void miHidden_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TMainForm *mf = (TMainForm*)self->ParentForm;
	TFileWin_SetShowHidden(mf->fw, (mi->fu & miChecked) != 0);
}

static void miCaseSort_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TMainForm *mf = (TMainForm*)self->ParentForm;
  int m;
	m = mf->fw->sortFu & ~dlsortFu_Case;
	if (mi->fu & miChecked) m |= dlsortFu_Case;
	TFileWin_SetSort(mf->fw, m);
	aldfile_SaveSetting();
}

void SetFileSystemUTF8(TMainForm *self, bool UTF8) {
  TpcIni *ini;
	TWins_SetUTF8((TWins*)self->edPath, UTF8);
	TWins_SetUTF8((TWins*)self->tv, UTF8);
	TWins_SetUTF8((TWins*)self->fw, UTF8);

	ini = TpcIni_Create(IappDat.inifile_global);
	TpcIni_WR_boolean(ini, "Global", "FileSystemUTF8", UTF8);
	TpcIni_SaveAndFree(ini);
}
static void miUTF8_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
	IappXDat.FileSystemUTF8on = mi->fu & miChecked;
	SetFileSystemUTF8((TMainForm*)self->ParentForm, IappXDat.FileSystemUTF8on);
}

/* ______________________ Create _____________________________________ */
void MenuSetting_Create(TMainForm *self) {
  int m;
	self->mbSetting = TMenuButton_CreateS(self->pnlTop, self->mbFile, "Settings");
	self->menuSetting = TMenu_Create((TWins*)self);
	self->mbSetting->menu = self->menuSetting;
	self->miDblItem = TMenu_AddItem(self->menuSetting, "Dbl-Click Item",
				miCanCheck | miAutoToggle, miDblItem_OnClick);
	self->miDblPath = TMenu_AddItem(self->menuSetting, "Dbl-Click Path",
				miCanCheck | miAutoToggle, miDblPath_OnClick);
	TMenu_AddItem(self->menuSetting, "Show Hidden", 
				miCanCheck | miChecked | miAutoToggle, miHidden_OnClick);
	self->miCaseSort = TMenu_AddItem(self->menuSetting, "Case Sort",
				miCanCheck | miAutoToggle, miCaseSort_OnClick);

	m = miCanCheck | miAutoToggle;
	if (IappXDat.FileSystemUTF8on) m = miCanCheck | miChecked | miAutoToggle;
	TMenu_AddItem(self->menuSetting, "-", 0, NULL);
	TMenu_AddItem(self->menuSetting, "File UTF-8", 
				m, miUTF8_OnClick);
}
