/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldpic.h"

void ALDpic_Chk_Mask(TMainForm *fpic, TPixMap *pxm) {
	if (!fpic->Alpha) {
	    fpic->AZClear = 0;
	    if (pxm->stat & pmxStat_HandleMask) {
		pxm->stat &= ~(pmxStat_XMaskPixAkt | pmxStat_HandleMask);
		if (pxm->maskID) XFreePixmap(IappXDat.dpy, pxm->maskID);
		pxm->maskID = 0;
		FreeGC(pxm->mask_gc);
		pxm->mask_gc = NULL;
		pxm->gcv.clip_mask = 0;
		pxm->gcv.clip_x_origin = 0;
		pxm->gcv.clip_x_origin = 0;
	    }
	} else {
	    if ((pxm->stat & pmxStat_has_alpha_tgl) &&
		!(pxm->stat & pmxStat_HandleMask)) {
		if (!pxm->mask_data) alpha2bitmask((TImage*)pxm);
		pxm->stat |= pmxStat_HandleMask;
		fpic->AZClear = 2;
	    }
	}
}

void ALDpic_Chk_AutoMask(TMainForm *fpic, int fu) {
  TPixMap *pxm = fpic->pxm;

	if (!pxm || (fpic->org_stat & pmxStat_has_alpha)) return;
        if (fpic->bmp_AutoMask) {
	    if (pxm->stat & pmxStat_has_alpha) return;
	    TImage_ColorToAlphaData((TImage*)pxm, *((dword*)(pxm->data + (pxm->bytes_per_line * (pxm->height-1)))));
	    alpha_data8_set((TImage*)pxm);
	    alpha_bm_stat((TImage*)pxm);
	    xfree(pxm->rgb565_alpha_data);
	    pxm->rgb565_alpha_data = NULL;
	    if (fu) ALDpic_resize_pxm(fpic);
	} else {
	    if (!(pxm->stat & pmxStat_has_alpha)) return;
	    alpha_data8_clr((TImage*)pxm);
	    if (fu) ALDpic_resize_pxm(fpic);
	    fpic->AZClear = 0;
	}
}

void ALDpic_Chk_dup_paint_pxm(TMainForm *fpic) {
	ALDpic_Chk_vioc_pxm(fpic);
  dword t = GetTime_us();
	fpic->paintTime = 0;
  TPixMap *pxm = ALDpic_pxm_get(fpic, ib_paintbase_pxm);

	if (!pxm) return;

	if (IappXDat.RootW_depth > 16) return;
	if ((pxm->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp) return;


	if (fpic->paint_pxm && ((pxm->width  != fpic->paint_pxm->width) ||
				(pxm->height != fpic->paint_pxm->height))) {
	    ALDpic_pxm_free(fpic, ib_paint_pxm);
	}

	if (fpic->paint_pxm) {
	    if (fpic->RePaint_pxm) {
		TImage_rgb888move565((TImage*)pxm, (TImage*)fpic->paint_pxm);
		if (fpic->Alpha && (pxm->stat & pmxStat_has_alpha_tgl)) {
		    alpha2bitmask((TImage*)fpic->paint_pxm);
		    fpic->AZClear = 2;
		}
	    }
	} else {
	    fpic->paint_pxm = (TPixMap*)TImage_rgb888to565((TImage*)pxm);
	}
	fpic->RePaint_pxm = False;
	fpic->paintTime = GetCurTimeDiv_us(t);
}

void ALDpic_Chk_vioc_pxm(TMainForm *fpic) {
  TVideo_IOC *vioc = fpic->ioc_colorRGB;
  TVideo_Color_Korr *tvckr = fpic->ioc_colorRGB->tvckr;
  int any_akt;
  dword t = GetTime_us();
  bool RePaint_pxm;

	fpic->viocTime = 0;
  TPixMap *pxm = ALDpic_pxm_get(fpic, ib_base_pxm);
	if (!pxm || !tvckr) return;

	RePaint_pxm = False;
	if (fpic->QuantMk != fpic->fpal->cbColQuantOn->Checked) {
	    fpic->QuantMk = fpic->fpal->cbColQuantOn->Checked;
	    RePaint_pxm = True;
	}

	if (tvckr->Brightness != fpic->pnlBrightness->val) {
	    tvckr->Brightness = fpic->pnlBrightness->val;
	    RePaint_pxm = True;
	}
	if (tvckr->Contrast != fpic->pnlContrast->val) {
	    tvckr->Contrast = fpic->pnlContrast->val;
	    RePaint_pxm = True;
	}
	if (fpic->gray) {
	    if (tvckr->ColorSat != -256) {
		tvckr->ColorSat = -256;
		RePaint_pxm = True;
	    }
	} else if (tvckr->ColorSat != fpic->pnlColorSat->val) {
	    tvckr->ColorSat = fpic->pnlColorSat->val;
	    RePaint_pxm = True;
	}
	if (tvckr->Red != fpic->pnlRed->val) {
	    tvckr->Red = fpic->pnlRed->val;
	    RePaint_pxm = True;
	}
	if (tvckr->Green != fpic->pnlGreen->val) {
	    tvckr->Green = fpic->pnlGreen->val;
	    RePaint_pxm = True;
	}
	if (tvckr->Blue != fpic->pnlBlue->val) {
	    tvckr->Blue = fpic->pnlBlue->val;
	    RePaint_pxm = True;
	}

	if (vioc->iocfu != fpic->iocfu) {
	    vioc->iocfu = fpic->iocfu;
	    RePaint_pxm = True;
	}

	if (fpic->paint_bpp != fpic->bpp) {
	    fpic->paint_bpp = fpic->bpp;
	    if (fpic->bpp) RePaint_pxm = True;
	}

	if (fpic->vio_pxm) {
	    if ((pxm->width != fpic->vio_pxm->width) ||
		(pxm->height != fpic->vio_pxm->height)) {
		ALDpic_pxm_free(fpic, ib_vio_pxm);
	    }
	}

	any_akt = tvckr->Brightness || tvckr->Contrast || tvckr->ColorSat ||
		  tvckr->Red || tvckr->Green || tvckr->Blue || 
		  (vioc->iocfu & VIOCFU_NEGATIV);

	if (fpic->bpp || any_akt) {
	  if (!fpic->vio_pxm || RePaint_pxm) {

	    fpic->QuantOk = False;
	    fpic->RePaint_pxm = True;
	    if (!fpic->vio_pxm) {
		fpic->vio_pxm = (TPixMap*)TImage_Create_dup_struct((TImage*)pxm, 0x01);
	    } else {
		Tfree(fpic->vio_pxm->cmap);
		fpic->vio_pxm->cmap = NULL;
	    }

  TMediaFrame fio;
  TIOCVideoF iof;
  TIOCVideoF ret_iof;

	    Fill0(&fio, sizeof(TFrame_IO));
	    Fill0(&iof, sizeof(TIOCF));
	    Fill0(&ret_iof, sizeof(TIOCF));
	    fio.org.v.iof = &iof;
	    fio.ret.v.iof = &ret_iof;
	    iof.typ = DatType_TImage;
	    ret_iof.typ = DatType_TImage;
	    fio.org.v.t.img = (TImage*)pxm;
	    fio.ret.v.t.img = (TImage*)fpic->vio_pxm;


	    switch (fpic->bpp) {
	    case pmxWR_bpp6: 
		tvckr->R_reduce = 5;
		tvckr->G_reduce = 5;
		tvckr->B_reduce = 5;
		break;
	    case pmxWR_bpp7: 
		tvckr->R_reduce = 5;
		tvckr->G_reduce = 9;
		tvckr->B_reduce = 5;
		break;
	    case pmxWR_bpp8: 
		tvckr->R_reduce = 9;
		tvckr->G_reduce = 9;
		tvckr->B_reduce = 5;
		break;
	    case pmxWR_bpp9: 
		tvckr->R_reduce = 9;
		tvckr->G_reduce = 9;
		tvckr->B_reduce = 9;
		break;
	    case pmxWR_bpp10: 
		tvckr->R_reduce = 9;
		tvckr->G_reduce = 17;
		tvckr->B_reduce = 9;
		break;
	    case pmxWR_bpp12: //rgb_mask = 0xf0f0f0; break;
		tvckr->R_reduce = 17;
		tvckr->G_reduce = 17;
		tvckr->B_reduce = 17;
		break;
	    case pmxWR_bpp15: //rgb_mask = 0xf8f8f8; break;
		tvckr->R_reduce = 33;
		tvckr->G_reduce = 33;
		tvckr->B_reduce = 33;
		break;
	    case pmxWR_bpp16: //rgb_mask = 0xf8f8f8; break;
		tvckr->R_reduce = 33;
		tvckr->G_reduce = 65;
		tvckr->B_reduce = 33;
		break;
	    case pmxWR_bpp18: //rgb_mask = 0xfcfcfc; break;
		tvckr->R_reduce = 65;
		tvckr->G_reduce = 65;
		tvckr->B_reduce = 65;
		break;
	    default:
		tvckr->R_reduce = 0;
		tvckr->G_reduce = 0;
		tvckr->B_reduce = 0;
	    }
	    Video_IOC_SetColor(vioc, NULL);
	    Video_IOC_Get_Frame(vioc, &fio);
//	    Video_IOC_Conv(vioc);

	  }
	} else {
	    if (fpic->vio_pxm) {
		if (!fpic->fpal->cbColQuantOn->Checked) {
		    fpic->RePaint_pxm = True;
		    ALDpic_pxm_free(fpic, ib_vio_pxm);
		}
	    }
	    if (fpic->fpal->cbColQuantOn->Checked) {
		if (!fpic->vio_pxm) {
		    fpic->QuantOk = False;
		    fpic->vio_pxm = (TPixMap*)TImage_Create_dup_struct((TImage*)pxm, 0x01);
		}
		if (!fpic->QuantOk || RePaint_pxm) {
		    fpic->QuantOk = False;
		    pnmove(fpic->vio_pxm->data, pxm->data, pxm->bytes_per_line * pxm->height);
		}
	    }
	}

	ColorsQuant(fpic);

	fpic->viocTime = GetCurTimeDiv_us(t);
}
