/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "ElMath.h"

void TFormRLConoff_DoPaint(TWins *self) {
  TFormRLConoff *fof = (TFormRLConoff*)self;
	if (fof->pic) {
	    DrawPic(fof->WinID, fof->pic, 
			(fof->width - fof->pic->width) >> 1, 
			(fof->height - fof->pic->height) >> 1);
	}
	TWins_DoPaint(self);
}

void TFormRLConoff_DoMouseDown(TWins *self, XButtonEvent *ev) {
  TFormRLConoff *fof = (TFormRLConoff*)self;
  TFormRLC *fRLC = (TFormRLC*)fof->Form;
	TWins_DoMouseDown(self, ev);
	if (fRLC) {
	    fRLC->tag = ((fof->BorderFu & mBorderL) == 0);
	    SetVisible((TWins*)fRLC, fRLC->tag != 0);
	    if (fRLC->Save) fRLC->Save(fRLC);
	}
}

TFormRLConoff *TFormRLConoff_Create(TWins *Parent) {
  TFormRLConoff *fof;
  TWins_Create_struct wcs;
	TWins_Create_struct_init(&wcs, sizeof(TFormRLConoff), wtyp_Wins);
	wcs.Parent = Parent;
	TWins_DefaultConf(&wcs);
	fof = wcs.wins;
	fof->DoPaint = TFormRLConoff_DoPaint;
	fof->DoMouseDown = TFormRLConoff_DoMouseDown;
	fof->BorderFu = mBorder;
	return fof;
}

TFormRLConoff *TFormRLConoff_CreateU(TWins *Parent, int left, int top, int width, int height, TPic *pic) {
  TFormRLConoff *fof = TFormRLConoff_Create(Parent);
	fof->pic = pic;
	fof->top = top;
	fof->left = left;
	fof->width = width;
	fof->height = height;
	Set_Parent((TWins*)fof, Parent);
	return fof;
}

void TFormRLConoff_Owner_OnShow(TForm *Form) {
  TFormRLConoff *fof = (TFormRLConoff*)Form->owner;
	fof->BorderFu |= mBorderL;
	Refresh((TWins*)fof);
}
void TFormRLConoff_Owner_OnCanClose(TForm *Form, int *CanClose) {
  TFormRLConoff *fof = (TFormRLConoff*)Form->owner;
	fof->BorderFu &= ~mBorderL;
	RePaint((TWins*)fof);
}

void TFormRLConoff_SetForm(TFormRLConoff *fof, TForm *Form) {
	Form->owner = (TWins*)fof;
	Form->OnShow = TFormRLConoff_Owner_OnShow;
	Form->OnCanClose = TFormRLConoff_Owner_OnCanClose;
	fof->Form = Form;
}

void TFormRLC_Save(TFormRLC* fRLC) {
  TpcIni *pcIni = TpcIni_Create(IappDat.inifile_app);
  char buf[256];
	snprintf(buf, sizeof(buf), "%d %d %d", fRLC->left, fRLC->top, fRLC->tag);
	TpcIni_WRstr(pcIni, fRLC->Gruppe, fRLC->sXY, buf);
	TpcIni_SaveAndFree(pcIni);
}
