/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public
 License along with this program; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA

 ----------------------------------------------------------------
 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"
#include "dlg.h"
#include "cicons.h"

typedef struct {
  AlgTWins
  AlgTForm
  TWins *PanelTop;

  TMenuButton *mbFile;
    TMenu *menuFile;

  TMenuButton *mbEdit;

  TMenuButton *mbHelp;
    TMenu *menuHelp;
} TFormMain;

int build_v = ALD_BUILD_V;
char *build_date = __DATE__;

static void mHelp_Info(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormMain *fmain = (TFormMain*)self->ParentForm;
  char buf[80];
	snprintf(buf, sizeof(buf), "ALDconsole %s   (build-%d  %s)", 
				VERSION, build_v, build_date);
	Copyright_MsgBox_Show((TWins*)fmain, buf);
}

void mExit_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  Close();
}

void mFile_OnMenuOpen(TMenu *self) {
}

char *Help_Msg = {
  "\n"
  "Usage: edit\n"
  "\n"
  "  -h, --help           Prints out this screen\n\n"
  "  ALDccp: edit version "VERSION"  (build %d  %s)\n"
};


int main (int argc, char **argv) {
  int i;
  char *val;
//  char *InFile;
  TFormMain *self;
  TMenuItem *mi;
  bool help = False;
  bool err = False;


//	InFile = NULL;
	i = 1;
	while (!err && (i<argc)) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		switch (*val) {
		case 'h':
		    help = True;
		    break;
		case '-':
		    val++;
		    if (pcncmp(val, "help", 4)) {
			help = True;
		    } else err = True;
		    break;
		default: 
		    err = True;
		}
	    } else {
//		InFile = val;
		err = True;
	    }
	    i++;
	}

//	err = err || !InFile;
	if (help || err) {
	    printf(Help_Msg, build_v, build_date);
	    exit(err);
	}

	initXapp(0, argc, argv);
	self = TForm_CreatParamAlg(NULL, sizeof(TFormMain));
	IappDat.obj = self;
/* Menu File */
	self->PanelTop = TWins_CreateBA((TWins*)self, 0, 0, 200, 21, mBorder | mBorderL, alTop);
	self->mbFile = TMenuButton_Create(self->PanelTop, (TMenuButton*)self);
	self->mbFile->top = 2;
	self->mbFile->left = 1;
	SetCaption((TWins*)self->mbFile, "File");
	Set_Parent((TWins*)self->mbFile, self->PanelTop);

	self->menuFile = TMenu_Create((TWins*)self);
	self->mbFile->menu = self->menuFile;
	self->menuFile->OnMenuOpen = mFile_OnMenuOpen;
	TMenu_AddItem(self->menuFile, "Exit", 0, mExit_OnClick);

/* Menu Edit */
	self->mbEdit = TMenuButton_Create(self->PanelTop, self->mbFile);
	SetCaption((TWins*)self->mbEdit, "Edit");
	Set_Parent((TWins*)self->mbEdit, self->PanelTop);

/* Menu Help */
	self->mbHelp = TMenuButton_Create(self->PanelTop, self->mbFile);
	SetCaption((TWins*)self->mbHelp, "Help");
	Set_Parent((TWins*)self->mbHelp, self->PanelTop);

	self->menuHelp = TMenu_Create((TWins*)self);
	self->mbHelp->menu = self->menuHelp;
	mi = TMenu_AddItem(self->menuHelp, "Info", 0, mHelp_Info);
	mi->pic = GetZIcon(zico16info);


	AppRun();
	return 0;
}
